<?php
	// $Id: generate_sitemap.php 314 2015-03-31 04:39:25Z robert0609 $
	// Copyright BRAEWORKS (R) 2015
	// CLI generate sitemap

error_reporting(E_ALL | E_STRICT);

define('CLI_MODE', true);	// tell configure not to crash

require_once 'includes/configure.php';
require_once LM_FS_INCLUDES_DIR . 'auto_class_loader.php';

echo 'Starting -> sitemap generator for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.' . "\n";
Clm::$cDB->logEvent('CLI: Starting -> sitemap generator for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.');

if((!defined('INI_XML_SITEMAP_FILE')) ||
	(strlen(INI_XML_SITEMAP_FILE) < 2)) {
	Clm::addMsg ('Sitemap name not set.');
	} // if
else if((defined('LMC_WEB_SITE_ADDRESS')) &&
	(strlen(LMC_WEB_SITE_ADDRESS) > 8) &&
	(Clm::has_dns_record(LMC_WEB_SITE_ADDRESS))) {
	new Clm_xml_sitemap();
	} // if
else Clm::addMsg ('Main Web Site URL not set or no DNS record found.');

$msgs = Clm::getMsgs();
$msgs = preg_replace('/\<br\>|\<br\/\>|\<\/p\>|\<\/tr\>/i', "\n",  strip_tags($msgs));
$msgs = preg_replace('/&nbsp;/i', '', $msgs);
echo $msgs;

echo 'Finished -> sitemap generator for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.' . "\n";
Clm::$cDB->logEvent('CLI: Finished -> sitemap generator for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.');

exit(0);

// eof
