<?php
	// $Id: app_page_body.php 367 2016-04-18 17:02:10Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

?>

<?php Clm::page_start_comment(__FILE__); ?>
<?php

function output_noscript_warning() {
	echo '	<noscript><span class="msg_warning">We have detected that your browser\'s JavaScript seems to be disabled.<br>You need JavaScript enabled and functional in your browser to utilize the functionality of this website.</span></noscript>';
	} // output_noscript_warning()

function output_link_or_tool_text($url) {
	echo '<div id="'. (Clm::$left_column ? 'link_frame_wlc':'link_frame_nolc') . '" class="' . ((Clm::$tablet_flg) ? 'link_frame_tablet':'link_frame_moz') . '">' . "\n";
	output_noscript_warning();
	echo '<iframe frameborder="0" src="' . $url . '" class="' . ((Clm::$tablet_flg) ? 'iframe_tablet':'iframe_moz') . '" id="lm_frame" onload="javascript:onloadIframe(this);">' . "\n";
	echo '<p>Your browser does not support iframes. <a href="' . $url . '">Click to show</a></p>' . "\n";
	echo '</iframe>' . "\n";
	echo '</div>' . "\n";
	if(isset($_SESSION['action'])) unset($_SESSION['action']);
	} // output_link_or_tool_text()

function output_include_body_text($inc_file,$more_globals_ary = '') {
	global $action; // globals scoped in includes, keep this to a minimum, keeps the crap down
	if(!empty($more_globals_ary)) {
		foreach($more_globals_ary as $g) {
			global $$g;
			} // foreach
		} // if
	echo '<div id="'. (Clm::$left_column ? 'page_body_wlc':'page_body_nolc') . '">' . "\n";
	output_noscript_warning();
	include "includes/app_msgs.php";
	if(is_readable($inc_file)) include($inc_file);
	else {
		Clm::addMsg('Missing file: "' . $inc_file . '"');
		Clm::$cDB->logEvent('ERROR: Missing file: "' . $inc_file . '"');
		} // else
	include "includes/app_msgs.php";
	echo '</div>' . "\n";
	if(isset($_SESSION['action'])) unset($_SESSION['action']);
	} // output_include_body_text()

switch($action) {
case 'link':
case 'tool':
	break;
case 'update_sitemap':
	// if(Clm::is_admin_user()) {
		new Clm_xml_sitemap();
	//	} // if
	$action = 'home';
	break;
default:
	break;
	} // switch

switch($action) {
case 'login':
	output_include_body_text("pages/login.php",array('user_name'));
	break;
case 'get_password':
	output_include_body_text("pages/get_password.php",array('user_name'));
	break;
case 'edit_tools':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_tools.php");
		break;
		} // if
case 'edit_sections':
	if(Clm::is_group_manager(-1)) {
		output_include_body_text("pages/edit_sections.php");
		break;
		} // if
case 'edit_links':
	if(Clm::is_group_manager(-1)) {
		output_include_body_text("pages/edit_links.php");
		break;
		} // if
case 'edit_groups':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_groups.php");
		break;
		} // if
case 'edit_users':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_users.php");
		break;
		} // if
case 'edit_search':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_search.php");
		break;
		} // if
case 'edit_config':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_config.php");
		break;
		} // if
case 'edit_install':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_install.php");
		break;
		} // if
case 'edit_theme':
	if(Clm::is_admin_user()) {
		output_include_body_text("pages/edit_theme.php");
		break;
		} // if
case 'link':
	if((isset($_GET['link_id'])) && ((int)$_GET['link_id'] > 0) &&
		($url = Clm::$cDB->get_data_in_table('lm_links','lm_link_url','lm_link_id = ' . (int)$_GET['link_id']))) {
		output_link_or_tool_text($url);
		} // if
	else output_include_body_text("pages/default.php");
	break;
case 'tool':
	if((isset($_GET['tool_id'])) && ((int)$_GET['tool_id'] > 0) &&
		($url = Clm::$cDB->get_data_in_table('lm_tools','lm_tool_url','lm_tool_id = ' . (int)$_GET['tool_id']))) {
		output_link_or_tool_text(LM_LOCAL_TOOLS_FOLDER . $url);
		} // if
	else output_include_body_text("pages/default.php");
	break;
case 'disclaimer':
	if(strlen(LMC_DISCLAIMER_LINK) <= 4) {
		output_include_body_text("pages/disclaimer.tmpl.php");
		}
	else output_link_or_tool_text(LMC_DISCLAIMER_LINK);
	break;
case 'home':
	// fall thru to default
default:
	output_include_body_text("pages/default.php");
	break;
case 'about_lm':
	output_include_body_text("pages/about_lm.php");
	break;
case 'lm_manual':
	output_include_body_text("pages/lm_manual.php");
	break;
case 'log_view':
	output_include_body_text("pages/log_view.php");
	break;
	} // switch
if(isset($_SESSION['action'])) unset($_SESSION['action']);

Clm::page_end_comment(__FILE__);
