<?php

/*
  $Id: auto_class_loader.php 213 2015-03-25 08:09:10Z robert0609 $
 *
 * Copyright (c) 2013 BRAEWORKS (R)
 *
 * class autoloader implementation
 * 
 * the autoloader removed many circular includes and requires from the code
 * with the overall result that it runs faster and uses a lot less memory (typically half)
 * 
 */

// function __autoload($class) {
//     include 'classes/' . $class . '.class.php';
// }

function lm_auto_class_loader($class) {
	
	$class_file = preg_replace('/^C/','', $class) . '.php';
	
	// classes
	if(file_exists(LM_FS_CLASSES_DIR . $class_file)) {
		include LM_FS_CLASSES_DIR . $class_file;
		return;
		} // if
	
	// special clases
	// @TODO rename the files of these classes
	switch($class) {
	default:
		break;
		} // switch
		
	$msg = 'ERROR: Unknown autoloader class: ' . $class . '';
	if((!defined('INI_DEBUG_BOOL')) || 
		(INI_DEBUG_BOOL)) echo $msg . "\n";
	if((!defined('INI_DB_DIE_ON_ERRORS_BOOL')) ||
		(INI_DB_DIE_ON_ERRORS_BOOL)) {
		 echo $msg . "\n";
		die();
		} // if
	Clm::$cDB->logEvent($msg);
	return;
	
} // lm_auto_class_loader()

// hook in global autoloader
spl_autoload_register('lm_auto_class_loader');

// the always defined classes
require_once(LM_FS_CLASSES_DIR . 'logger.php');

// set global classes
$cLM = new Clm();

