/*
	$Id: block_styles.css.php 229 2015-04-07 06:25:47Z robert0609 $
	Document   : main_styles
    Description:
        Purpose of the stylesheet follows.
		Block styles, keep the header and footer at top and bottom of the browser window.
		<?php echo $gen_note; ?>

	Syntax recommendation http://www.w3.org/TR/REC-CSS2/
*/


/* container contents positioning */
#container {
	position:	absolute;
	top:		0px;
	left:		0px;
	right:		0px;
	bottom:		0px;
	overflow:	hidden;
	}

#header {
	position:	absolute;
	top:		0px;
	left:		0px;
	right:		0px;
	padding:	0px;
	margin:		0px;
	height:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;   /* Height of the header */
	overflow:	visible;	/* visible for drop downs from page header */
	}

#left_column {
	position:	absolute;
	top:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;
	left:		0px;
	width:		<?php echo $theme['ThemeSettings']['LEFT_WIDTH']; ?>;
	overflow-y: auto;
	overflow-x: hidden;
	padding:	0px;
	margin:		0px;
	z-index:	805;
	overflow:	visible;
	}

#page_body_wlc {	/* with left column */
	position:	absolute;
	top:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;
	left:		<?php echo $theme['ThemeSettings']['LEFT_WIDTH']; ?>;
	right:		0px;
	padding:	0px;
	margin:		0px;
	bottom:		<?php echo $theme['ThemeSettings']['FOOTER_HEIGHT']; ?>;
	overflow:	auto;
	}

#link_frame_wlc {	/* with left column */
	position:	absolute;
	top:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;
	left:		<?php echo $theme['ThemeSettings']['LEFT_WIDTH']; ?>;
	right:		0px;
	padding:	0px;
	bottom:		<?php echo $theme['ThemeSettings']['FOOTER_HEIGHT']; ?>;
	}

#page_body_nolc {	/* with left no column */
	position:	absolute;
	top:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;
	left:		0px;
	right:		0px;
	padding:	0px;
	margin:		0px;
	bottom:		<?php echo $theme['ThemeSettings']['FOOTER_HEIGHT']; ?>;
	overflow:	auto;
	}

#link_frame_nolc {	/* with left no column */
	position:	absolute;
	top:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;
	left:		0px;
	right:		0px;
	padding:	0px;
	bottom:		<?php echo $theme['ThemeSettings']['FOOTER_HEIGHT']; ?>;
	}

#footer {
	position:	absolute;
	height:		<?php echo $theme['ThemeSettings']['FOOTER_HEIGHT']; ?>;
	left:		0px;
	right:		0px;
	bottom:		0px;
	overflow:	hidden;
	}

.link_frame_moz {
	}

.link_frame_tablet {
	overflow:	auto;
	-webkit-overflow-scrolling: touch;
	}

.iframe_tablet {
	width:		100%;
	min-height:	100%;
	border-width: 0;
	}

.iframe_moz {
	width:		100%;
	min-height:	100%;
	border-width: 0;
	}

/* eof */

