<?php

/**
 * $Id: lm_filter.php 139 2015-03-04 12:03:22Z robert0609 $
 *
 *  * Description of lm_filter
 *	* static class to provide text filter in user data
 *
 * @author robert0609
 */
class Clm_filter extends Clm_general {

	protected static $filter_keywords = false;
//	protected static $sect_sql_filter = '';
//	protected static $link_sql_filter = '';

	protected static $linkkeys = array('lm_link_name','lm_link_title','lm_link_description');	// ,'lm_link_url','lm_link_image_url'
	protected static $sectkeys = array('lm_section_name', 'lm_section_description', 'lm_section_title');	// ,'lm_section_image_url'

	protected static $layout_ids = false;

			function __construct() {
		parent::__construct();
		} // __construct()

	function __destruct() {
		parent::__destruct();
		} // __destruct()

// static methods
	public static function help() {
		$text = "Enter text keywords, seperated by spaces, to find and filter Sections, Links, Titles, Desciptions and Names.";
		$text .= '\n' . (LMC_FILTER_ANDED ? 'Must have all keywords.':'Can have any keyword.');
		return $text;
		} // help()

	protected static function is_filtering() {
		if(!LMC_FILTER_OUTPUT) return false;
		if(self::$filter_keywords) return true;
		if((isset($_POST['filter'])) &&
			(isset($_POST['keywords'])) &&
			(!empty($_POST['keywords']))) {
			self::$filter_keywords = $_POST['keywords'];
			return true;
			} // if
		if((isset($_GET['filter'])) &&
			(!empty($_GET['filter']))) {
			self::$filter_keywords = $_GET['filter'];
			return true;
			} // if
		return false;
		} // is_filtering()

	protected static function check_ored_keywords($data,$keys) {
		$words = explode(' ',self::$filter_keywords);
		$txt = '';
		foreach($keys as $k) {
			if(!isset($data[$k])) continue;
			$txt .= ' ' . $data[$k];	// make a long str
			} // foreach
		foreach($words as $w) {
			if(preg_match('/' . $w . '/i', $txt)) return true;
			} // foreach
		return false;
		} // check_ored_keywords()

	protected static function check_anded_keywords($data,$keys) {
		$words = explode(' ',self::$filter_keywords);
		$txt = '';
		foreach($keys as $k) {
			if(!isset($data[$k])) continue;
			$txt .= ' ' . $data[$k];	// make a long str
			} // foreach
		$found = true;
		foreach($words as $w) {
			if(!preg_match('/' . $w . '/i', $txt)) $found = false;
			} // foreach
		return $found;
		} // check_anded_keywords()

	protected static function check_keywords($data,$keys) {
		if(!self::is_filtering()) return true;	// allow every thing
		if(LMC_FILTER_ANDED) return self::check_anded_keywords ($data, $keys);
		return self::check_ored_keywords($data, $keys);
		} // check_keywords()

	protected static function check_section_keywords($section) {
		$keys = self::$sectkeys;
		return self::check_keywords($section,$keys);
		} // check_section_keywords();

	protected static function check_link_keywords($link) {
		$keys = self::$linkkeys;
		return self::check_keywords($link,$keys);
		} // check_link_keywords()

	public static function find_sections_links_layout() {
		if(self::$layout_ids) return self::$layout_ids;
		self::$layout_ids = array();
		$sql_section_query = "SELECT lm_section_id, lm_section_name, lm_section_columns" .
			", lm_section_title,lm_section_description,lm_section_group_ids" .
			", lm_section_image_url" .
			" FROM  lm_sections" .
			" WHERE  lm_section_enabled > 0" .
			" ORDER BY lm_section_order,lm_section_id;";
		if($result_section = Clm::$cDB->db_query_unbuffered($sql_section_query)) {
			while($section = Clm::$cDB->db_fetch_array_unbuffered($result_section)) {
				if(!Clm::check_user_group_ids($section['lm_section_group_ids']))	continue;
				$section_found = self::check_section_keywords($section);
				if($section_found) self::$layout_ids[($section['lm_section_id'])]['data'] = $section;
				$sql_link_query = "SELECT" .
					" lm_link_id,lm_link_name,lm_link_title,lm_link_description" .
					", lm_link_url, lm_link_image_url, lm_link_new_page, lm_link_ssl, lm_link_add_name2url" .
					" FROM  lm_links" .
					" WHERE  lm_link_enabled > 0 AND  lm_link_section_id = " . (int)$section['lm_section_id'] .
					" ORDER BY lm_link_order;";
				if($result_link = Clm::$cDB->db_query_unbuffered($sql_link_query)) {
					while($link = Clm::$cDB->db_fetch_array_unbuffered($result_link)) {
						if($section_found) self::$layout_ids[($section['lm_section_id'])][($link['lm_link_id'])]['data'] = $link;	// put all links if section matches
						else {
							if(self::check_link_keywords($link)) {
								if(!isset(self::$layout_ids[($section['lm_section_id'])]['data'])) self::$layout_ids[($section['lm_section_id'])]['data'] = $section; // time saver
								self::$layout_ids[($section['lm_section_id'])][($link['lm_link_id'])]['data'] = $link;	// put in if link matches
								} // if
							} // else
						} // while
					} // if
				} // while
			}//if
		 return self::$layout_ids;
		} // find_sections_links_layout()

//	protected static function get_keywords_sql($cols) {
//		if(!self::is_filtering()) return '';
//		$sql = '';
//		$words = explode(' ',self::$filter_keywords);
//		foreach($cols as $c) {
//			foreach($words as $w) {
//				$sql .= ' OR ' . $c . " LIKE '%" . $w . "%'";
//				} // foreach
//			} // foreach
//		if(!empty($sql)) return ' AND (' . substr($sql,4) . ')';
//		return '';
//		} // get_keywords_sql()
//
//	public static function get_section_keywords_sql() {
//		$cols = self::$sectkeys;
//		return self::get_keywords_sql($cols);
//		} // get_section_keywords_sql();
//
//	public static function get_link_keywords_sql() {
//		$cols = self::$linkkeys;
//		return self::get_keywords_sql($cols);
//		} // get_link_keywords_sql()

} // Clm_filter
