<?php

/**
 * $Id: lm_general.php 419 2016-10-18 12:30:56Z robert0609 $
 *
 * Description of lm_general
 * general base class for links_manager functions
 *
 * @author robert0609
 */

class Clm_general extends Cmsgs {

	//put your code here
	public static $cDB = false;
	public static $tablet_flg = false;
	public static $tiny_flg = false;
	public static $tooltips_flg = true;
	public static $block_html = false;
	public static $moz_4_flg = false;
	public static $chrome_flg = false;
	public static $browser_html5 = true;
	public static $ssl_required = false;
	public static $page_info = false;
	public static $left_column = true;
	public static $admin_tools_in_header = false;

	protected static $head_output_flg = false;
	protected static $tools = false;
	protected static $tools_cnt = false;
	protected static $client_ip = false;

	function __construct() {
		parent::__construct();
		if(!$this->make_head_values()) {
			self::addMsg('Failed to make head values.');
			} // if
		} // __construct()

	function __destruct() {
		parent::__destruct();
		} // __destruct()

// dynamic methods

	protected function define_install_settings() {

		$settings = self::read_ini_settings();

		// define installed settingss
		foreach($settings as $skey => $sect) {
			foreach($sect as $key => $val) {
				if($skey == 'ThemeSettings') {
					switch($key) {
					case 'HEADER_HEIGHT':
					case 'LEFT_COLUMN_BOOL':
					case 'LEFT_WIDTH':
					case 'FOOTER_HEIGHT':
						break;	// needed
					default:
						continue;	// dont define 'ThemeSettings' not used at runtime
						} // switch
					} // if
				switch(strtolower($val)) {
				case 'comment': break;	// only to help edit settings web page
				case '0':	// that what false becomes
				case 'false':
				//case 'inline':
					define('INI_' . $key,false);
					break;
				case '1':	// thats what true becomes
				case 'true':
				//case 'block':
					define('INI_' . $key,true);
					break;
				default:
					define('INI_' . $key,$val);
					break;
					} // switch
				} // foreach
			} // foreach
		return $settings;
		} // define_install_settings()

	private function get_page_title($action, $delimiter = ' - ') { // set page title, a bit of basic SEO
		$title = LMC_TITLE;
		switch($action) {
		case 'link':
			if((isset($_GET['link_id'])) && ((int)$_GET['link_id'] > 0) &&
				($name = self::$cDB->get_data_in_table('lm_links','lm_link_name','lm_link_id = ' . (int)$_GET['link_id'])) &&
				(!empty($name))) {
				$title .= $delimiter . $name;
				} // if
			break;
		case 'tool':
			if((isset($_GET['tool_id'])) && ((int)$_GET['tool_id'] > 0) &&
				($name = self::$cDB->get_data_in_table('lm_tools','lm_tool_name','lm_tool_id = ' . (int)$_GET['tool_id'])) &&
				(!empty($name))) {
				$title .= $delimiter . $name;
				} // if
			break;
		case 'login':
			$title .= $delimiter . 'Login';
			break;
		case 'get_password':
			$title .= $delimiter . 'First Time Login';
			break;
		case 'edit_tools':
			$title .= $delimiter . 'Edit Tools';
			break;
		case 'edit_sections':
			$title .= $delimiter . 'Edit Sections';
			break;
		case 'edit_links':
			$title .= $delimiter . 'Edit Links';
			break;
		case 'edit_groups':
			$title .= $delimiter . 'Edit Groups';
			break;
		case 'edit_users':
			$title .= $delimiter . 'Edit Users';
			break;
		case 'edit_search':
			$title .= $delimiter . 'Admin Search';
			break;
		case 'edit_install':
			$title .= $delimiter . 'Edit Installation';
			break;
		case 'edit_config':
			$title .= $delimiter . 'Edit Config';
			break;
		case 'about_lm':
			$title .= $delimiter . 'About ' . LM_PROJECT_SHORTNAME;
			break;
		case 'lm_manual':
			$title .= $delimiter . LM_PROJECT_SHORTNAME . ' User Manual';
			break;
		case 'home':
		default:
			break;
		} // switch
		return $title;
		} // get_page_title()

	private function is_ssl_required() {
		global $action;
		if((defined('CLI_MODE')) && (CLI_MODE)) self::$ssl_required = false;
		else if(!self::$page_info['login_allowed']) self::$ssl_required = false;
		else if((Clm::is_user_logged_in()) ||
			(INI_BLIND_LOGIN_BOOL) ||
			(INI_ALWAYS_LOGIN_BOOL)) self::$ssl_required = true;
		else if((isset($_SERVER['PHP_SELF'])) &&
			(preg_match('/login|logout/i',$_SERVER['PHP_SELF'])) &&
			(self::$page_info['login_allowed']))  self::$ssl_required = true;
		else if(!empty($action)) {
			if((preg_match('/login|logout|edit.*/', $action)) &&
				(self::$page_info['login_allowed'])) return true;
			switch($action) {
			case 'tool':
				if((isset($_GET['tool_id'])) &&
					((int)$_GET['tool_id'] > 0) &&
					(self::$cDB->get_data_in_table('lm_tools','lm_tool_ssl','lm_tool_id = ' . (int)$_GET['tool_id'])))
					self::$ssl_required = true;
				break;
			case 'link':
				if((isset($_GET['link_id'])) &&
					((int)$_GET['link_id'] > 0) &&
					(self::$cDB->get_data_in_table('lm_links','lm_link_ssl','lm_link_id = ' . (int)$_GET['link_id'])))
					self::$ssl_required = true;
				break;
			default:
				break;
				} // switch
			} // if
		return self::$ssl_required;
		} // is_ssl_required()

	private function get_base_ref() {
		global $action;
		$base_ref = '';
		if((isset($_SERVER['HTTPS'])) &&
			($_SERVER['HTTPS'] == 'on')) {
			// running on SSL
			if($this->is_ssl_required()) {	// ok
				$base_ref = LM_SSL_URL;
				} // if
			else { // redirect to non SSL
				$url = LM_WWW_URL;
				if(!empty($action)) $url .= 'index.php?action=' . $action;
				else {
					$uri = str_replace('/' . LM_WS_DIR, '', $_SERVER['PHP_SELF']);
					if(!empty($uri)) {
						if(!empty($SERVER['QUERY_STRING'])) $uri .= '?' . $SERVER['QUERY_STRING'];
						$url .= $uri;
						} // if
					} // else
				header('Location: ' . $url);
				exit(0);
				} // else
			} // if
		else {
			// running on an open port
			if($this->is_ssl_required()) {	// change to SSL
				$url = LM_SSL_URL;
				if(!empty($action)) $url .= 'index.php?action=' . $action;
				else {
					$uri = str_replace('/' . LM_WS_DIR, '', $_SERVER['PHP_SELF']);
					if(!empty($uri)) {
						if(!empty($SERVER['QUERY_STRING'])) $uri .= '?' . $SERVER['QUERY_STRING'];
						$url .= $uri;
						} // if
					} // else
				header('Location: ' . $url);
				exit(0);
				} // if
			else { // ok
				$base_ref = LM_WWW_URL;
				} // else
			} // else
		return $base_ref;
		} // get_base_ref()

	protected function get_user_agent() {
		if((isset($_SERVER['HTTP_USER_AGENT'])) &&
			(isset($_SERVER['HTTP_USER_AGENT']))) {
			return $_SERVER['HTTP_USER_AGENT'];
			} // if
		return 'agent_unknown';
		} // get_user_agent()

	protected function is_mobile_device($useragent = '') {
		// the preg_match patterns come from "http://detectmobilebrowsers.com/", too specific miss the commen common
		if(empty($useragent)) $useragent = $this->get_user_agent();
		if(preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i', $useragent)) {
			return true;
			} // if
		if(preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i', substr($useragent, 0, 4))) {
			return true;
			} // if

		// look for safari ?
		// eg Mozilla/5.0 (iPad; CPU OS 6_1_3 like Mac OS X) AppleWebKit/536.26 (KHTML, like Gecko) Version/6.0 Mobile/10B329 Safari/8536.25
		if(preg_match('/.*(iPad|iPod|iPhone).*/i', $useragent)) {
			return true;
			} // if
		return false;
		} // is_mobile_device()

	protected function is_tiny_device($useragent = '') {
		if(preg_match('/.*(iPad).*/i', $useragent)) {
			return false;
			} // if

		// the preg_match patterns come from "http://detectmobilebrowsers.com/", too specific miss the commen common
		if(empty($useragent)) $useragent = $this->get_user_agent();
		if(preg_match('/.+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|vodafone|wap|windows (ce|phone)|xda|xiino/i', $useragent)) {
			return true;
			} // if

		if(preg_match('/.*(iPod|iPhone).*/i', $useragent)) {
			return true;
			} // if

		return false;
		} // is_tiny_device()

	protected function show_title_tooltips() {
		if(!LMC_USE_TITLE_TOOLTIPS) return false;
		if(!self::is_hover_boxes_ok()) return false;
		if((self::$chrome_flg) && (self::$block_html)) return false;
		if(self::$tiny_flg) return false;
		return true;
		} // show_title_tooltips()

	protected function make_head_values() {
		global $action;
		if(!empty(self::$page_info)) return true;	// already done
		self::$page_info = array(
			'action' => $action,
			);

		self::$page_info['login_allowed'] = $this->check_login_allowed();
		self::$page_info['closed'] = $this->is_web_site_closed($action);
		self::$page_info['redirect_url'] = $this->is_web_site_redirected($action);
		self::$page_info['title'] = self::get_page_title($action);
		self::$page_info['meta_keywords'] = LMC_META_KEYWORDS;
		self::$page_info['meta_description'] = LMC_META_DESCRIPTION;
		self::$page_info['header_title'] = LMC_TITLE . ((strlen(LMC_SITE_STATUS) > 0) ? ' ' . LMC_SITE_STATUS:'') . (INI_WEBSITE_CLOSED_BOOL ? ' (Closed)':'');

//		switch($action) {
//		case 'home':
//		default:
//			break;
//		} // switch

		self::$page_info['base_ref'] = $this->get_base_ref();

		return true;
		} // make_head_values()

	private function is_ip_local_subnet($ip) {
		$local_subnets = array('127.0.0.1','172.16.','192.88.99.','192.168.', '10.', '::1' );
		foreach($local_subnets as $n) {
			if(substr($ip,0,strlen($n)) == $n) {
				return true;	// not public
				} // if
			} //foreach
		return false;
		} // is_ip_local_subnet()

	private function get_client_ip_address_via_public_proxy() {
		// see http://en.wikipedia.org/wiki/X-Forwarded-For

		global $_SERVER;
		$ip = null;
		if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else if(getenv('HTTP_X_FORWARDED_FOR')) {
			$ip = getenv('HTTP_X_FORWARDED_FOR');
		} // else if

		if(empty($ip)) return null;	// no proxy used

		$ip_array = explode(',',$ip);
		$ip = $ip_array[0];

		// filter out local subnets
		if(!self::is_ip_local_subnet($ip)) return null;	// not public
		return $ip;
		} // get_client_ip_address_via_public_proxy()

	private function get_client_ip_address() {
		global $_SERVER;
		if(self::$client_ip !== false) return self::$client_ip;

		if((self::$client_ip = self::get_client_ip_address_via_public_proxy())) return self::$client_ip;

		if (isset($_SERVER)) {
			if (isset($_SERVER['HTTP_CLIENT_IP'])) {
				self::$client_ip = $_SERVER['HTTP_CLIENT_IP'];
			} else if(isset($_SERVER['REMOTE_ADDR'])) {
				self::$client_ip = $_SERVER['REMOTE_ADDR'];
			}
		} else {
			if (getenv('HTTP_CLIENT_IP')) {
				self::$client_ip = getenv('HTTP_CLIENT_IP');
				}
			elseif(getenv('REMOTE_ADDR')) {
				self::$client_ip = getenv('REMOTE_ADDR');
				}
		} // else

		if((!self::$client_ip) && (isset($_SERVER['REMOTE_ADDR']))) self::$client_ip = $_SERVER['REMOTE_ADDR'];	// as a last resort

		return self::$client_ip;
		} // get_client_ip_address()

	private function ipCIDRCheck($IP, $CIDR) { // from "http://php.net/manual/en/ref.network.php" after the maths was sorted
		$nips = explode('/',$CIDR);
		$net = $nips[0];

		if(!isset($nips[1])) $ip_mask = -1;
		else $ip_mask = ~((1 << (32 - $nips[1])) - 1);

		$ip_net = ip2long ($net);

		$ip_ip = ip2long ($IP);

		$ip_ip_net = $ip_ip & $ip_mask;

		return ($ip_ip_net == $ip_net);
		} // ipCIDRCheck()

	protected function check_login_allowed($log_flg = true) {
		if((defined('CLI_MODE')) && (CLI_MODE)) return true;
		if((!defined('INI_ALLOWED_LOGIN_IPS')) ||
			(strlen(INI_ALLOWED_LOGIN_IPS) < 4)) return true;	// always ok

		$client_ip = self::get_client_ip_address();
		$country = '';
		$allowed = explode(',',INI_ALLOWED_LOGIN_IPS);
		foreach($allowed as $allow) {
			if(preg_match('/^[a-z]*$/i',$allow)) {	// country name
				if(!function_exists('geoip_country_name_by_name')) {
					if($log_flg) self::$cDB->logEvent('WARNING: PECL geoip >= 2.0 not found.');
					return false;
					} // if
				else if(!self::is_ip_local_subnet ($client_ip)) {
					$country = @geoip_country_name_by_name($client_ip);
					if((!empty($country)) &&
						(preg_match('/' . $allow . '/i',$country))) return true;	// its ok
					} // else if
				} // if
			else if(preg_match ('/^[0-9\.\/]*$/', $allow)) {	// ip address
				if(self::ipCIDRCheck($client_ip,$allow)) return true;	// its OK
				} // else
			} // foreach
		if($log_flg) self::$cDB->logEvent('WARNING: Failed login attempt from ' . $client_ip . (!empty($country) ? '(' . $country . ')':'') . ', IP not allowed.');
		return false;
		} // check_login_allowed()

	protected function is_web_site_closed($action) {
		if((defined('CLI_MODE')) && (CLI_MODE)) return false;
		if(!defined('INI_WEBSITE_CLOSED_BOOL')) return false;
		if(!INI_WEBSITE_CLOSED_BOOL) return false;
		if(Clm::is_admin_user()) return false;

		// if the admin is trying to login, allow it
		if(!self::$page_info['login_allowed']) return true;	// login not allowed, so its closed
		if(preg_match('/login|logout/i',$_SERVER['PHP_SELF'])) return false;	// open for login, etc
		if(preg_match('/login|logout|edit_install/', $action)) return false;	// open for login, etc
		return true;	// closed
		} // is_web_site_closed()

	protected function is_web_site_redirected($action) {
		if((defined('CLI_MODE')) && (CLI_MODE)) return '';
		if(!defined('INI_REDIRECT_WEBSITE_BOOL')) return '';
		if(!INI_REDIRECT_WEBSITE_BOOL) return '';
		if(Clm::is_admin_user()) return '';
		if(!self::has_dns_record($url)) return '';

		// if the admin is trying to login, allow it
		if(!self::$page_info['login_allowed']) return $url;	// login not allowed, so its closed
		if(preg_match('/login|logout/i',$_SERVER['PHP_SELF'])) return '';	// open for login, etc
		if(preg_match('/login|logout|edit_install/', $action)) return '';	// open for login, etc
		return $url;	// redirected
		} // is_web_site_redirected()

// static methods

	public static function has_dns_record($url, $types = array('A','AAAA','CNAME')) {
		$url_chk = parse_url($url);
		if(strlen($url_chk['host']) < 6) return false;
		if(is_array($types)) foreach($types as $t) {
			if(checkdnsrr($url_chk['host'],$t)) return true;
			} // foreach
		if(is_array($types)) foreach($types as $t) if(checkdnsrr($url_chk['host'],$t)) return true;
		else if(checkdnsrr($url_chk['host'],$types)) return true;
		return false;
		} // has_dns_record()

	public static function get_header_bar_title($action, $delimiter = ' - ') { // set page title, a bit of basic SEO
		$title = self::$page_info['header_title'];
		switch($action) {
		case 'link':
			if((isset($_GET['link_id'])) && ((int)$_GET['link_id'] > 0) &&
				($name = self::$cDB->get_data_in_table('lm_links','lm_link_title','lm_link_id = ' . (int)$_GET['link_id'])) &&
				(!empty($name))) {
				$title .= $delimiter . $name;
				} // if
			break;
		case 'tool':
			if((isset($_GET['tool_id'])) && ((int)$_GET['tool_id'] > 0) &&
				($name = self::$cDB->get_data_in_table('lm_tools','lm_tool_title','lm_tool_id = ' . (int)$_GET['tool_id'])) &&
				(!empty($name))) {
				$title .= $delimiter . $name;
				} // if
			break;
		case 'login':
		case 'edit_tools':
		case 'edit_sections':
		case 'edit_links':
		case 'edit_groups':
		case 'edit_users':
		case 'edit_search':
		case 'edit_install':
		case 'edit_config':
		case 'about_lm':
		case 'home':
		default:
			break;
		} // switch
		return $title;
		} // get_header_bar_title()

	public static function output_head() {
		global $action;
		if(self::$head_output_flg) return false;
		echo '	<head>' . "\n" .
			'		<meta charset="' . INI_CHAR_SET . '">' . "\n" .
			'		<title>' . self::$page_info['title'] . '</title>' . "\n" .
			'		<base href="' . self::$page_info['base_ref'] . '">' . "\n" .
			'		<META NAME="GENERATOR" CONTENT="'. LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '">' . "\n";

		if(strlen(LMC_META_COPYRIGHT) > 4)
			echo '		<meta name="owner" content="' . LMC_META_COPYRIGHT . '">' . "\n";
		if(strlen(LMC_META_COPYRIGHT) > 4)
			echo '		<meta name="copyright" content="' . LMC_META_COPYRIGHT . '">' . "\n";
		if(strlen(LMC_META_AUTHOR) > 4)
			echo '		<meta name="author" content="' . LMC_META_AUTHOR . '">' . "\n";
		if(!empty(self::$page_info['meta_keywords']))
			echo '		<meta name="keywords" content="' . self::$page_info['meta_keywords'] . '">' . "\n";

		if(!empty(self::$page_info['meta_description']))
			echo '		<meta name="description" content="' . self::$page_info['meta_description'] . '">' . "\n";
		if(!INI_ALLOW_ROBOTS_BOOL)
			echo '		<meta name="robots" content="nofollow">' . "\n";

		if(self::$tablet_flg) {
			echo '		<meta name="viewport" content="initial-scale = 1.0, user-scalable = no">' . "\n";
			echo '		<meta name="apple-mobile-web-app-capable" content="yes">' . "\n";
			} // if

		if(!INI_ENABLE_CACHING_BOOL) {
			echo '		<meta HTTP-EQUIV="Pragma" CONTENT="no-cache">' . "\n";
			echo '		<meta HTTP-EQUIV="Expires" CONTENT="-1">' . "\n";
			} // if

		if(is_readable(LM_FS_BASE_DIR . '/favicon.ico')) {
			echo '		<link rel="icon" type="image/png" href="favicon.ico" />' . "\n";
			} // if

		echo '		<link rel="stylesheet" type="text/css" href="main_styles.css">' . "\n";
		echo '		<link rel="stylesheet" type="text/css" href="' . (self::$block_html ? 'block_styles.css':'inline_styles.css') . '">' . "\n";
		echo '		<script type="text/javascript" src="lm_funcs.js"></script>' . "\n";
		echo '		<script type="text/javascript" src="client_visit_cntr.js"></script>' . "\n";

		if(Clm::$tooltips_flg) {
			echo '		<script type="text/javascript" src="title_tooltips.js"></script>' . "\n";
			} // if

		echo '	</head>' . "\n";

		self::$head_output_flg = true;
		return true;
		} // output_head()

	public static function do_lm_warnings($chk_flg = false) {
		if((!$chk_flg) && (!INI_INSTALLATION_WARNINGS_BOOL)) return true;

		$files_rw_check_list = array(	// read/write paths
			LM_FS_SQLITE_DIR,	// for INI_DB_SQLITE_DATABASE,
			LM_FS_SQLITE_DIR . INI_DB_SQLITE_DATABASE,
			LM_FS_BASE_DIR . 'main_styles.css',
			LM_FS_BASE_DIR . 'block_styles.css',
			LM_FS_BASE_DIR . 'inline_styles.css',
			LM_FS_BASE_DIR . 'images/upload',
			LM_FS_VARIABLES_DIR,
			LM_FS_TRASH_DIR,
			LM_FS_CONFIG,
			LM_LOGS_DIR,
			LM_LOG_FILE,
			FILE_ERROR_LOG,
			LM_FS_EXPORT_DIR,
			LM_FS_IMPORT_DIR,
			);
		$files_r_check_list = array(	// read paths
			LM_FS_BASE_DIR . LM_LOCAL_TOOLS_FOLDER,
		);
		$ok = true;
		if($chk_flg) self::addMsg('Installation check.','info');
		foreach($files_rw_check_list as $f) {
			if(is_dir($f)) {
				if(!is_writable($f)) {
					self::addMsg('Directory . "' . $f . '" is Not writeable (1).');
					$ok = false;
					} // if
				} // if
			else if(is_dir(dirname($f))) {
				if(!is_writable(dirname($f))) {
					self::addMsg('Directory . "' . dirname($f) . '" is Not writeable (2).');
					$ok = false;
					} // if
				} // if
			else if((is_readable($f)) && (!is_writeable($f))) {
				self::addMsg('File . "' . $f . '" is Not writeable (3).');
				$ok = false;
				} // if
			} // foreach
		foreach($files_r_check_list as $f) {
			if(!is_readable($f)) {
				self::addMsg($f . ' is Not readable (1).');
				$ok = false;
				} // if
			} // foreach

		if($chk_flg) {
			$func_class_chk_list = array(
				array(
					'funct' => 'geoip_country_name_by_name',
					'needs' => 'PECL geoip >= 2.0',
					),
				array(
					'func' =>'posix_getgrgid',
					'needs' => 'php-posix or php-process',
					),
				array(
					'func' => 'posix_getpwuid',
					'needs' => 'php-posix or php-process',
					),
				array(
					'class' => 'SQLite3',
					'needs' => 'SQLite 3',
					),
				);
			foreach($func_class_chk_list as $f) {
				if((isset($f['func'])) &&
					(!function_exists($f['func']))) {
					self::addMsg('System Function: ' . $f['func'] . '() not installed. Needs ' . $f['needs'] . ' to be installed.');
					$ok = false;
					} // if
				if((isset($f['class'])) &&
					(!class_exists($f['class']))) {
					self::addMsg('System Class: ' . $f['class'] . ' not installed. Needs ' . $f['needs'] . ' to be installed.');
					$ok = false;
					} // if
				} // foreach
			} // if

		if((!$chk_flg) && ($ok)) self::getMsgs();	// no error clear it
		if($chk_flg) {
//			if(is_writable(LM_FS_INCLUDES_DIR . 'configure.php')) {
//				self::addMsg('includes/configure.php is writeable.','warning');
//				$ok = false;
//				} // if
			if($ok) self::addMsg ('No install issues detected.','info');
			} // if
		return $ok;
	} // do_lm_warnings()

	public static function array_trimCallback(&$str,$key) { $str = trim($str); } // array_trimCallback()
	public static function array_trim(&$array) { return array_walk_recursive($array,'self::array_trimCallback'); } // array_trim()

	protected static function get_ini_value($sect,$key) {	// get from the ini file directly
		// $sect not used as all keys are different
		if(!is_readable(LM_FS_CONFIG)) return null;
		$v = preg_grep('/' . $key . '/',file(LM_FS_CONFIG));
		if((!$v) || (empty($v)) || (count($v) != 1)) return null;
		$value = preg_replace('/.*"(.*?)".*/', '$1', trim(array_pop($v)));
		if(!$value) return null;	// error
		if(is_numeric($value)) return $value;
		switch(strtolower($value)) {
		case 'false': return false;
		case 'true': return true;
		default: break;
			} // switch
		return $value;
		} // get_ini_value()

	protected static function get_config_value($key) {	// get from the DB directly
		$value = self::$cDB->get_data_in_table('lm_configs','lm_config_value',"lm_config_key = '" . $key . "'");
		if(!$value) return null;	// error
		if(is_numeric($value)) return $value;
		switch(strtolower($value)) {
		case 'false': return false;
		case 'true': return true;
		default: break;
			} // switch
		return $value;
		} // get_config_value()

	public static function build_css_stylesheets($theme = '') {
		global $left_column;
		$left_column = self::get_ini_value('ThemeSettings','LEFT_COLUMN_BOOL');

		if((empty($theme)) ||
			(!isset($theme['ThemeSettings'])) ||
			(!is_array($theme['ThemeSettings']))) {
			$theme = self::read_ini_settings(false,array('CommonSettings','DataBaseAccess'));
			} // if
		$css_files = array(
			'main_styles',
			'block_styles',
			'inline_styles',
			);
		$ok = true;
		foreach ($css_files as $css) {
			$gen_note = 'CSS filename generated from ' . $css . '.css.php on ' . date('Y-m-d h:M:s') . "\n";
			ob_start();
			include(LM_FS_INCLUDES_DIR . $css . '.css.php');
			$text = ob_get_clean();
			$out = LM_FS_BASE_DIR . '' . $css . '.css';
			if((!empty($text)) &&
				($fh = fopen($out, 'w'))) {
				fwrite($fh, $text);
				fclose($fh);
				if(strlen(INI_GROUP_PERMISSIONS)) chgrp($out,INI_GROUP_PERMISSIONS);
				@chmod($out,0664);
				self::addMsg('Update ' . $css . '.css','success');
				} // if
			else {
				$ok = false;
				self::addMsg('Failed to update ' . $css . '.css');
				} // else
			} // foreach
		return $ok;
		} // build_css_stylesheets()

	public static function read_ini_settings($verbose = true, $exclude_sects = '') {	// and sub defaults
		if(!is_readable(LM_FS_CONFIG)) $settings = false;
		else $settings = parse_ini_file(LM_FS_CONFIG,true);
		if(!is_readable(LM_FS_CONFIG_DEFAULT)) $settings_default = false;
		else $settings_default = parse_ini_file(LM_FS_CONFIG_DEFAULT,true);

		if(((empty($settings) || !is_array($settings)) &&
			((empty($settings_default)) || !is_array($settings_default)))) {
			echo "ERROR: Failed to read settings " . basename(LM_FS_CONFIG) . ' and default ' . basename(LM_FS_CONFIG_DEFAULT) . "." . LM_NL;
			exit(100);
			} // if
		if(((empty($settings) || !is_array($settings)) &&
			(!empty($settings_default)) && is_array($settings_default))) {
			$settings = $settings_default;
			if($verbose) self::addMsg("Using default settings " . basename(LM_FS_CONFIG_DEFAULT) . ".",'warning');
			} // if
		else if(((empty($settings_default) || !is_array($settings_default)) &&
			(!empty($settings)) && is_array($settings))) {
			$settings_default = $settings;
			if($verbose) self::addMsg("No default settings " . basename(LM_FS_CONFIG_DEFAULT) . ". (Copy " . basename(LM_FS_CONFIG) . " to " . basename(LM_FS_CONFIG_DEFAULT)  . " as a safe guard.)",'warning');
			} // if
		$defaults = 0;
		foreach($settings as $skey => $sect) {
			if((is_array($exclude_sects)) && (in_array($skey, $exclude_sects))) {
				unset($settings[$skey]);
				continue;
				} // if
			foreach($sect as $key => $val) {
				if((empty($val)) && (!is_numeric($val)) &&
					(!empty($settings_default[$skey][$key]))) {	// do safeguard
					$val = $settings_default[$skey][$key];
					$settings[$skey][$key] = $val;
					$defaults++;
					} // if
				} // foreach
			} // foreach

		if(($verbose) && ($defaults)) {
			self::addMsg("Using " . $defaults . " default values from " . basename(LM_FS_CONFIG_DEFAULT) . ".",'warning');
			} // if
		return $settings;
	} // read_ini_settings()

	public static function save_ini_settings(&$new_settings) {
		$old_settings = self::read_ini_settings();
		foreach($old_settings as $skey => $section) {
			// put in missings sections
			if(!isset($new_settings[$skey])) {
				$new_settings[$skey] = $section;
				} // if
			} // foreach

		$hc =	'; Copyright ' . 	LMC_CO_NAME . ' ' . date('Y') . "\n" .
				'; Contains non database ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . ' settings.' . "\n";

		$fh = fopen(LM_FS_CONFIG,'w');
		if(!$fh) {
			self::$cDB->logEvent('ERROR: Failed to open "' . LM_FS_CONFIG . '" for save.');
			self::addMsg('Failed to open "' . basename(LM_FS_CONFIG) . '" for save.');
			return false;
			} // if
		else {
			if(!fwrite($fh, $hc)) {
				self::$cDB->logEvent('ERROR: Failed to save comments in "' . basename(LM_FS_CONFIG) . '".');
				self::addMsg('Failed to save comments in "' . basename(LM_FS_CONFIG) . '".');
				} // if
			else {
				$ini_cntl = self::read_ini_comments();	// get control file
				$settings_default = parse_ini_file(LM_FS_CONFIG_DEFAULT,true);
				foreach($ini_cntl as $sect_name => $section) {
					fwrite($fh,'[' . $sect_name . ']' . "\n");
					foreach($section as $key => $value_comment) {
						if($key == 'comment') continue;
						if(!isset($new_settings[$sect_name][$key])) $new_value = '';
						else $new_value = $new_settings[$sect_name][$key];
						if((empty($new_value)) && (!is_numeric($new_value)) &&
							(!empty($settings_default[$sect_name][$key]))) {
							$new_value = $settings_default[$sect_name][$key];
							$new_settings[$sect_name][$key] = $new_value;
							self::addMsg('Restore default; ' . self::unmake_hungarion_fmt($sect_name) . ', ' . self::make_nice_name($key) .' = "' . $new_value . '".','info');
							} // if
						if($sect_name != 'ThemeSettings') {
							if($new_value == '0') $new_value = 'false';
							if($new_value == '1') $new_value = 'true';
							} // if
						fwrite($fh,$key . ' = "' . html_entity_decode($new_value . '"' . "\n"));
						} // foreach
					fwrite($fh,"\n");
					} // foreach
				fwrite($fh,'; eof' . "\n");
				fclose($fh);
				self::$cDB->logEvent('INFO: Saved in "' . basename(LM_FS_CONFIG) . '".');
				self::addMsg('Saved settings in "' . basename(LM_FS_CONFIG) . '".','success');
				} // else
			} // else
		return true;
	} // save_ini_settings()

	public static function read_ini_comments($verbose = true, $exclude_sects = '') {	// and sub defaults
		$comments = parse_ini_file(LM_FS_CONFIG_MSGS,true);

		if(((empty($comments) || !is_array($comments)) &&
			((empty($comments_default)) || !is_array($comments_default)))) {
			echo "ERROR: Failed to read comments INI controls " . basename(LM_FS_CONFIG_MSGS) . "." . LM_NL;
			exit(100);
			} // if
		foreach($comments as $skey => $sect) {
			if((is_array($exclude_sects)) && (in_array($skey, $exclude_sects))) {
				unset($comments[$skey]);
				continue;
				} // if
			} // foreach
		return $comments;
	} // read_ini_comments()

	public static function make_nice_name($ini_key, $delim = '_', $substitutes = null) {	// turns "MAGE_IMPORT_CHANGED_ONLY_BOOL_BOOL" into "Mage Continue Import"
		if(is_array($substitutes)) $subs = $substitutes;
		else {
			$subs = array(
				'DB' => 'DB',	// keep same
				'WS' => 'WS',	// keep same
				'BOOL' => '',	// remove type at end of $ini_key
				'TZ' => '', // remove type at end of $ini_key
				);
			} // else
		$name = '';
		$words = explode($delim,$ini_key);
		self::array_trim($words);
		foreach($words as $word) {
			if(!empty($name)) $name .= ' ';
			if(isset($subs[$word])) $name .= $subs[$word];
			else $name .= ucwords(strtolower($word));	// make proper noun
			} // foreach
		return trim($name);
	} // make_nice_name()

	public static function unmake_hungarion_fmt($str) {
		$text = '';
		$idx = 0; $spFlg = true; $c_l = '';
		while($idx < strlen($str)) {
			$c = substr($str,$idx++,1);
			if(strlen($text) > 0) {
				if($c == '_' || $c == '-') {
					if(!$spFlg || $c_l != ' ') {	// only one space
						$text .= ' ';
						$spFlg = true;
						} // if
					$c_l = ' ';
					continue; // dont add $c
					} // if
				else if($c >= 'A' && $c <= 'Z' && ($c_l < 'A' || $c_l > 'Z')) {
					if(!$spFlg) {	// only one space
						$text .= ' ';
						$spFlg = true;
						} // if
					// add $c
					} // if
				else $spFlg = false;
				} // if
			$c_l = $c;
			$text .= $c;
			} // while
		return $text;
	} // unmake_hungarion_fmt()

	public static function check_user_group_ids($group_ids) {
		if(strlen($group_ids) == 0) return false;
		$op_group_ids = explode(':',$group_ids);
		if(in_array(0,$op_group_ids)) return true;	// all groups
		if(!isset($_SESSION['user']['group_ids'])) return false;
		// else logged
		$user_group_ids = explode(':',$_SESSION['user']['group_ids']);
		if(in_array(0,$user_group_ids)) return true;
		foreach($user_group_ids as $uid) {
			if(in_array($uid,$op_group_ids)) return true;
			} // foreach
		return false;
	} // check_user_group_ids()

	public static function is_group_name_inuse($lm_group_name, $exclude_name = '') {
		$sql_query = "SELECT lm_group_name FROM lm_groups WHERE lm_group_name = '" . self::$cDB->db_input($lm_group_name) . "'";
		if(!empty($exclude_name)) $sql_query .= " and lm_group_name != '" . $exclude_name . "'";
		if(!$result = self::$cDB->db_query($sql_query)) return false;
		$rows = self::$cDB->db_num_rows($result);
		self::$cDB->db_free_result($result);
		if((int)$rows > 0) return true;
		return false;
		} // is_group_name_inuse()

	public static function is_user_name_inuse($lm_user_name, $exclude_name = '') {
		$sql_query = "SELECT lm_user_name FROM lm_users WHERE lm_user_name = '" . self::$cDB->db_input($lm_user_name) . "'";
		if(!empty($exclude_name)) $sql_query .= " and lm_user_name != '" . $exclude_name . "'";
		if(!$result = self::$cDB->db_query($sql_query)) return false;
		$rows = self::$cDB->db_num_rows($result);
		self::$cDB->db_free_result($result);
		if((int)$rows > 0) return true;
		return false;
		} // is_user_name_inuse()

	public static function is_link_name_inuse($lm_link_name, $exclude_name = '') {
		$sql_query = "SELECT lm_link_name FROM lm_links WHERE lm_link_name = '" . self::$cDB->db_input($lm_link_name) . "'";
		if(!empty($exclude_name)) $sql_query .= " and lm_link_name != '" . $exclude_name . "'";
		if(!$result = self::$cDB->db_query($sql_query)) return false;
		$rows = self::$cDB->db_num_rows($result);
		self::$cDB->db_free_result($result);
		if((int)$rows > 0) return true;
		return false;
		} // is_link_name_inuse()

	public static function is_section_name_inuse($lm_section_name, $exclude_name = '') {
		$sql_query = "SELECT lm_section_name FROM lm_sections WHERE lm_section_name = '" . self::$cDB->db_input($lm_section_name) . "'";
		if(!empty($exclude_name)) $sql_query .= " and lm_section_name != '" . $exclude_name . "'";
		if(!$result = self::$cDB->db_query($sql_query)) return false;
		$rows = self::$cDB->db_num_rows($result);
		self::$cDB->db_free_result($result);
		if((int)$rows > 0) return true;
		return false;
		} // is_section_name_inuse()

	public static function is_tool_name_inuse($lm_tool_name, $exclude_name = '') {
		$sql_query = "SELECT lm_tool_name FROM lm_tools WHERE lm_tool_name = '" . self::$cDB->db_input($lm_tool_name) . "'";
		if(!empty($exclude_name)) $sql_query .= " and lm_tool_name != '" . $exclude_name . "'";
		if(!$result = self::$cDB->db_query($sql_query)) return false;
		$rows = self::$cDB->db_num_rows($result);
		self::$cDB->db_free_result($result);
		if((int)$rows > 0) return true;
		return false;
		} // is_tool_name_inuse()

	public static function is_browser_html5() {
		return self::$browser_html5;
		} // is_browser_html5()

	public static function get_time_zones() {
		$timezones = timezone_identifiers_list();
//		if(!in_array('Australia/Canberra', $timezones)) {
//			reset($timezones);
//			$timezones[] = 'Australia/Canberra'; // they forgot !!!!!
//			} // if
		sort($timezones);
		return $timezones;
		} // get_time_zones()

	public static function get_language_codes() {
		$languages = array(
			'en',
			'en_AU',
			'en_CA',
			'en_GB',
			'en_NZ',
			'en_US',
			);
		return $languages;
		} // get_language_codes()

	public static function get_charsets() {
		$languages = array(
			'ASCII',
			'ANSI',
			'ISO-8859-1',
			'UTF-8',
			);
		return $languages;
		} // get_charsets()

	public static function get_group_ids_text($lm_group_ids,$only_enabled = true) {
		$ids = explode(':',$lm_group_ids);
		$text = '';
		foreach($ids as $id) {
			if(!empty($text)) $text .= ',';
			if((int)$id == 0) $text .= 'All Groups';
			else {
				$name = self::$cDB->get_data_in_table('lm_groups','lm_group_name','lm_group_id = ' . $id . ($only_enabled ? ' lm_group_enabled > 0':''));
				if(!$only_enabled) {
					$text .= '<a href="index.php?action=edit_groups&group_edit_id=' . $id . '">' . $name . '</a>';
					} // if
				else $text .= $name;
				if((!$only_enabled) &&
					(!self::$cDB->get_data_in_table('lm_groups','lm_group_enabled','lm_group_id = ' . $id))) {
					$text .= ' (disabled)';
					} // if
				} // else
			} // foreach
		return $text;
		} // get_group_ids_text()

	public static function get_group_user_ids_text($cms_group_user_ids,$only_enabled = true) {
		$ids = explode(':',$cms_group_user_ids);
		$text = '';
		foreach($ids as $id) {
			if(!empty($text)) $text .= ',';
			if((int)$id == 0) $text .= 'All users';
			else {
				$name = self::$cDB->get_data_in_table('cms_users','cms_user_name','cms_user_id = ' . $id . ($only_enabled ? ' cms_user_enabled > 0':''));
				if(!$only_enabled) {
					$text .= '<a href="index.php?action=edit_user&user_edit_id=' . $id . '">' . $name . '</a>';
					} // if
				else $text .= $name;
				if((!$only_enabled) &&
					(!self::$cDB->get_data_in_table('cms_users','cms_user_enabled','cms_user_id = ' . $id))) {
					$text .= ' (disabled)';
					} // if
				} // else
			} // foreach
		return $text;
		} // get_group_user_ids_text()

	public static function get_group_manager_ids_text($lm_group_manager_ids,$only_enabled = true) {
		$ids = explode(':',$lm_group_manager_ids);
		$text = '';
		foreach($ids as $id) {
			if(!empty($text)) $text .= ',';
			if((int)$id == 0) $text .= 'No Manager';
			else {
				$name = self::$cDB->get_data_in_table('lm_users','lm_user_name','lm_user_id = ' . $id . ($only_enabled ? ' lm_user_enabled > 0':''));
				if(!$only_enabled) {
					$text .= '<a href="index.php?action=edit_user&user_edit_id=' . $id . '">' . $name . '</a>';
					} // if
				else $text .= $name;
				if((!$only_enabled) &&
					(!self::$cDB->get_data_in_table('lm_users','lm_user_enabled','lm_user_id = ' . $id))) {
					$text .= ' (disabled)';
					} // if
				} // else
			} // foreach
		return $text;
		} // get_group_manager_ids_text()

	public static function reset_xml_stitemap() {
		if(strlen(INI_XML_SITEMAP_FILE) < 2) return false;
		$xml_file = LM_FS_BASE_DIR . INI_XML_SITEMAP_FILE . '.xml';
		if(is_readable($xml_file)) {
			unlink($xml_file);
			self::addMsg('Sitemap deleted.','info');
			self::$cDB->logEvent('INFO: Deleted sitemap "' . basename($xml_file) . '".');
			} // if
		return true;
		} // save_xml_stitemap()

	public static function get_code_errors() {	// get errors that are not normally displyed in debug
		if(!INI_DEBUG_BOOL) return '';

		$text = '';
		if(($prerr = preg_last_error()) != PREG_NO_ERROR) {	// regex error
			static $errtext;
			if (!isset($errtxt)) {
				$errtext = array();
				$constants = get_defined_constants(true);
				foreach ($constants['pcre'] as $c => $n) if (preg_match('/_ERROR$/', $c)) $errtext[$n] = $c;
				} // if
			$text .= array_key_exists($errcode, $errtext)? $errtext[$errcode] : '';
			} // if
		if(!empty($text)) self::addMsg($text);
		return $text;
		} // get_code_errors()

	public static function is_hover_boxes_ok() {
		//if(self::$tablet_flg) return false;
		if(self::$moz_4_flg) return false;
		return true;
		} // is_hover_boxes_ok()

} // Clm_general
