<?php

/**
 * $Id: lm_html.php 409 2016-10-10 13:01:58Z robert0609 $
 *
 * Description of lm_html
 * static html class for Link Manager
 *
 * @author robert0609
 */

class Clm_html extends Clm_general {

	//put your code here
	private static $std_colours = array(
			'AliceBlue' => '#F0F8FF',
			'AntiqueWhite' => '#FAEBD7',
			'Aqua' => '#00FFFF',
			'Aquamarine' => '#7FFFD4',
			'Azure' => '#F0FFFF',
			'Beige' => '#F5F5DC',
			'Bisque' => '#FFE4C4',
			'Black' => '#000000',
			'BlanchedAlmond' => '#FFEBCD',
			'Blue' => '#0000FF',
			'BlueViolet' => '#8A2BE2',
			'Brown' => '#A52A2A',
			'BurlyWood' => '#DEB887',
			'CadetBlue' => '#5F9EA0',
			'Chartreuse' => '#7FFF00',
			'Chocolate' => '#D2691E',
			'Coral' => '#FF7F50',
			'CornflowerBlue' => '#6495ED',
			'Cornsilk' => '#FFF8DC',
			'Crimson' => '#DC143C',
			'Cyan' => '#00FFFF',
			'DarkBlue' => '#00008B',
			'DarkCyan' => '#008B8B',
			'DarkGoldenRod' => '#B8860B',
			'DarkGray' => '#A9A9A9',
			'DarkGreen' => '#006400',
			'DarkKhaki' => '#BDB76B',
			'DarkMagenta' => '#8B008B',
			'DarkOliveGreen' => '#556B2F',
			'Darkorange' => '#FF8C00',
			'DarkOrchid' => '#9932CC',
			'DarkRed' => '#8B0000',
			'DarkSalmon' => '#E9967A',
			'DarkSeaGreen' => '#8FBC8F',
			'DarkSlateBlue' => '#483D8B',
			'DarkSlateGray' => '#2F4F4F',
			'DarkTurquoise' => '#00CED1',
			'DarkViolet' => '#9400D3',
			'DeepPink' => '#FF1493',
			'DeepSkyBlue' => '#00BFFF',
			'DimGray' => '#696969',
			'DimGrey' => '#696969',
			'DodgerBlue' => '#1E90FF',
			'FireBrick' => '#B22222',
			'FloralWhite' => '#FFFAF0',
			'ForestGreen' => '#228B22',
			'Fuchsia' => '#FF00FF',
			'Gainsboro' => '#DCDCDC',
			'GhostWhite' => '#F8F8FF',
			'Gold' => '#FFD700',
			'GoldenRod' => '#DAA520',
			'Gray' => '#808080',
			'Green' => '#008000',
			'GreenYellow' => '#ADFF2F',
			'HoneyDew' => '#F0FFF0',
			'HotPink' => '#FF69B4',
			'IndianRed' => '#CD5C5C',
			'Indigo' => '#4B0082',
			'Ivory' => '#FFFFF0',
			'Khaki' => '#F0E68C',
			'Lavender' => '#E6E6FA',
			'LavenderBlush' => '#FFF0F5',
			'LawnGreen' => '#7CFC00',
			'LemonChiffon' => '#FFFACD',
			'LightBlue' => '#ADD8E6',
			'LightCoral' => '#F08080',
			'LightCyan' => '#E0FFFF',
			'LightGoldenRodYellow' => '#FAFAD2',
			'LightGray' => '#D3D3D3',
			'LightGreen' => '#90EE90',
			'LightPink' => '#FFB6C1',
			'LightSalmon' => '#FFA07A',
			'LightSeaGreen' => '#20B2AA',
			'LightSkyBlue' => '#87CEFA',
			'LightSlateGray' => '#778899',
			'LightSteelBlue' => '#B0C4DE',
			'LightYellow' => '#FFFFE0',
			'Lime' => '#00FF00',
			'LimeGreen' => '#32CD32',
			'Linen' => '#FAF0E6',
			'Magenta' => '#FF00FF',
			'Maroon' => '#800000',
			'MediumAquaMarine' => '#66CDAA',
			'MediumBlue' => '#0000CD',
			'MediumOrchid' => '#BA55D3',
			'MediumPurple' => '#9370DB',
			'MediumSeaGreen' => '#3CB371',
			'MediumSlateBlue' => '#7B68EE',
			'MediumSpringGreen' => '#00FA9A',
			'MediumTurquoise' => '#48D1CC',
			'MediumVioletRed' => '#C71585',
			'MidnightBlue' => '#191970',
			'MintCream' => '#F5FFFA',
			'MistyRose' => '#FFE4E1',
			'Moccasin' => '#FFE4B5',
			'NavajoWhite' => '#FFDEAD',
			'Navy' => '#000080',
			'OldLace' => '#FDF5E6',
			'Olive' => '#808000',
			'OliveDrab' => '#6B8E23',
			'Orange' => '#FFA500',
			'OrangeRed' => '#FF4500',
			'Orchid' => '#DA70D6',
			'PaleGoldenRod' => '#EEE8AA',
			'PaleGreen' => '#98FB98',
			'PaleTurquoise' => '#AFEEEE',
			'PaleVioletRed' => '#DB7093',
			'PapayaWhip' => '#FFEFD5',
			'PeachPuff' => '#FFDAB9',
			'Peru' => '#CD853F',
			'Pink' => '#FFC0CB',
			'Plum' => '#DDA0DD',
			'PowderBlue' => '#B0E0E6',
			'Purple' => '#800080',
			'Red' => '#FF0000',
			'RosyBrown' => '#BC8F8F',
			'RoyalBlue' => '#4169E1',
			'SaddleBrown' => '#8B4513',
			'Salmon' => '#FA8072',
			'SandyBrown' => '#F4A460',
			'SeaGreen' => '#2E8B57',
			'SeaShell' => '#FFF5EE',
			'Sienna' => '#A0522D',
			'Silver' => '#C0C0C0',
			'SkyBlue' => '#87CEEB',
			'SlateBlue' => '#6A5ACD',
			'SlateGray' => '#708090',
			'Snow' => '#FFFAFA',
			'SpringGreen' => '#00FF7F',
			'SteelBlue' => '#4682B4',
			'Tan' => '#D2B48C',
			'Teal' => '#008080',
			'Thistle' => '#D8BFD8',
			'Tomato' => '#FF6347',
			'Turquoise' => '#40E0D0',
			'Violet' => '#EE82EE',
			'Wheat' => '#F5DEB3',
			'White' => '#FFFFFF',
			'WhiteSmoke' => '#F5F5F5',
			'Yellow' => '#FFFF00',
			'YellowGreen' => '#9ACD32',
			);
	private static $lc_std_colours = false;	// lowercase, searchable version and cache it
	private static $contrast_text_colours = false;	// cache it
	private static $image_lists = false;	// cache it

	private static $font_families = array(
		"inherit",
		"'Courier New', Courier, monospace",
		"Verdana, Arial, Helvetica, sans-serif",
		"Verdana, Geneva, sans-serif",
		"helvetica, Arial, sans-serif",
		"'Lucida Grande', Helvetica, Arial",
		"Arial, Helvetica, sans-serif",
		"'Times New Roman', Times, serif",
		"Techno, Impact, sans-serif",
		"Helvetica, Arial",
		"'Trebuchet MS', sans-serif",
		"Terminal, monospace",
		"VT-100, monospace",
		"Textile, cursive",
		"Arial Black",
		"Impact",
		"sans-serif",
		);

	private static $font_styles = array(
		'inherit',
		'normal',
		'italic',
		'oblique',
		);

	private static $font_weights = array(
		'inherit',
		'normal',
		'bold',
		'bolder',
		'lighter',
		'100',
		'200',
		'300',
		'400',
		'500',
		'600',
		'700',
		'800',
		'900',
		);

	function __construct() {
		parent::__construct();
		} // __construct()

	function __destruct() {
		parent::__destruct();
		} // __destruct()

// static methods
	public static function blank_page($msg = '', $echo = true, $frm_reset = true) {	// blank the browser window, with optional msg
		$text = array();
		$text[] = '<!DOCTYPE html>';
		$text[] = '<html dir="ltr" lang="' . INI_LANGUAGE_CODE . '">';
		$text[] = '	<head>';
		$text[] = '		<title>' . LMC_TITLE . '</title>';
		$text[] = '		<META NAME="GENERATOR" CONTENT="'. LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '">';
		$text[] = '		<meta name="robots" content="nofollow">';
		$text[] = '		<meta HTTP-EQUIV="Pragma" CONTENT="no-cache">';
		$text[] = '		<meta HTTP-EQUIV="Expires" CONTENT="-1">';
		$text[] = '	</head>';
		$text[] = '	<body>';
		if($frm_reset) {
			$text[] = '	<script type="text/javascript">';
			$text[] = '		document.form.reset();';
			$text[] = '	</script>';
			$text[] = '	<noscript></noscript>';
			} // if
		if(!empty($msg)) $text[] = $msg;
		else $text[] = '&nbsp;';
		$text[] = '	</body>';
		$text[] = '</html>';
		$txt = implode("\n",$text);
		if($echo) echo $txt;
		return $txt;
		} // blank_page()

	public static function gen_group_selection_list($name, $lm_group_ids = 0, $size_max = '', $params = '') {
		if(!is_array($lm_group_ids)) $lm_group_ids = explode(':', $lm_group_ids);
		$sql_query = "SELECT" .
			" lm_group_id,lm_group_name,lm_group_enabled,lm_group_admin" .
			" FROM lm_groups ORDER BY lm_group_name";
		$cnt = 0;
		$options = array();
		if(($result = self::$cDB->db_query($sql_query)) &&
			(($cnt = self::$cDB->db_num_rows($result)) > 0)) {
//			$options[] = array(
//					'value' => -1,
//					'selected' => false,
//					'text' => ' - Select Group/s - ',
//					);
			$options[] = array(
					'value' => 0,
					'selected' => (in_array(0,$lm_group_ids) ? true:false),
					'text' => 'All Groups (default)',
					);
			while($row = self::$cDB->db_fetch_array($result)) {
				$options[] = array(
					'value' => $row['lm_group_id'],
					'selected' => (in_array((int)$row['lm_group_id'],$lm_group_ids) ? true:false),
					'text' => $row['lm_group_name'] . ' (' . ($row['lm_group_enabled'] == true ? 'enabled':'disabled') . ($row['lm_group_admin'] == 1 ? ', admin':'') . ')',
					);
				} // while
			} // if
		else $options[] = array(
					'value' => 0,
					'selected' => true,
					'text' => '<span class="msg_warning">(No groups setup)</span>',
					);
		self::$cDB->db_free_result($result);
		if(empty($size_max)) $size_max = 6;
		if(count($options) < $size_max) $size_max = count($options);
		return self::gen_selection_list($name, $options, 'size="' . $size_max . '" ' . $params);
	} // gen_group_selection_list()

	public static function gen_group_manager_selection_list($name, $lm_group_manager_ids = 0, $size_max = '', $params = '') {
		if(!is_array($lm_group_manager_ids)) $lm_group_manager_ids = explode(':', $lm_group_manager_ids);
		$sql_query = "SELECT" .
			" lm_user_id,lm_user_name,lm_user_enabled" .
			" FROM lm_users ORDER BY lm_user_name";
		$cnt = 0;
		$options = array();
		if(($result = self::$cDB->db_query($sql_query)) &&
			(($cnt = self::$cDB->db_num_rows($result)) > 0)) {
//			$options[] = array(
//					'value' => -1,
//					'selected' => false,
//					'text' => ' - Select Manager/s - ',
//					);
			while($row = self::$cDB->db_fetch_array($result)) {
				$options[] = array(
					'value' => $row['lm_user_id'],
					'selected' => (in_array((int)$row['lm_user_id'],$lm_group_manager_ids) ? true:false),
					'text' => $row['lm_user_name'] . ' (' . ($row['lm_user_enabled'] == true ? 'enabled':'disabled') . ')',
					);
				} // while
			} // if
		else $options[] = array(
					'value' => 0,
					'selected' => true,
					'text' => '<span class="msg_warning">(No users setup)</span>',
					);
		self::$cDB->db_free_result($result);
		if(empty($size_max)) $size_max = 6;
		if(count($options) < $size_max) $size_max = count($options);
		return self::gen_selection_list($name, $options, 'size="' . $size_max . '" ' . $params);
	} // gen_group_manager_selection_list()

	public static function page_start_comment($file) {	// outputs a stx marker for the php file
		if(!INI_DEBUG_BOOL) return;
		$file = basename($file);
		echo "\n" . '<!-- '. $file . ' stx -->' . "\n\n";
	} // page_start_comment()

	public static function page_end_comment($file) {	// outputs a etx marker for the php file
		if(!INI_DEBUG_BOOL) return;
		$file = basename($file);
		echo "\n" . '<!-- '. $file . ' etx -->' . "\n\n";
	} // page_end_comment()

	private static function make_text_colours() {
		if(empty(self::$contrast_text_colours)) { // work out text colours and cache them
			self::$contrast_text_colours = array();
			self::$lc_std_colours = array();
			if((defined('LMC_CUSTOM_COLOURS')) && (strlen(LMC_CUSTOM_COLOURS) > 6)) {
				$cc = explode(':', LMC_CUSTOM_COLOURS);
				foreach($cc as $c) {
					$c = preg_split('/=#/', $c);
					if((!isset($c[0])) || (!isset($c[1]))) continue;	// bad entry
					$n = strtolower(trim($c[0]));
					$v = '#' . trim($c[1]);
					self::$lc_std_colours[$n] = $v;
					} // foreach
				} // if
			foreach (self::$std_colours as $n => $v) {
				self::$lc_std_colours[strtolower($n)] = $v;
				} // foreach
			foreach (self::$lc_std_colours as $n => $v) {
				$h = substr($v,1);
				$h = hexdec($h);
				$i = (($h >> 16) & 0xff) + (($h >> 8) & 0xff) + ($h & 0xff);	// intenity
				if($i > (3 * 96)) $c = 'black';	// contrast !!
				else $c = 'white';
				self::$contrast_text_colours[$n] = $c;
				self::$contrast_text_colours[strtolower($n)] = $c;
				} // foreach
			} // if
		} // make_text_colours()

	protected static function make_colour_select_options($value) {
		self::make_text_colours();

		$value = strtolower($value);
		$text = '<option value="">  (Use Default) </option>' . "\n";	// special case
		$text .= '<option value="inherit"' . (($value == 'inherit') ? ' SELECTED' : '') . '>&nbsp;inherit' . (($value == 'inherit') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
		foreach (self::$lc_std_colours as $n => $v) {
			$c = self::$contrast_text_colours[$n];

			// put it together
			$text .= '<option value="' . htmlentities($v) . '"' . ((($value == strtolower($n)) || ($value == strtolower($v))) ? ' SELECTED' : '');
			$text .= ' style="background-color: ' . $v . '; color: ' . $c . ';">';
			if(($value == strtolower($n)) || ($value == strtolower($v))) $text .= '&nbsp;' . $n . ' **';
			else $text .= '&nbsp;' . $n . '&nbsp;';
			$text .= '</option>' . "\n";
			} // foreach
		return $text;
	} // make_colour_select_options()

	protected static function make_image_list($path = '') {
		if(empty($path)) $path = 'images/';
		$idx = str_replace('/','_', $path);	// make nice index
		if(!isset(self::$image_lists[$idx])) {	// cache it
			self::$image_lists[$idx] = array();
			if(!is_dir(LM_FS_BASE_DIR . $path)) return self::$image_lists[$idx];
			if($dh = opendir(LM_FS_BASE_DIR . $path)) {
				while (($file = readdir($dh)) !== false) {
					if(preg_match('/\.png|\.jpg|\.jpeg|\.gif/',$file)) self::$image_lists[$idx][] = $file;
					} // while
				} // if
			} // if
		return self::$image_lists[$idx];
	} // make_image_list()

	protected static function make_image_select_options($path,$value) {
		$img_list = self::make_image_list($path);

		$text = '<option value="-1"' . (($value == '') ? ' SELECTED' : '') . '>&nbsp;(No Image)' . (($value == '') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
		// $text .= '<option value="inherit"' . (($value == 'inherit') ? ' SELECTED' : '') . '>&nbsp;inherit' . (($value == 'inherit') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
		foreach ($img_list as $img) {
			// put it together
			$text .= '<option value="' . htmlentities($img) . '"' . (($value == $img) ? ' SELECTED' : '') . '>';
			if($value == $img) $text .= '&nbsp;' . $img . ' **';
			else $text .= '&nbsp;' . $img . '&nbsp;';
			$text .= '</option>' . "\n";
			} // foreach
		return $text;
	} // make_image_select_options()

	public static function make_uploaded_image_select_options($value) {
		$path = 'images/upload/';
		if(!is_dir(LM_FS_BASE_DIR . $path)) mkdir(LM_FS_BASE_DIR . $path, 0660);
		return self::make_image_select_options($path,$value);
	} // make_uploaded_image_select_options()

	public static function make_bkgnd_image_select_options($value) {
		$path = 'images/backgrounds/';
		if(!is_dir(LM_FS_BASE_DIR . $path)) mkdir(LM_FS_BASE_DIR . $path, 0660);
		return self::make_image_select_options($path,$value);
	} // make_bkgnd_image_select_options()

	public static function add_svalues_options($svalues,$value) {
		$text = '';
		foreach($svalues as $sv) {
			if((!empty($sv)) || (is_numeric($sv))) {
				$svt = preg_replace('/\n|\r/i', ' ',  strip_tags($sv));
				$text .=  "\n" . '<option value="' . $svt . '"' . (($value == $sv) ? ' SELECTED':'') . '>' . $svt . '</option>';
				} // if
			} // foreach
		return $text;
	} // add_svalues_options()

//	private static function add_svalues_options($svalues,$value) {
//		$text = '';
//		foreach($svalues as $sv) {
//			$text .= '<option value="' . $sv . '"' . (($value == $sv) ? ' SELECTED':'') . '>' . $sv . '</option>';
//			} // foreach
//		return $text;
//	} // add_svalues_options()

	 public static function make_type_input($name,$ini_key,$value,$size = 30) {
		$text = "\n";

		if(substr($ini_key,-11) == 'FONT_FAMILY') {	// multiple box for font family
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value=""' . (empty($ff) ? ' SELECTED':'') . '> -- default -- </option>';
			//$text .= '<option value="inherit"' . (($value == 'inherit') ? ' SELECTED' : '') . '>&nbsp;inherit' . (($value == 'inherit') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
			foreach(self::$font_families as $ff) {
				$text .= '<option value="' . rawurldecode($ff) . '"' . ((strtolower($value) == strtolower($ff)) ? ' SELECTED':'') . '>' . $ff. ((strtolower($value) == strtolower($ff)) ? ' **':'') . '</option>';
				} // foreach
			$text .= '</select>';
			} // if
		else if(substr($ini_key,-10) == 'FONT_STYLE') {	// multiple box for font style
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value=""' . (empty($ff) ? ' SELECTED':'') . '> -- default -- </option>';
			//$text .= '<option value="inherit"' . (($value == 'inherit') ? ' SELECTED' : '') . '>&nbsp;inherit' . (($value == 'inherit') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
			foreach(self::$font_styles as $ff) {
				$text .= '<option value="' . rawurldecode($ff) . '"' . ((strtolower($value) == strtolower($ff)) ? ' SELECTED':'') . '>' . $ff. ((strtolower($value) == strtolower($ff)) ? ' **':'') . '</option>';
				} // foreach
			$text .= '</select>';
			} // if
		else if(substr($ini_key,-11) == 'FONT_WEIGHT') {	// multiple box for font weight
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value=""' . (empty($ff) ? ' SELECTED':'') . '> -- default -- </option>';
			//$text .= '<option value="inherit"' . (($value == 'inherit') ? ' SELECTED' : '') . '>&nbsp;inherit' . (($value == 'inherit') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
			foreach(self::$font_weights as $ff) {
				$text .= '<option value="' . rawurldecode($ff) . '"' . ((strtolower($value) == strtolower($ff)) ? ' SELECTED':'') . '>' . $ff. ((strtolower($value) == strtolower($ff)) ? ' **':'') . '</option>';
				} // foreach
			$text .= '</select>';
			} // if
		else if(substr($ini_key,-4) == 'BOOL') {	// a true / false box
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value="false"'. (($value != 'true') ? ' SELECTED':'') . '>&nbsp;&nbsp;&nbsp;&nbsp;false&nbsp;&nbsp;&nbsp;&nbsp;</option>';
			$text .= '<option value="true"'. (($value == 'true') ? ' SELECTED':'') . '>&nbsp;&nbsp;&nbsp;&nbsp;true&nbsp;&nbsp;&nbsp;&nbsp;</option>';
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -2) == 'TZ') { // a time zone box
			$tzs = self::get_time_zones();
			$text .= '<select name="' . $name . '" size="1">';
			foreach($tzs as $tz) {
				$text .= '<option value="' . htmlentities($tz) . '"' . (($value == $tz) ? ' SELECTED' : '') . '>&nbsp;' . $tz . '&nbsp;</option>';
				} // foreach
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -13) == 'LANGUAGE_CODE') { // a language code box
			$lcs = self::get_language_codes();
			$text .= "\n" . '<select name="' . $name . '" size="1">';
			foreach($lcs as $lc) {
				$text .=  "\n" . '<option value="' . htmlentities($lc) . '"' . (($value == $lc) ? ' SELECTED' : '') . '>&nbsp;' . $lc . '&nbsp;</option>';
				} // foreach
			$text .=  "\n" . '</select>' . "\n";
			} // if
		else if (substr($ini_key, -8) == 'CHAR_SET') { // a charset box
			$css = self::get_charsets();
			$text .= "\n" . '<select name="' . $name . '" size="1">';
			foreach($css as $cs) {
				$text .=  "\n" . '<option value="' . htmlentities($cs) . '"' . (($value == $cs) ? ' SELECTED' : '') . '>&nbsp;' . $cs . '&nbsp;</option>';
				} // foreach
			$text .=  "\n" . '</select>' . "\n";
			} // if
		else if (substr($ini_key, -6) == 'COLOUR') { // a colour box
			$text .= '<select name="' . $name . '" size="1">';
			$text .= self::make_colour_select_options($value);
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -10) == 'BKGD_IMAGE') { // a background image box
			$cLMC = new Clmc();
			$text .= "\n" . '&nbsp;' . $cLMC->input_image($ini_key, $value, 'images/backgrounds/');
			} // if
		else if (substr($ini_key, -10) == 'LEFT_WIDTH') { // a width box
			$svalues = array(
				'75px', '100px', '125px', '150px', '175px', '200px', '225px', '250px', '275px',
				);
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value="">Width</option>';
			$text .= self::add_svalues_options($svalues, $value);
			$text .= '</select>';
			} // if
		else if ($ini_key == 'TOOLS_SEARCH_DEPTH_MAX') { // a width box
			$svalues = array(
				'1', '2', '3', '4', '5',
				);
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value="">Depth</option>';
			$text .= self::add_svalues_options($svalues, $value);
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -6) == 'HEIGHT') { // a height box
			$svalues = array(
				// '1em', '1.5em', '2em', '2.5em', '3em', '3.5em',
				'15px', '20px', '25px', '30px', '35px', '40px', '50px', '65px', '75px', '100px', '125px', '150px', '175px', '200px',
				);
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value="">Height</option>';
			$text .= self::add_svalues_options($svalues, $value);
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -6) == 'RADIUS') { // a radius box
			$svalues = array(
				'0px', '1px', '2px', '5px', '0.5em', '1em', '1.25em',
				);
			$text .= '<select name="' . $name . '" size="1">';
			$text .= '<option value="">Radius</option>';
			$text .= self::add_svalues_options($svalues, $value);
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -9) == 'FONT_SIZE') { // a size box
			$svalues = array(
				'8px', '10px', '12px', '14px', '16px', '18px', '20px', '22px',
				);
			$text .= '<select name="' . $name . '" size="1">';
			//$text .= '<option value="">Size</option>';
			$text .= '<option value="inherit"' . (($value == 'inherit') ? ' SELECTED' : '') . '>&nbsp;inherit' . (($value == 'inherit') ? ' **' : '&nbsp;') . '</option>' . "\n";	// special case
			$text .= self::add_svalues_options($svalues, $value);
			$text .= '</select>';
			} // if
		else if (substr($ini_key, -6) == 'BORDER') { // a width, style, colour box
			$vs = preg_split('/\s/',$value);

			$svalues = array(
				'0px', '1px', '2px', '5px', '8px', '10px', '12px', '15px', '18px', '20px',
				);
			$text .= '<select name="' . $name . '[]" size="1">';
			$text .= '<option value="">Width</option>';
			$text .= self::add_svalues_options($svalues, $vs[0]);
			$text .= '</select>';

			$svalues = array(
				'none', 'hidden', 'dotted', 'dashed', 'solid', 'double', 'groove', 'ridge', 'inset', 'outset',
				);
			$text .= '<select name="' . $name . '[]" size="1">';
			$text .= '<option value="">Style</option>';
			$text .= self::add_svalues_options($svalues, $vs[1]);
			$text .= '</select>';

			$text .= '<select name="' . $name . '[]" size="1">';
			$text .= self::make_colour_select_options($vs[2]);
			$text .= '</select>';
			} // if
		else {
			if(($slen = strlen($value)) > $size) {	// a text area
				$text .= '<textarea name="' . $name . '" cols="' . ($size + 2) . '" rows="' . (($slen / $size) + 2) . '">' . $value . '</textarea>';
				} // if
			else {	// an input box
				$text .= '<input type="text" name="' . $name . '" size="' . $size . '" value="' . $value . '" autocapitalize="off"/>';
				} // else
			} // else

		return $text;
	} // make_type_input()

	protected static function gen_selection_list($name, $options, $params = '') {
		if((empty($options)) || (!is_array($options))) return '';
		$text =  "\n";
		$text .= '<select' .
			(!empty($name) ? ' name="' . $name . '"':'') .
			(!empty($params) ? ' ' . $params:'') . '>' . "\n";
		for($i = 0, $n = count($options); $i < $n; $i++) {
			$option = $options[$i];
			$text .= '<option value="' . htmlentities($option['value']) . '"' . ($option['selected'] ? ' SELECTED':'') . '>';
			$text .= $option['text'];
			$text .= '</option>' . "\n";
			} // for
		$text .= '</select>' . "\n";
		return $text;
	} // gen_selection_list()

	public static function gen_user_selection_list($name, $lm_user_id = 0, $params = '') {
		$sql_query = "SELECT lm_user_id,lm_user_name,lm_user_enabled,lm_user_admin" .
			" FROM lm_users ORDER BY lm_user_name";
		$cnt = 0;
		$options = array();
		if(($result = self::$cDB->db_query($sql_query)) &&
			(($cnt = self::$cDB->db_num_rows($result)) > 0)) {
			$options[] = array(
					'value' => 0,
					'selected' => ($lm_user_id ? false:true),
					'text' => ' - Select User - ',
					);
			while($row = self::$cDB->db_fetch_array($result)) {
				$options[] = array(
					'value' => $row['lm_user_id'],
					'selected' => ((int)$row['lm_user_id'] == (int)$lm_user_id ? true:false),
					'text' => $row['lm_user_name'] . ' (' . ($row['lm_user_enabled'] == true ? 'enabled':'disabled') . ($row['lm_user_admin'] == 1 ? ', admin':'') . ')',
					);
				} // while
			} // if
		else $options[] = array(
					'value' => 0,
					'selected' => true,
					'text' => '<span class="msg_warning">(No users setup)</span>',
					);
		self::$cDB->db_free_result($result);
		return self::gen_selection_list($name, $options, $params);
	} // gen_user_selection_list()

	public static function gen_link_selection_list($name, $lm_link_id = 0, $params = '') {
		$sql_query = "SELECT lm_link_id,lm_link_name,lm_link_title,lm_link_description" .
			",lm_link_section_id,lm_section_name,lm_link_new_page, lm_link_image_url" .
			",lm_section_order,lm_section_title,lm_link_order,lm_link_enabled, lm_link_ssl, lm_link_add_name2url,lm_section_enabled,lm_section_id" .
			" FROM  lm_links as l LEFT JOIN lm_sections as s ON l.lm_link_section_id = s.lm_section_id" .
			" WHERE lm_link_id > 0" .
			" AND l.lm_link_section_id = s.lm_section_id" .
			" ORDER BY lm_section_order asc,lm_link_order asc,lm_link_name asc";
		$cnt = 0;
		$options = array();
		if(($result = self::$cDB->db_query($sql_query)) &&
			(($cnt = self::$cDB->db_num_rows($result)) > 0)) {
			$options[] = array(
					'value' => 0,
					'selected' => ($lm_link_id ? false:true),
					'text' => ' - Select Link - ',
					);
			while($row = self::$cDB->db_fetch_array($result)) {
				$text = $row['lm_section_name'] . ' (' . ($row['lm_section_enabled'] == true ? 'enabled':'disabled') . ')';
				$text .= " -&gt; ";
				$text .= $row['lm_link_name'] . ' (' . ($row['lm_link_enabled'] == true ? 'enabled':'disabled') . ')' . ((int)$row['lm_link_id'] == (int)$lm_link_id ? ' **':'');
				$options[] = array(
					'value' => $row['lm_link_id'],
					'selected' => ((int)$row['lm_link_id'] == (int)$lm_link_id ? true:false),
					'text' => $text,
					);
				} // while
			} // if
		else $options[] = array(
					'value' => 0,
					'selected' => true,
					'text' => '<span class="msg_warning">(No links setup)</span>',
					);
		self::$cDB->db_free_result($result);
		return self::gen_selection_list($name, $options, $params);
	} // gen_link_selection_list()

	public static function gen_section_selection_list($name, $lm_section_id = 0, $params = '') {
		$sql_query = "SELECT lm_section_id,lm_section_name,lm_section_enabled" .
			" FROM lm_sections ORDER BY lm_section_order";
		$cnt = 0;
		$options = array();
		if(($result = self::$cDB->db_query($sql_query)) &&
			(($cnt = self::$cDB->db_num_rows($result)) > 0)) {
			$options[] = array(
					'value' => 0,
					'selected' => ($lm_section_id ? false:true),
					'text' => ' - Select Section - ',
					);
			while($row = self::$cDB->db_fetch_array($result)) {
				$options[] = array(
					'value' => $row['lm_section_id'],
					'selected' => ((int)$row['lm_section_id'] == (int)$lm_section_id ? true:false),
					'text' => $row['lm_section_name'] . ' (' . ($row['lm_section_enabled'] == true ? 'enabled':'disabled') . ')' . ((int)$row['lm_section_id'] == (int)$lm_section_id ? ' **':''),
					);
				} // while
			} // if
		else $options[] = array(
					'value' => 0,
					'selected' => true,
					'text' => '<span class="msg_warning">(No sections setup)</span>',
					);
		self::$cDB->db_free_result($result);
		return self::gen_selection_list($name, $options, $params);
	} // gen_section_selection_list()

	public static function gen_tool_selection_list($name, $lm_tool_id = 0, $params = '') {
		$sql_query = "SELECT lm_tool_id,lm_tool_name,lm_tool_enabled" .
			" FROM lm_tools ORDER BY lm_tool_order";
		$cnt = 0;
		$options = array();
		if(($result = self::$cDB->db_query($sql_query)) &&
			(($cnt = self::$cDB->db_num_rows($result)) > 0)) {
			$options[] = array(
					'value' => 0,
					'selected' => ($lm_tool_id ? false:true),
					'text' => ' - Select Tool - ',
					);
			while($row = self::$cDB->db_fetch_array($result)) {
				$options[] = array(
					'value' => $row['lm_tool_id'],
					'selected' => ((int)$row['lm_tool_id'] == (int)$lm_tool_id ? true:false),
					'text' => $row['lm_tool_name'] . ' (' . ($row['lm_tool_enabled'] == true ? 'enabled':'disabled') . ')' . ((int)$row['lm_tool_id'] == (int)$lm_tool_id ? ' **':''),
					);
				} // while
			} // if
		else $options[] = array(
					'value' => 0,
					'selected' => true,
					'text' => '<span class="msg_warning">(No tools setup)</span>',
					);
		self::$cDB->db_free_result($result);
		return self::gen_selection_list($name, $options, $params);
	} // gen_tool_selection_list()

	public static function is_iframeable_url($url, $add_msg = true) {
		// return false if full url or error, anti click jacking may be in play
		if(!$parts = parse_url($url)) return false;
		if(((isset($parts['scheme'])) && (!empty($parts['scheme']))) ||
			((isset($parts['host'])) && (!empty($parts['host'])))) {
			if($add_msg) self::addMsg ('URL "' . $url . '" may not be iframe compatible','warning');
			return false;
			} // if
		return true;
	} // is_iframeable_url()

	private static function  get_tools_dir_selection_recurse(&$text,&$lm_tool_url,&$option_cnt,$base = '',$depth = 0) {	// recursive
		if($depth >= (int)INI_TOOLS_SEARCH_DEPTH_MAX) return false;	// no deeper
		$tools = scandir(LM_FS_BASE_DIR . LM_LOCAL_TOOLS_FOLDER . $base);
		sort($tools);
		for($i = 0, $n = count($tools); $i < $n; $i++) {
			$tool = $tools[$i];
			if(preg_match('/^\.|\.cvs$|\.svn$|^_/i',$tool)) continue;	// no hiddens, version control or directory nav
			if(is_dir(LM_FS_BASE_DIR . LM_LOCAL_TOOLS_FOLDER . $base . '/' . $tool)) {
				self::get_tools_dir_selection_recurse($text,$lm_tool_url,$option_cnt, ($base . '/' . $tool),($depth + 1));	// recurse
				} // if
			else if(preg_match('/\.htm$|\.php$|\.html$|\.txt$/i',$tool)) {
				$option_cnt++;
				$text .= '<option style="text-align:left;" value="' . htmlentities($base . '/' . $tool) . '"' . (($base . '/' . $tool == $lm_tool_url) ? ' SELECTED':'') . '>' . $base . '/' . $tool . (($base . '/' . $tool == $lm_tool_url) ? ' **':'') . '</option>' . "\n";
				} // else if
			} // for
		return true;
		} // get_tools_dir_selection_recurse()

	public static function get_tools_dir_selection($name,$lm_tool_url) {	// recursive
		$text = '<select name="' . $name . '" size="1" title="Tool URL. The clickable tool the new web page. Minimum of 4 charaters. Tools resides in the "' . LM_LOCAL_TOOLS_FOLDER . '/ directory (at ' . LM_FS_BASE_DIR .  LM_LOCAL_TOOLS_FOLDER . '). Each tool should reside in a separate directory.">' . "\n";
		$text .= '<option value="0" style="text-align: left"> - Select Tool URL - </option>' . "\n";
		$option_cnt = 0;
		self::get_tools_dir_selection_recurse($text,$lm_tool_url,$option_cnt);	// recurse
		$text .= '</select>' . "\n";
		if(!$option_cnt) return '<span class="msg_error">(No tool files found in "' . LM_FS_BASE_DIR . LM_LOCAL_TOOLS_FOLDER . '/")</span>';
		return $text;
		} // get_tools_dir_selection()

	public static function get_row_bkgnd_colour($even, $bk, $chg = 0.15) {
		self::make_text_colours();
		$chg = (float)$chg;
		if(is_numeric($bk)) $v = (int)$bk;
		if(is_string($bk)) {
			if((strlen($bk) == 7) &&
				(substr($bk, 0,1) == '#')) {	// hex value
				$v = hexdec(substr($bk,1));
				$r = (($v >> 16) & 0xff);
				$g = (($v >> 8) & 0xff);
				$b = ($v & 0xff);
				} // if
			else if((strlen($bk) == 4) &&
				(substr($bk, 0,1) == '#')) {	// hex value
				$v = hexdec(substr($bk,1));
				$r = (($v >> 4) & 0xf0);
				$g = ($v & 0xf0);
				$b = (($v << 4) & 0xf0);
				} // if
			else {
				$bk = strtolower($bk);
				if(key_exists($bk, self::$lc_std_colours)) {
					$v = hexdec(substr(self::$lc_std_colours[$bk],1));
					$r = (($v >> 16) & 0xff);
					$g = (($v >> 8) & 0xff);
					$b = ($v & 0xff);
					} // if
				else return $bk;	// a colour string, @TODO loolup colour
				} // else
			} // if

		$intensity = $r + $g + $b;

		if($even) { // make brighter
			$gain = 1.00 + (float)$chg;
			$offset = (255.00 - (float)$intensity) * (float)$chg / 3.0;
			} // if
		else {	// make darker
			$gain = 1.00 - (float)$chg;
			$offset = (255.00 - (float)$intensity) * (float)$chg / -3.0;
			} // else

		$rr = ((float)$r * $gain) + $offset;
		if($rr > 255.00) $r = 255;
		else if($rr < 0.00) $r = 0;
		else $r = (int)$rr;

		$gg = ((float)$g * $gain) + $offset;
		if($gg > 255.00) $g = 255;
		else if($gg < 0.00) $g = 0;
		else $g = (int)$gg;

		$bb = ((float)$b * $gain) + $offset;
		if($bb > 255.00) $b = 255;
		else if($bb < 0.00) $b = 0;
		else $b = (int)$bb;

		$new_bk = sprintf('#%02X%02X%02X',$r,$g,$b);

		return $new_bk;
		} // get_row_bkgnd_colour()

	public static function get_link_html($link) {
		$text = '';
		if(empty($link)) return '&nbsp;';
		$url_parts = parse_url($link['lm_link_url']);
		$url = '';

		if((empty($url_parts['scheme'])) &&
			(empty($url_parts['host'])) &&
			($link['lm_link_ssl']))
			$url .= LM_SSL_URL;

		if($link['lm_link_new_page']) {
			$url .= $link['lm_link_url'] . ((int)$link['lm_link_add_name2url'] ? '?name=' . $link['lm_link_name']:'');
			} // if
		else {
			$url .= 'index.php?action=link&link_id=' . (int)$link['lm_link_id'] . '&name=' . urlencode($link['lm_link_name']);
			} // else

		if($link['lm_link_new_page']) {
			$text .= '<a href="' . $url . '"';
			$text .= ' target="_blank"';
			$text .= ' title="' . (!empty($link['lm_link_title']) ? strip_tags($link['lm_link_title']) . "\n":'') . (LMC_SHOWINNEWTAB ? '(in a new tab)':'') . '"';
			} // if
		else {
			$text .= '<a href="' . $url . '"';
			if(!empty($link['lm_link_title'])) $text .= ' title="' . strip_tags($link['lm_link_title']) . '"';
			} // else

		$text .= ' class="link_body">';

		if(!empty($link['lm_link_image_url'])) {
			$text .= '<img height="' . LMC_SMALL_IMAGE_HEIGHT . '" src="images/upload/' . $link['lm_link_image_url'] . '">';
			$text .= '<br>';
			} // if
		$text .= $link['lm_link_name'];
		$text .= '</a>';
		if((LMC_SHOW_LINK_DESCRIPTION) &&
			(!empty($link['lm_link_description']))) $text .= '<br><small>' . $link['lm_link_description'] . '</small>';
		return $text;
		} // get_link_html()

	protected static function make_ws_image_select_options() {
		$paths = array(
			'images/upload/',
			'images/backgrounds/',
			);
		$img_list = array();
		foreach($paths as $path) {
			if($dh = opendir(LM_FS_BASE_DIR . $path)) {
				while (($file = readdir($dh)) !== false) {
					if(preg_match('/\.png|\.jpg|\.jpeg|\.gif/',$file)) $img_list[] = $path . $file;
					} // while
				closedir($dh);
				} // if
			} // foreach
		sort($img_list);
		return self::add_svalues_options(array_merge(array('-- Select Image URI to Copy --'),$img_list),'-1');
	} // make_ws_image_select_options()

	public static function get_ws_image_uri_selection() {
		$text = '<select id="ws_image_list_id" name="ws_image_list" size="1" onchange="javascript:get_selected_ws_image();">' . self::make_ws_image_select_options() . '</select>';
		return $text;
		} // get_ws_image_uri_selection()

	public static function get_admin_scroll2top_anchor($js_flg = true) {
		$text = '' . "\n";
		$text .= '<a name="top"></a>' . "\n";
		if(($js_flg) && (!self::$tablet_flg) && (!self::$chrome_flg)) {
			$text .= '<span class="admin-right-floating-box"><a onclick="javascript:scroll2Name(\'top\');" title="Back to Top">Top</a></span>' . "\n";
			} // if
		return $text;
		} // get_admin_scroll2top_anchor()

} // Clm_html
