<?php
/**
 * $Id: lm_install.php 410 2016-10-11 13:04:28Z robert0609 $
 *
 * Description of lm_install
 *
 * @author robert0609
 */

class Clm_install {

	//put your code here

	function __construct() {
		} // __construct()

	function __destruct() {
		// clean before I go home
		} // __destruct()

	public static function clean_DB() {
		// put version updates here
		$lm_key_errs = array(	// lm_configs lm_config_key code errors
			// nil atm
			);
		foreach($lm_key_errs as $o => $n) {
			if(($result = Clm::$cDB->db_query("select lm_config_id from lm_configs where lm_config_key = '" . $o ."'")) &&
				($config_chk = Clm::$cDB->db_fetch_array($result))) {
				if(!Clm::$cDB->db_query("UPDATE lm_configs SET lm_config_key = '" . $n . "' WHERE lm_config_id = " . $config_chk['lm_config_id'] . ";")) {
					Clm::addMsg('ERROR: Failed to update config key ' . $o . ' to ' . $n . '.');
					Clm::$cDB->logEvent('ERROR: Failed to update config key ' . $o . ' to ' . $n . '.');
					} // if
				} // if
			} // foreach
		$lm_keys2delete = array(
			'LMC_SHOW_LEFT_COLUMN',	// now part of INI theme
			'LMC_BLOCK_STYLE',	// now part of INI theme
			);
		foreach($lm_keys2delete as $o) {
			if(Clm::$cDB->is_data_in_table('lm_configs','lm_config_key',$o)) {
				$sql_query = "DELETE FROM  lm_configs WHERE  lm_config_key = '" . $o . "'";
				Clm::$cDB->db_query($sql_query);
				} // if
			} // foreach
		} // clean_DB()

	public static function rebuild_from_settings() {
		Clm::addMsg('Checking installation settings.','info');
		$settings = Clm::read_ini_settings();
		Clm::save_ini_settings($settings);

		Clm::addMsg('Rebuild sitemap.','info');
		Clm::reset_xml_stitemap();
		new Clm_xml_sitemap();

		Clm::addMsg('Rebuild theme.','info');
		Clm::build_css_stylesheets();
		} // rebuild_from_settings()

	public function get_installDBscripts() {
		$id = 1;
		$install_scripts = array(	// multi tables, REMEMBER SQLITE DOES NOT THE SAME SQL SUITE AS MYSQL
			'lm_users' => array(	// table name
				'drop' => 'false', // dont drop on table reload
				'columns' => array(
					"lm_user_id" => "INTEGER PRIMARY KEY",			// the row id
					"lm_user_added" => "TIMESTAMP",	// date and time the row was added
					"lm_user_updated" => "TIMESTAMP",	// date and time the row was updated
					"lm_user_name" => "VARCHAR(128) NOT NULL ON CONFLICT FAIL",						// the user name
					"lm_user_password_md5" => "VARCHAR(40) NOT NULL ON CONFLICT FAIL",				// the md5ed password
					"lm_user_admin" => "BOOLEAN DEFAULT 0",			// the administrator rights enabled or disabled
					"lm_user_group_ids" => "VARCHAR(128) DEFAULT '0'",		// the user groups
					"lm_user_enabled" => "BOOLEAN DEFAULT 1",		// the user enabled or disabled
					"lm_user_inline_html" => "BOOLEAN DEFAULT 1",	// the users 1=inline dispaly, 0=block display
					"lm_user_login_count" => "INTEGER DEFAULT 0",	// the number of logins
					),
				'updateable_columns' => '',	// used with update_row_data(), comma seperate list, nil
				'functions' => array(
					"InsertTrigger_lm_users" => "CREATE TRIGGER InsertTrigger_lm_users AFTER INSERT ON lm_users" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_users SET lm_user_added = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					"UpdateTrigger_lm_users" => "CREATE TRIGGER UpdateTrigger_lm_users AFTER UPDATE ON lm_users" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_users SET lm_user_updated = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					),
				'data' => array(	// in the same order as the columns
					array(1, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",  "'" . LM_DEFAULT_ADMIN . "'", "'" . LM_DEFAULT_PASSWORD . "'", "1", "0", "1", "0"),	// row data
					),
				),

			'lm_groups' => array(	// table name
				'drop' => 'false', // dont drop on table reload
				'columns' => array(
					"lm_group_id" => "INTEGER PRIMARY KEY",	// the row id
					"lm_group_added" => "TIMESTAMP",		// date and time the row was added
					"lm_group_updated" => "TIMESTAMP",		// date and time the row was updated
					"lm_group_name" => "VARCHAR(128) NOT NULL ON CONFLICT FAIL",		// the group name
					"lm_group_description" => "TEXT DEFAULT ''",
					"lm_group_admin" => "BOOLEAN DEFAULT 0",			// the administrator right enabled or disabled
					"lm_group_manager_ids" => "VARCHAR(128) DEFAULT '0'",			// the group manager rights enabled or disabled
					"lm_group_order" => "INTEGER DEFAULT 0",	// sort order
					"lm_group_enabled" => "BOOLEAN DEFAULT 1",		// the group enabled or disabled
					),
				'key_column' => '',	// used with update_row_data()
				'updateable_columns' => '',	// used with update_row_data(), comma seperate list, nil
				'functions' => array(
					"InsertTrigger_lm_groups" => "CREATE TRIGGER InsertTrigger_lm_groups AFTER INSERT ON lm_groups" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_groups SET lm_group_added = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					"UpdateTrigger_lm_groups" => "CREATE TRIGGER UpdateTrigger_lm_groups AFTER UPDATE ON lm_groups" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_groups SET lm_group_updated = DATETIME('NOW','UTC')  WHERE rowid = old.rowid;" . "\n" .
						"END;" . "\n",
					),
				),

			'lm_configs' => array(	// table name
				'drop' => 'false', // dont drop on table reload
				'columns' => array(
					"lm_config_id" => "INTEGER PRIMARY KEY",	// the row id
					"lm_config_added" => "TIMESTAMP",	// date and time the row was added
					"lm_config_updated" => "TIMESTAMP",	// date and time the row was updated
					"lm_config_key" => "VARCHAR(128) UNIQUE ON CONFLICT FAIL",		// the config key translated into a define()
					"lm_config_value" => "TEXT DEFAULT ''",			// the config value translated into a define()
					"lm_config_allowed_values" => "TEXT DEFAULT ''",	// allowed values for lm_config_value seperated by a colon, or empty for unrestricted
					"lm_config_name" => "TEXT DEFAULT ''",			// the config name
					"lm_config_description" => "TEXT DEFAULT ''",	// the config description
					"lm_config_show_func" => "VARCHAR(32) DEFAULT ''",	// the config Clmc function to show the entry, displays data
					"lm_config_input_func" => "VARCHAR(32) DEFAULT ''",	// the config Clmc function to input the entry, outputs form html
					"lm_config_save_func" => "VARCHAR(32) DEFAULT ''",	// the config Clmc function to save the entry, save the data from the posted form
					),	// used in code by using define('lm_config_name', 'lm_config_value');
				'key_column' => 'lm_config_key',	// used with update_row_data()
				'updateable_columns' => 'lm_config_name,lm_config_allowed_values,lm_config_description,lm_config_show_func,lm_config_input_func,lm_config_save_func',	// used with update_row_data(), comma seperate list
				'functions' => array(
					"InsertTrigger_lm_configs" => "CREATE TRIGGER InsertTrigger_lm_configs AFTER INSERT ON lm_configs" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_configs SET lm_config_added = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					"UpdateTrigger_lm_configs" => "CREATE TRIGGER UpdateTrigger_lm_configs AFTER UPDATE ON lm_configs" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_configs SET lm_config_updated = DATETIME('NOW','UTC')  WHERE rowid = old.rowid;" . "\n" .
						"END;" . "\n",
					),
				'data' => array(	// in the same order as the columns
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_CO_NAME'",	// lm_config_key
						"'My Company'",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Company / Entity Name.'",
						"'Enter the company or entitity name used on the " . LM_PROJECT_SHORTNAME . " pages.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_TITLE'",	// lm_config_key
						"'Default Settings for " . LM_PROJECT_SHORTNAME . "'",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Title.'",
						"'Enter the title used for this web site.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_DISCLAIMER_LINK'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Custom Link'",
						"'Enter the URI link to the a custom link. Defaults to a content disclaimer.<br>" .
							"Link appears on the left side of the footer, and is displayed in an iframe.<br>" .
							"An empty value defaults to pages/disclaimer.tmpl.php'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_url'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_DISCLAIMER_LINK_NAME'",	// lm_config_key
						"'Disclaimer'",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Custom Link Name'",
						"'Enter the name for the Custom Link. An empty value turns off the Custom Link.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_WEB_SITE_ADDRESS'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Main Web Site URL'",
						"'Enter the primary web site URL for " . LM_PROJECT_SHORTNAME . " content. Include the protocol (e.g. http://www.example.com).<br><span class=\"msg_warning\">NOTE: This URL is also used for sitemaps links.</span>'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_url'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SUPPORT_EMAIL'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Support Email Address'",
						"'Enter the support email address for " . LM_PROJECT_SHORTNAME . " content.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_email'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SHOW_LOGIN_LINK'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Show Login Link'",
						"'true = show login link in header, false = not shown. <b>NOTE:</b>Use URL ./login.php?user=username to login.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SITE_STATUS'",	// lm_config_key
						"'(Draft)'",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Status.'",
						"'Enter the site status. Used as a sub-text.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_EXT_URL_NEW_PAGE'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'External URLs on New Page.'",
						"'true = set external links to new page (stops possible click jacking), false = dont automatically set to new page.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SHOW_VISITOR_COUNTER'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Show Visitor Count.'",
						"'true = show " . LM_PROJECT_SHORTNAME . " visitor count in footer, false = turn off counter.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SHOW_STATS'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Show Web Stats.'",
						"'true = show " . LM_PROJECT_SHORTNAME . " page stats in footer, false = turn off stats.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SHOW_COOKIE_COUNTER'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Show Personal Visit Count.'",
						"'true = show personal " . LM_PROJECT_SHORTNAME . " visit count in footer, false = turn off counter.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data

					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_LOGO_IMAGE'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Logo Image.'",
						"'Select the header logo image filename (stored in images/upload/ directory). Use a transparent image to remove the Home word and make a hotspot link. (Hint: Set the logo height to the header height.)'",
						"'show_image'",	// lm_config_show_func
						"'input_image'",	// lm_config_input_func
						"'get_image'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SMALL_IMAGE_HEIGHT'",	// lm_config_key
						"'25'",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Small Image Height.'",
						"'Enter the height of small images in pixels.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_LARGE_IMAGE_HEIGHT'",	// lm_config_key
						"'150'",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Large Image Height.'",
						"'Enter the height of large images in pixels.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SHOW_LINK_DESCRIPTION'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Show Link Description.'",
						"'true = to show descriptions, false = to NOT show.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_META_DESCRIPTION'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Description.'",
						"'Enter a description of the site. Used in the page head meta data.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_META_KEYWORDS'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Keywords.'",
						"'Enter keywords or short phrases seperated by commas, used by search engines. Used in the page head meta data.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_META_OWNER'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Owner.'",
						"'Enter the web site owner. Used in the page head meta data.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_META_AUTHOR'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Author.'",
						"'Enter the web site author. Used in the page head meta data.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_META_COPYRIGHT'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Web Site Copyright.'",
						"'Enter the web site copyright message. Used in the page head meta data.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"'get_sanitized_text'",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_CUSTOM_COLOURS'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"'Custom Colours.'",
						"'Enter custom colours in Name=#RGB format. Multiple colours are seperated by colons  (e.g. My Colour 1 #7FFFD4:My Colour 2=#ff00ff).'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_RETURN2SEARCH'",	// lm_config_key
						"'false'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Return to Search.'",
						"'true = clicking save or cancel in admin pages returns to the admin search page, false = returns to the standard pages.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_VERSION'",	// lm_config_key
						"''",	// lm_config_value
						"''",	// lm_config_allowed_values
						"''",	// invisible
						"'Invisible, DB version tracking.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_USE_TITLE_TOOLTIPS'",	// lm_config_key
						"'true'",	// lm_config_value
						"'true:false'",	// lm_config_allowed_values
						"'Show Title Tooltips.'",
						"'true = show title attributes as tooltip bubbles, false = use the standard browser title bubble.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_SHOWINNEWTAB'",	// cms_config_key
						"'false'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'Show Link In a New Tab.'",
						"'true = show In a New Tab in link titles and tooltips, false = turn off In a New Tab.'",
						"''",	// cms_config_show_func
						"''",	// cms_config_input_func
						"''",	// cms_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_FILTER_OUTPUT'",	// lm_config_key
						"'true'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'Find.'",
						"'true = Show filter dialog to filter output by finding keywords in titles, descriptions and links, false = turn off filter dialog.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_FILTER_ANDED'",	// lm_config_key
						"'true'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'Filter Logic.'",
						"'true = Find filter uses ANDed logic to find keyswords, false = Find filter uses ORed logic to find keyswords.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_FILTER_STAT'",	// lm_config_key
						"'true'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'Find.'",
						"'true = Show filter find stats at the bottom of the page, false = turn off filter stats.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_USE_FIRST_LOGIN_ALWAYS'",	// lm_config_key
						"'true'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'First login password always.'",
						"'true = Always use first time login to get the password from the user, false = show password inputs in add user page.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_ALLOW_CSV_EXPORT_IMPORT'",	// lm_config_key
						"'true'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'Allow CSV Export and Import.'",
						"'true = Allows CSV export and import, false = no CSV operations.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_RECENT_CHANGES_ENABLED'",	// lm_config_key
						"'true'",	// cms_config_value
						"'true:false'",	// cms_config_allowed_values
						"'Enable Most Recent Changes.'",
						"'true = Enable most recent change to be displayed, false = disbale most recent chsanges.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_RECENT_CHANGES_MAX'",	// lm_config_key
						"'10'",	// cms_config_value
						"'10:20:50:100:200:500'",	// cms_config_allowed_values
						"'Maximum Recent Changes.'",
						"'Enter the maximum number of most recent changes to show.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_RECENT_CHANGES_DAYS'",	// lm_config_key
						"'14'",	// cms_config_value
						"'7:14:30:90:180:365'",	// cms_config_allowed_values
						"'Days Most Recent Change.'",
						"'Enter the number of days to show recent changes for.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_MIN_PASSWD_LEN'",	// lm_config_key
						"'4'",	// cms_config_value
						"'4:5:6:7:8:9:10'",	// cms_config_allowed_values
						"'Minimum Password Length.'",
						"'Enter the minimum length for new passwords.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					array( $id++, "DATETIME('NOW','UTC')", "DATETIME('NOW','UTC')",
						"'LMC_MIN_NAME_LEN'",	// lm_config_key
						"'4'",	// cms_config_value
						"'4:5:6:7:8:9:10'",	// cms_config_allowed_values
						"'Minimum Name Length.'",
						"'Enter the minimum length for new names.'",
						"''",	// lm_config_show_func
						"''",	// lm_config_input_func
						"''",	// lm_config_save_func
						),	// row data
					),
				),

			'lm_sections' => array(	// table name
				'drop' => 'false',	// dont redo on table reload
				'columns' => array(
					"lm_section_id" => "INTEGER PRIMARY KEY",	// the row id
					"lm_section_added" => "TIMESTAMP",	// date and time the row was added
					"lm_section_updated" => "TIMESTAMP",	// date and time the row was updated
					"lm_section_group_ids" => "VARCHAR(128) DEFAULT '0'",	// display group ids
					"lm_section_order" => "INTEGER DEFAULT 0",	// sort order
					"lm_section_enabled" => "BOOLEAN DEFAULT 1",
					"lm_section_name" => "VARCHAR(128) DEFAULT ''",
					"lm_section_description" => "TEXT DEFAULT ''",
					"lm_section_title" => "VARCHAR(128) DEFAULT ''",
					"lm_section_image_url" => "VARCHAR(255) DEFAULT ''",
					"lm_section_columns" => "INTEGER DEFAULT 6",	// columns acroos the page
					),
				'key_column' => 'lm_config_key',	// used with update_row_data()
				'updateable_columns' => '',	// used with update_row_data(), comma seperate list, nil
				'functions' => array(
					"InsertTrigger_lm_sections" => "CREATE TRIGGER InsertTrigger_lm_sections AFTER INSERT ON lm_sections" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_sections SET lm_section_added = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					"UpdateTrigger_lm_sections" => "CREATE TRIGGER UpdateTrigger_lm_sections AFTER UPDATE ON lm_sections" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_sections SET lm_section_updated = DATETIME('NOW','UTC')  WHERE rowid = old.rowid;" . "\n" .
						"END;" . "\n",
					),
				),

			'lm_links' => array(	// table name
				'drop' => 'false',	// dont redo on table reload
				'columns' => array(
					"lm_link_id" => "INTEGER PRIMARY KEY",
					"lm_link_added" => "TIMESTAMP",	// date and time the row was added
					"lm_link_updated" => "TIMESTAMP",	// date and time the row was updated
					"lm_link_name" => "VARCHAR(128)  DEFAULT ''",
					"lm_link_section_id" => "INTEGER DEFAULT 0",	// display section ids
					"lm_link_order" => "INTEGER DEFAULT 0",	// sort order
					"lm_link_enabled" => "BOOLEAN DEFAULT 1",
					"lm_link_url" => "VARCHAR(128) NOT NULL ON CONFLICT FAIL",
					"lm_link_description" => "TEXT",
					"lm_link_title" => "TEXT DEFAULT ''",
					"lm_link_image_url" => "VARCHAR(255) DEFAULT ''",
					"lm_link_new_page" => "BOOLEAN DEFAULT 1",
					"lm_link_ssl" => "BOOLEAN DEFAULT 0",
					"lm_link_add_name2url" => "BOOLEAN DEFAULT 1",
					),
				'key_column' => 'lm_config_key',	// used with update_row_data()
				'updateable_columns' => '',	// used with update_row_data(), comma seperate list, nil
				'functions' => array(
					"InsertTrigger_lm_links" => "CREATE TRIGGER InsertTrigger_lm_links AFTER INSERT ON lm_links" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_links SET lm_link_added = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					"UpdateTrigger_lm_links" => "CREATE TRIGGER UpdateTrigger_lm_links AFTER UPDATE ON lm_links" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_links SET lm_link_updated = DATETIME('NOW','UTC')  WHERE rowid = old.rowid;" . "\n" .
						"END;" . "\n",
					),
				),

			'lm_tools' => array(	// table name
				'drop' => 'false',	// dont redo on table reload
				'columns' => array(
					"lm_tool_id" => "INTEGER PRIMARY KEY",
					"lm_tool_added" => "TIMESTAMP",	// date and time the row was added
					"lm_tool_updated" => "TIMESTAMP",	// date and time the row was updated
					"lm_tool_name" => "VARCHAR(128)  DEFAULT ''",
					"lm_tool_group_ids" => "VARCHAR(128) DEFAULT '0'",	// display group ids
					"lm_tool_order" => "INTEGER DEFAULT 0",	// sort order
					"lm_tool_enabled" => "BOOLEAN DEFAULT 1",
					"lm_tool_url" => "VARCHAR(128) NOT NULL ON CONFLICT FAIL",
					"lm_tool_description" => "TEXT",
					"lm_tool_title" => "TEXT DEFAULT ''",
					"lm_tool_new_page" => "BOOLEAN DEFAULT 0",
					"lm_tool_ssl" => "BOOLEAN DEFAULT 0",
					"lm_tool_add_name2url" => "BOOLEAN DEFAULT 1",
					),
				'key_column' => 'lm_config_key',	// used with update_row_data()
				'updateable_columns' => '',	// used with update_row_data(), comma seperate list, nil
				'functions' => array(
					"InsertTrigger_lm_tools" => "CREATE TRIGGER InsertTrigger_lm_tools AFTER INSERT ON lm_tools" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_tools SET lm_tool_added = DATETIME('NOW','UTC')  WHERE rowid = new.rowid;" . "\n" .
						"END;" . "\n",
					"UpdateTrigger_lm_tools" => "CREATE TRIGGER UpdateTrigger_lm_tools AFTER UPDATE ON lm_tools" . "\n" .
						"BEGIN" . "\n" .
						" UPDATE lm_tools SET lm_tool_updated = DATETIME('NOW','UTC')  WHERE rowid = old.rowid;" . "\n" .
						"END;" . "\n",
					),
				),
			);
		return $install_scripts;
		} // get_installDBscripts()

} // Clm_install
