<?php

/**
 * $Id: lm_recents.php 139 2015-03-04 12:03:22Z robert0609 $
 *
 *  * Description of lm_recents
 *	* static class to provide recent changes
 *
 * @author robert0609
 */
class Clm_recents extends Clm_general {

	protected static $recents_keywords = false;
//	protected static $sect_sql_recents = '';
//	protected static $link_sql_recents = '';

	protected static $linkkeys = array('lm_link_name','lm_link_title','lm_link_description');	// ,'lm_link_url','lm_link_image_url'
	protected static $sectkeys = array('lm_section_name', 'lm_section_description', 'lm_section_title');	// ,'lm_section_image_url'

	protected static $layout_ids = false;

			function __construct() {
		parent::__construct();
		} // __construct()

	function __destruct() {
		parent::__destruct();
		} // __destruct()

// static methods
	protected static function help($cnt = LMC_RECENT_CHANGES_MAX) {
		$text = "The " . $cnt . " most recent changes that occured in the last " . LMC_RECENT_CHANGES_DAYS . " days.";
		return $text;
		} // help()

	protected static function get_changes() {
		$list = array();
		$sql_query = "SELECT " .
			"l.lm_link_id, l.lm_link_name, l.lm_link_section_id, l.lm_link_url, lm_link_order" .
			", l.lm_link_name , l.lm_link_description, l.lm_link_title" .
			", lm_link_image_url, lm_link_new_page, lm_link_ssl, lm_link_enabled, lm_link_add_name2url" .
//			", DATETIME(lm_link_added, 'LocalTime') as  lm_link_added" .
			", DATETIME(lm_link_updated, 'LocalTime') as  lm_link_updated" .
			", s.lm_section_id, s.lm_section_name, s.lm_section_updated, s.lm_section_group_ids" .
			" FROM  lm_sections as s, lm_links as l" .
			" WHERE s.lm_section_id = l.lm_link_section_id" .
			" AND l.lm_link_enabled > 0" .
			" AND s.lm_section_enabled > 0" .
			" AND DATETIME(lm_link_updated, 'LocalTime') >= DATETIME('NOW','LocalTime','-" . LMC_RECENT_CHANGES_DAYS . " Day')" .
			" ORDER BY lm_link_updated DESC" .
			" LIMIT " . LMC_RECENT_CHANGES_MAX . ";";
		if($sql_result = Clm::$cDB->db_query($sql_query)) {
			while($recent = Clm::$cDB->db_fetch_array($sql_result)) {
				if(!Clm::check_user_group_ids($recent['lm_section_group_ids']))	continue;
				$list[] = $recent;
				} // while
			Clm::$cDB->db_free_result($sql_result);
			} // if
		return $list;
		} // get_changes()

	protected static function get_option_link($link) {
		$text = '';
		if(empty($link)) return '&nbsp;';
		$url_parts = parse_url($link['lm_link_url']);
		$url = '';

		if((empty($url_parts['scheme'])) &&
			(empty($url_parts['host'])) &&
			($link['lm_link_ssl']))
			$url .= LM_SSL_URL;

		if($link['lm_link_new_page']) {
			$url .= $link['lm_link_url'] . ((int)$link['lm_link_add_name2url'] ? '?name=' . $link['lm_link_name']:'');
			} // if
		else {
			$url .= 'index.php?action=link&link_id=' . (int)$link['lm_link_id'] . '&name=' . urlencode($link['lm_link_name']);
			} // else

		if($link['lm_link_new_page']) {
			$text = $url . '&PARAM=_blank';
			} // if
		else {
			$text = $url;
			} // else

		return $text;
		} // get_option_link()

	public static function get_recent_changes($class = 'page_body') {
		if(!LMC_RECENT_CHANGES_ENABLED) return false;
		$list = self::get_changes();
		if(empty($list)) return false;
		$text = '';
		$text .= '<select class="' . $class . '" name="recents" id="recents" onchange="javascript:gotoOption(this)" title="' . self::help(count($list)) . '">' . "\n";
//		$text .= '	<option class="' . $class .'">' . 'Recent Changes' . '</option>' . "\n";
		foreach($list as $l) {
			$url = self::get_option_link($l);
			$text .= '	<option class="' . $class . '" value="' . urlencode($url) . '">' .
				$l['lm_link_name'] . ' in ' . $l['lm_section_name'] . ' on ' . $l['lm_link_updated'] .
				'</option>' . "\n";
			} // foreach
		$text .= '</select>' . "\n";
		$text .= "\n";
		$text .= '<script type="text/javascript">' . "\n";
		$text .= "\n";
		$text .= '	function gotoOption(elm) {' . "\n";
		$text .= '		var val = elm.options[elm.selectedIndex].value;' . "\n";
		$text .= '		var uri = decodeURIComponent(val.replace(/\+/g, " "));' . "\n";
//		$text .= '		alert(uri);' . "\n";
		$text .= '		var parts = uri.split("&PARAM=");' . "\n";
//		$text .= '		alert(parts);' . "\n";
		$text .= '		window.open(parts[0],parts[1]);' . "\n";
		$text .= '	} // gotoOption()' . "\n";
		$text .= "\n";
		$text .= '</script>' . "\n";
		$text .= "\n";
		return $text;
		} // get_recent_changes()

} // Clm_recents
