<?php

/**
 * $Id: lmc.php 396 2016-04-28 12:29:55Z robert0609 $
 *
 * Description of lmc
 * lm_configs database configure functions
 *
 * @author robert0609
 */

class Clmc extends Cmsgs {

	//put your code here

	function __construct() {
		} // __construct()

	function __destruct() {
		} // __destruct()

// methods
	public function is_config_value_ok($lm_config_id,$lm_config_value) {
		$allows = Clm::$cDB->get_data_in_table('lm_configs','lm_config_allowed_values',"lm_config_id = '" . (int)$lm_config_id . "'");
		if(empty($allows)) return true;
		$allowed = explode(':',$allows);
		if(!is_array($allowed)) return true;
		if(in_array($lm_config_value,$allowed)) return true;
		return false;
		} // is_config_value_ok()

	public function show_value($lm_config_value,$lm_config_allowed_values,$lm_config_input_func,$lm_config_description) {
		$text = '';
		if((!empty($lm_config_allowed_values)) && (is_array(($allowed = explode(':',$lm_config_allowed_values))))) {
			$text .= '<select name="lm_config_value" size="1" title="' . strip_tags($lm_config_description) . '">';
			foreach($allowed as $v) {
				$text .= '<option value="' . htmlentities($v) . '"' . ($lm_config_value == $v ? 'SELECTED':'') . '>' . Clm::make_nice_name($v) . '</option>' . "\n";
				} // foreach
			$text .= '</select>';
			}
		else if((!empty($lm_config_input_func)) &&
			(method_exists($this,$lm_config_input_func))) {
			$method = $lm_config_input_func;
			$text .= $this->$method('lm_config_value',$lm_config_value);
			}
		else {
			$text .= '<input type="text" size="80" name="lm_config_value" value="' . htmlentities($lm_config_value) . '" title="' . strip_tags($lm_config_description) . '"/>';
			} // else
		return $text;
		}

// special config functions
	public function show_image($image,$path = '') {
		if(empty($path)) $path = 'images/upload/';
		$text = '';
		if((!empty($image)) && (is_readable(LM_FS_BASE_DIR . $path . $image))) {
			$text .= '<img height="' . LMC_SMALL_IMAGE_HEIGHT . 'px" src="' . $path . $image . '"/>';
			}
		else $text .= '(No image)';
		return $text;
		} // show_image()

	public function input_image($name,$image,$path = '') {
		if(empty($path)) $path = 'images/upload/';
		$text = '';
		$text .= '<select name="' . $name . '" size="1">';
		if(preg_match('/background/',$path)) $text .= Clm::make_bkgnd_image_select_options($image);
		else $text .= Clm::make_uploaded_image_select_options($image);
		$text .= '</select>' . "\n";
		if((!empty($image)) && (is_readable(LM_FS_BASE_DIR . $path . $image))) {
			$text .= '&nbsp&nbsp' . "\n";
			$text .= '<img height="' . LMC_SMALL_IMAGE_HEIGHT . 'px" src="' . $path . $image . '">';
			$text .= '<input type="checkbox" name="' . $name . '_delet"/> delete image' . "\n";
			} // if
		$text .= '&nbsp&nbsp&nbsp' . "\n";
		$text .= '<input type="file" class="page_config" name="' . $name . '_new" size="40" ' . (!empty($image) ? 'value="' . htmlentities($image) . '" ':'') . ' title="Image or icon (optional). Stored in the ' . $path . ' directory"/>' . "\n";
		return $text;
		} // input_image()

	public function get_image($name,$image,$path = '') {
		if(empty($path)) $path = 'images/upload/';
		if((isset($_FILES[$name . '_new']['name'])) &&
			(!empty($_FILES[$name . '_new']['name']))) { // check image location
			$tmp_name = $_FILES[$name . '_new']['tmp_name'];
			$filename = LM_FS_BASE_DIR . $path . $_FILES[$name . '_new']['name'];
			if(move_uploaded_file($tmp_name, $filename)) {
				@chmod($filename,0664);
				if(strlen(INI_GROUP_PERMISSIONS)) chgrp($filename, INI_GROUP_PERMISSIONS);
				$image = $_FILES[$name . '_new']['name'];
				} // if
			} // if
		else if((isset($_POST[$name . '_delete'])) && ($_POST[$name . '_delete'] == 'on')) {
			$image = '';
			} // if
		else if((isset($_POST[$name])) &&
			(!empty($_POST[$name]))) {
			$image = $_POST[$name];
			if($image == "-1") $image = '';
			} // else if
		return $image;
		} // get_image()

	public function show_txt_file($file,$path = '') {
		if(empty($path)) $path = 'temp/';
		$text = '';
		if((!empty($file)) && (is_readable(LM_FS_BASE_DIR . $path . $file))) {
			$text .= readfile(LM_FS_BASE_DIR . $path . $file);
			}
		else $text .= '(No text)';
		return $text;
		} // show_txt_file()

	public function input_txt_file($name,$file,$path = '') {
		if(empty($path)) $path = 'temp/';
		$text = '';
		$text .= '<input type="file" class="page_config" name="' . $name . '_new" size="40" ' . (!empty($file) ? 'value="' . htmlentities($file) . '" ':'') . ' title="Text (optional). Stored in the ' . $path . ' directory"/>' . "\n";
		return $text;
		} // input_txt_file()

	public function get_txt_file($name,$file,$path = '') {
		if(empty($path)) $path = 'temp/';
		if((isset($_FILES[$name . '_new']['name'])) &&
			(!empty($_FILES[$name . '_new']['name']))) { // check image location
			$tmp_name = $_FILES[$name . '_new']['tmp_name'];
			if(!empty($file)) $filename = $file;
			else $filename = LM_FS_BASE_DIR . $path . $_FILES[$name . '_new']['name'];
			if(move_uploaded_file($tmp_name, $filename)) {
				@chmod($filename,0664);
				if(strlen(INI_GROUP_PERMISSIONS)) chgrp($filename, INI_GROUP_PERMISSIONS);
				$file = $filename;
				} // if
			} // if
		else if((isset($_POST[$name])) &&
			(!empty($_POST[$name]))) {
			$file = $_POST[$name];
			} // else if
		return $file;
		} // get_txt_file()

	public function get_url($name,$url) {
		if(isset($_POST[$name])) $url = html_entity_decode($_POST[$name]);
		if(empty($url)) return '';

		$p = parse_url($url);
		if((!isset($p['scheme'])) || (empty($p['scheme']))) {
			if(!isset($p['host'])) {
				// try the front part
				$h = strtolower(preg_replace('/\/.*/', '', $p['path']));
				if(!empty($h)) {
					if((substr($h, 1, 3) == 'www') ||	// guess ???
						(checkdnsrr($h,'A'))) {	// lookup
						$p['scheme'] = 'http'; // default
						$p['host'] = $h;
						$p['path'] = substr($p['path'],strlen($h));
						} // if
					} // if
				// else leave it
				} // if
			} // if

		$url = '';
		if((isset($p['host'])) && (!empty($p['host']))) {
			$url .= $p['scheme'] . '://';
			$url .= $p['host'];
			} // if
		if((isset($p['port'])) && ((int)$p['port'] > 0)) $url .= ':' . $p['port'];
		if((isset($p['path'])) && (!empty($p['path']))) $url .= $p['path'];
		if((isset($p['query'])) && (!empty($p['query']))) $url .= '?' . $p['query'];

		return $url;
		} // get_url()

	public function get_email($name,$email) {
		if(isset($_POST[$name])) $email = html_entity_decode($_POST[$name]);
		if(empty($email)) return '';

		$h = preg_replace('/.*@/', '', $email);
		$u = preg_replace('/@.*/', '', $email);
		if(empty($h)) {
			Clm::addMsg('Email address missing host.');
			return '';
			} // if
		if(empty($u)) {
			Clm::addMsg('Email address missing username.');
			return '';
			} // if
		if(!checkdnsrr($h,'MX')) {	// lookup
			Clm::addMsg('Email host "' . $h . '" has no MX record.','warning');
			// return '';
			} // if
		$email = $u . '@' . $h;
		return $email;
		} // get_email()

	public function get_sanitized_text($name,$value = '') {	// cleans the text, mainly for use in meta values
		$text = ''; $value = trim($value);
		if((isset($_POST[$name])) && (!empty($_POST[$name]))) {
			$text = html_entity_decode($_POST[$name]);
			} // if
		else if(!empty($value)) $text = $value;
		if(empty($text)) return '';
		$search_strs = array(
			'/[<>]/',
			'/[\\n]/',
			);
		$text = preg_replace($search_strs, ' ', $text);
		$text = htmlentities($text, ENT_QUOTES, INI_CHAR_SET);
		return $text;
		} // get_sanitized_text()

} // Clmc
