<?php

// $Id: logger.php 313 2015-05-20 03:24:03Z robert0609 $
// Copyright BRAEWORKS (R) 2013

/**
 * Description of logger
 *
 * @author robert0609
 */

class CLogger extends Cmsgs {
    //put your code here
	protected static $m_csLogFilename = '';
	private static $m_bsInUse = false;
	private static $m_ssBuffr = array();

	function __construct($log = '') {
		parent::__construct();
		if(!empty($log)) {
			self::$m_csLogFilename = $log;
			} // if
		if(empty(self::$m_csLogFilename)) {
			self::addMsg('No log file.','warning');
			return;
			} // if
		if(!is_writable(self::$m_csLogFilename)) {	// create it
			$fh = fopen(self::$m_csLogFilename, 'w');
			if($fh) {
				fclose($fh);
				$group = $this->get_fs_group();
				if(!empty($group)) chgrp(self::$m_csLogFilename,$group);
				@chmod(self::$m_csLogFilename,0660);
				if(Clm::is_admin_user()) self::addMsg('Started new "' . basename(self::$m_csLogFilename) . '".','info');
				} // if
			} // if
		} // __construct()

	function  __destruct() {
		parent::__destruct();
		} // __destruct()

	public function get_fs_group() { return ''; } // get_fs_group(), virtual function

	public function logEvent($msg) {
		if(empty(self::$m_csLogFilename)) return false;
		if(empty($msg)) return false;
		$prefix = date('Ymd-Hms ');
		if(self::$m_bsInUse) {
			self::$m_ssBuffr[] = $prefix . $msg . "\n";
			} // if
		else {
			self::$m_bsInUse = true;
			error_log($prefix . $msg . "\n",3,self::$m_csLogFilename);
			$i = 0;
			while($i < count(self::$m_ssBuffr)) {
				if(strlen(self::$m_ssBuffr[$i])) {
					error_log(self::$m_ssBuffr[$i],3,self::$m_csLogFilename);
					self::$m_ssBuffr[$i] = '';
					} // if
				$i++;
				} // while
			self::$m_ssBuffr = array();	//?? multithreading
			self::$m_bsInUse = false;
			} // else
		return true;
		} // logEvent()
} // CLogger

