<?php
	// $Id: configure.php 410 2016-10-11 13:04:28Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

// general program definition constants
define("LM_TRUE",			true);			// general TRUE define
define("LM_FALSE",			false);			// generaln FALSE define
define("LM_YES",			LM_TRUE);		// general YES define
define("LM_NO",				LM_FALSE);		// general NO define
// define("LM_DEBUG",			LM_FALSE);		// LM_TRUE to debug, LM_FALSE for normal operation

define("LM_PROJECT_NAME",	"Links Manager");	// Define the project name
define("LM_PROJECT_SHORTNAME",	"BW-LM");	// Define the project abreviated name
define("LM_PROJECT_VERSION", "V0.38");		// Define the project version

//define general stuff
define("LM_FS_BASE_DIR",	str_replace('\\','/',dirname(dirname(__FILE__))) . '/');	// the web page file base, must be LINUX and Windows compatible
// echo LM_FS_BASE_DIR; // test (turn of compression to see)
define("LM_LOCAL_TOOLS_FOLDER", 'localtools');
define("LM_FS_INCLUDES_DIR", LM_FS_BASE_DIR . 'includes/');
define("LM_FS_CLASSES_DIR",	LM_FS_INCLUDES_DIR . 'classes/');
define("LM_FS_SQLITE_DIR",	LM_FS_INCLUDES_DIR . 'sqlite/');
define("LM_FS_EXPORT_DIR",	LM_FS_BASE_DIR . 'export/');
define("LM_FS_IMPORT_DIR",	LM_FS_BASE_DIR . 'import/');
define("LM_FS_VARIABLES_DIR", LM_FS_BASE_DIR . "variables/");
define("LM_FS_TRASH_DIR",	LM_FS_BASE_DIR . "Trash/");

define("LM_ACCESS_CNTR", LM_FS_VARIABLES_DIR . "LinksManagerAccessCntr.dat");

define("LM_SESSION_NAME",	"LMid");		// session id index

define("LM_FS_CONFIG",		LM_FS_INCLUDES_DIR . 'ini/lm.ini');
define("LM_FS_CONFIG_DEFAULT",LM_FS_INCLUDES_DIR . 'ini/lm.defaults.ini');
define("LM_FS_CONFIG_MSGS",	LM_FS_INCLUDES_DIR . 'ini/lm.comments.ini');

define('LM_NL', "<br>\n");

if(isset($_SERVER['SERVER_NAME'])) {	// running as a web app
	//	site status definition
	define("LM_WS_DIR",			((isset($_SERVER['PHP_SELF']) && (strlen(dirname($_SERVER['PHP_SELF'])) > 2)) ? substr(dirname($_SERVER['PHP_SELF']),1) . '/':''));	// folder on server with web pages, usually the web pages alias setting
	define("LM_SITE_TYPE",		(($_SERVER['SERVER_PORT'] == 80) ? 'NO_SSL':'SSL'));

	define("LM_DOMAIN",			$_SERVER['SERVER_NAME']);
	define("LM_DOMAIN_IP",		$_SERVER['SERVER_ADDR']);

	define("LM_WWW_URL",		"http://" . LM_DOMAIN . '/' . LM_WS_DIR);
	define("LM_SSL_URL",		"https://" . LM_DOMAIN . '/' . LM_WS_DIR);
	} // if
else if((defined('CLI_MODE')) && (CLI_MODE) && (!isset($SERVER))) { // running in CLI
	//	cli status definition
	global $_SERVER;
	$_SERVER = array(
		'HTTP_USER_AGENT' => 'cli',
		);

	define("LM_WS_DIR",		'');	// folder on server with web pages, usually the web pages alias setting
	define("LM_SITE_TYPE",		'NO_SSL');

	define("LM_DOMAIN",		'CLI');
	define("LM_DOMAIN_IP",		'10.10.10.10');

	define("LM_WWW_URL",		"http://" . LM_DOMAIN . '/' . LM_WS_DIR);
	define("LM_SSL_URL",		"https://" . LM_DOMAIN . '/' . LM_WS_DIR);
	} // else if
else { // ?? what am I doing ???
	echo "HOST ERROR: Cannot determine set up requirements.\n";
	if(isset($_SERVER)) {
		echo "\n" . "Server variables " . '($_SERVER)' . ":" . "\n";
		var_dump($_SERVER);
		} // if
	exit(1);
	} // else

define("LM_LOGIN_COOKIE_NAME", preg_replace('/[\/.,\\ ]?/', '_', LM_WS_DIR) . '_LM_Login_id');

define("LM_LOGS_DIR",		LM_FS_BASE_DIR . "logs/");
define("LM_LOG_FILE",		LM_LOGS_DIR . LM_DOMAIN . '_LinksManager-' . date('Ymd') . '.log');
define("FILE_ERROR_LOG",	LM_LOGS_DIR . LM_DOMAIN . '_error_php-' . date('Ymd') . '.log');
ini_set('log_errors','On');
ini_set('error_log',FILE_ERROR_LOG);

// set no data base login creds
define("LM_DEFAULT_ADMIN",		'admin');
define("LM_DEFAULT_PASSWORD",	md5('password'));

// set login ttl
define("LM_USER_TIMEOUT_SECS",	(2 * 3600));	// 2 hours
define("LM_USER_COOKIE_TIMEOUT_SECS",	(3600 * 24 * 90));	// 90 days

// Web Browser Compatibility
define('LM_BROWSER_MATRIX',	LM_FS_INCLUDES_DIR . 'LM_Web_Browser_Compatibility_Matrix.csv');

