<?php
	// $Id: filtered_page.php 389 2016-04-26 20:24:17Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

?>

<?php Clm::page_start_comment(__FILE__); ?>
<table class="page_body">
	<?php if(Clm::is_browser_html5()) echo '<caption>The page contents</caption>'; ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_body_msgs">
		<td class="page_body_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
<?php
$layout_data = Clm_filter::find_sections_links_layout();	// generates a heirachical array of required links
$section_cnt = 0; $links_cnt = 0;
foreach($layout_data as $s_id => $sect) {
		if(!is_numeric($s_id)) continue;
		$section = $sect['data'];
		$section_cnt++;
?>
	<tr class="page_body">
		<td class="page_body">
			<table class="section_body">
				<?php if(Clm::is_browser_html5()) echo '<caption>Section ' . $section['lm_section_name'] . '</caption>'; ?>
				<tr class="section_body">
					<td class="section_body">
						<table>
							<?php if(Clm::is_browser_html5()) echo '<caption> </caption>'; ?>
							<tr class="section_body">
								<td class="section_body" style="text-align: left" width="<?php echo ((int)LMC_SMALL_IMAGE_HEIGHT * 3); ?>px">
<?php							if((!empty($section['lm_section_image_url']))) { ?>
									<img height="<?php echo LMC_SMALL_IMAGE_HEIGHT; ?>" src="images/upload/<?php echo $section['lm_section_image_url']; ?>">
<?php								} else echo '&nbsp;'; ?>
								</td>
								<th class="section_body" style="text-align: left">
									<h2<?php echo (!empty($section['lm_section_title']) ? ' title="' . strip_tags($section['lm_section_title']) . '"':''); ?>>
										<?php echo $section['lm_section_name']; ?>
									</h2>
								</th>
								<td class="section_body" style="text-align: left">
<?php							if(!empty($section['lm_section_description'])) { ?>
									<small><?php echo $section['lm_section_description']; ?></small>
<?php								} else echo '&nbsp;'; ?>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr class="section_body">
					<td class="section_body">
						<table class="link_body">
							<?php if(Clm::is_browser_html5()) echo '<caption>Links for ' . $section['lm_section_name'] . '</caption>'; ?>
<?php 						$left_margin = 5;	?>

							<tr class="link_body" valign="top" style="text-align: center;">
								<td width="<?php echo $left_margin; ?>%" class="link_body">&nbsp;</td>
<?php
						$cell_width = (int)((100 - $left_margin)/(empty($section['lm_section_columns']) ? 2:$section['lm_section_columns']));
						$cnt = 0;
						$columns = 0;
						foreach($sect as $l_id => $lk) {
							if(!is_numeric($l_id)) continue;	// skip over section data
							$links_cnt++;
							$columns++;
							$cnt++;
							$link = $lk['data'];
?>
								<td class="link_body" width="<?php echo $cell_width;?>%">
									<?php echo Clm::get_link_html($link); ?>
								</td>
<?php
							if($columns >= $section['lm_section_columns']) {
								$columns = 0;
?>
							</tr>
							<tr class="link_body" valign="top" style="text-align: center;">
								<td width="<?php echo $left_margin; ?>%" class="link_body">&nbsp;</td>
<?php
								} // if
							} // foreach
						while($columns < $section['lm_section_columns']) {	// finish last row
?>
								<td class="link_body" width="<?php echo $cell_width; ?>%">&nbsp;</td>
<?php
							$columns++;
							} // while
?>
							</tr>
<?php
						if(!$cnt) echo '<tr class="link_body"><td colspan="' . $section['lm_section_columns'] . '" class="link_body" style="text-align: left">(No links available in this section)</td></tr>' . "\n";
?>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
<!--	<tr class="page_body"><td class="page_body">&nbsp;</td></tr>-->
<?php
	} // foreach

if(!$section_cnt) {
?>
	<tr class="page_body">
		<td class="page_body" style="text-align: center;">
			(No results found.)
		</td>
	</tr>
<?php	} // if
else if(LMC_FILTER_STAT) {
?>
	<tr class="page_body">
		<td class="page_body" style="text-align: right;">
<?php
		echo 'Total of ' . $section_cnt . (($section_cnt > 1) ? ' sections':' section') , ' with ' . $links_cnt . (($links_cnt > 1) ? ' links.':' link.');
?>
		</td>
	</tr>
<?php	} // if ?>

</table>

<?php Clm::page_end_comment(__FILE__); ?>
