/*
	$Id: main_styles.css.php 390 2016-04-27 13:48:39Z robert0609 $
	Document   : main_styles
    Description:
        Purpose of the stylesheet follows.
		Main styles styles for common styles.
		<?php echo $gen_note; ?>

	Syntax recommendation http://www.w3.org/TR/REC-CSS2/
*/

/* standard stuff */
html {
	}

body {
<?php if(!empty($theme['ThemeSettings']['BODY_BKGD_IMAGE'])) { ?>
	background-image: url("<?php echo 'images/backgrounds/' . $theme['ThemeSettings']['BODY_BKGD_IMAGE']; ?>");
	background-repeat: no-repeat;
	background-attachment: fixed;
	background-size: cover;
<?php } else { ?>
	background-color: <?php echo $theme['ThemeSettings']['BODY_BKGD_COLOUR']; ?>;
<?php } // else ?>
	font-family:	<?php echo $theme['ThemeSettings']['FONT_FAMILY']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	font-style:		<?php echo $theme['ThemeSettings']['FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['FONT_WEIGHT']; ?>;
	color:			<?php echo $theme['ThemeSettings']['FONT_COLOUR']; ?>;
	margin:		0px;
	padding:	0px;
	}

div {
	}

caption {	/* make captions invisible to seeing, but useful to sight impaired */
	height: 0px;
	width: 0px;
	visibility: hidden;
	}

iframe {
	width:		100%;
	border:		0px;
	}

font {
	font-family:	<?php echo $theme['ThemeSettings']['FONT_FAMILY']; ?>;
	font-style:		<?php echo $theme['ThemeSettings']['FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	color:			<?php echo $theme['ThemeSettings']['FONT_COLOUR']; ?>;
	}

a, a:active, a:link, a:visited {
	font-family:	inherit;
	font-size:		inherit;
	color:			inherit;
	text-decoration: none;
	}

a:hover {
	font-family:	inherit;
	color:			<?php echo $theme['ThemeSettings']['ANCHOR_HOVER_COLOUR']; ?>;
	text-decoration: underline;
	}

p {
	background-color: inherit;
	font-family:inherit;
	font-weight: normal;
	font-size:	inherit;
	color:		inherit;
	text-align: left;
	text-decoration: none;
	padding-bottom: 8px;
	padding-top:	2px;
	padding-left:	0px;
	padding-right:	0px;
	margin:			0px;
	}

h1 {
	font-family:	<?php echo $theme['ThemeSettings']['H1_FONT_FAMILY']; ?>;
	color: inherit;
	font-size: <?php echo $theme['ThemeSettings']['H1_FONT_SIZE']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['H1_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['H1_FONT_WEIGHT']; ?>;
	text-align: left;
	text-decoration: underline;
	padding-top: 10px;
	padding-bottom: 4px;
	padding-left:	0px;
	padding-right:	0px;
	margin:			0px;
	}

h2 {
	font-family:	<?php echo $theme['ThemeSettings']['H2_FONT_FAMILY']; ?>;
	color: inherit;
	font-weight: bold;
	font-size: <?php echo $theme['ThemeSettings']['H2_FONT_SIZE']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['H2_FONT_STYLE']; ?>;
	font-weight:	<?php echo $theme['ThemeSettings']['H2_FONT_WEIGHT']; ?>;
	text-align: left;
	text-decoration: underline;
	padding-top: 10px;
	padding-bottom: 2px;
	padding-left:	0px;
	padding-right:	0px;
	margin:			0px;
	}

h3 {
	font-family:	<?php echo $theme['ThemeSettings']['H3_TH_FONT_FAMILY']; ?>;
	color: inherit;
	font-size: <?php echo $theme['ThemeSettings']['H3_TH_FONT_SIZE']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['H3_TH_FONT_STYLE']; ?>;
	font-weight:	<?php echo $theme['ThemeSettings']['H3_TH_FONT_WEIGHT']; ?>;
	text-align: left;
	text-decoration: none;
	padding-top: 10px;
	padding-bottom: 0px;
	padding-left:	0px;
	padding-right:	0px;
	margin:			0px;
	}

img {
	border: 0px;
	padding: 0px;
	margin: 0px;
	text-decoration: none;
	}

img.logo {
<?php	// adjust logo height so it fits header
	$hh = (int)preg_replace('/[a-z]*$/i', '',  $theme['ThemeSettings']['HEADER_HEIGHT']);
	$lh = (int)preg_replace('/[a-z]*$/i', '',  $theme['ThemeSettings']['LOGO_HEIGHT']);
	$pad = 5;
	if((($hh - $pad - $pad) > 0) && ($lh > ($hh - $pad - $pad))) {
		$lh = $hh - $pad - $pad;
		Clm::addMsg('Login height reduced to ' . $lh . 'px to fit into header.','warning');
		} // if
	else if(($hh - $pad - $pad) <= 0) {
		$lh = 0;
		Clm::addMsg('Login height too large to fit into header.','error');
		} // else if
	// else ok
?>
	height: <?php echo $lh . 'px'; ?>;
	vertical-align: bottom;
	text-decoration: none;
	}

img.manual {
	border:	2px solid gray;
	padding: 5px;
	margin: 5px;
	text-decoration: none;
	}

form {
	display: inline;
	}

input[type='file'] {
	border:		<?php echo $theme['ThemeSettings']['LINK_BORDER']; ?>;
	border-radius: 0.5em;
	padding: 5px 8px;
	outline: none;
	}

select {
	text-align: center;
	}

option {
	text-align: left;
	}

lu {
	background-color: inherit;
	font-family:inherit;
	font-weight: normal;
	font-size:	inherit;
	color:		inherit;
	text-align: left;
	text-decoration: none;
	padding-bottom: 0px;
	padding-top:	0px;
	padding-left:	0px;
	padding-right:	0px;
	margin:			0px;
	}

li {
	background-color: inherit;
	font-family:inherit;
	font-weight: normal;
	font-size:	inherit;
	color:		inherit;
	text-align: left;
	text-decoration: none;
	padding-bottom: 2px;
	padding-top:	0px;
	padding-left:	0px;
	padding-right:	0px;
	margin:			5px;
	list-style-type: disc;
	}

table {
	background-color: inherit;
	font-family:	inherit;
	font-style:		inherit;
	font-weight:	inherit;
	font-size:		inherit;
	color:		inherit;
	padding:	0px;
	border:		0px;
	margin:		0px;
	width:		100%;
	border:		0px;
	border-radius: <?php echo $theme['ThemeSettings']['BORDER_RADIUS']; ?>;
	-webkit-user-select: none;
	-webkit-border-radius: <?php echo $theme['ThemeSettings']['BORDER_RADIUS']; ?>;
/*	-moz-border-radius: <?php echo $theme['ThemeSettings']['BORDER_RADIUS']; ?>; */
	}

th {
	background-color: inherit;
	border:			0px;
	color:			inherit;
	font-family:	inherit;
	font-size:		<?php echo $theme['ThemeSettings']['H3_TH_FONT_SIZE']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['H3_TH_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['H3_TH_FONT_WEIGHT']; ?>;
	text-align:		left;
	padding:		0px;
	margin:			0px;
	border:			0px;
	}

tr, td {
	background-color: inherit;
	border:			0px;
	color:			inherit;	/* show the inherited, try red */
	font-family:	inherit;
	font-weight:	inherit;
	font-size:		inherit;
	padding:		0px;
	margin:			0px;
	border:			0px;
	}

table.page_top {
<?php if(!empty($theme['ThemeSettings']['HEADER_BKGD_IMAGE'])) { ?>
	background-image: url("<?php echo 'images/backgrounds/' . $theme['ThemeSettings']['HEADER_BKGD_IMAGE']; ?>");
	background-repeat: no-repeat;
	background-attachment: local;
	background-size: 100% 100%;
<?php } else { ?>
	background-color: <?php echo $theme['ThemeSettings']['HEADER_BKGD_COLOUR']; ?>;
<?php } // else ?>
	font-family:	<?php echo $theme['ThemeSettings']['HEADER_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['HEADER_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['HEADER_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['HEADER_FONT_SIZE']; ?>;
	color:		<?php echo $theme['ThemeSettings']['HEADER_FONT_COLOUR']; ?>;
	padding:	0px;
	border:		<?php echo $theme['ThemeSettings']['HEADER_BORDER']; ?>;
	margin:		0px;
	width:		100%;
	height:		<?php echo $theme['ThemeSettings']['HEADER_HEIGHT']; ?>;   /* Height of the header */
	}

th.page_top {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	text-align:		left;
	}

tr.page_top, td.page_top {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	}

table.page_container {
	background-color: inherit;
	color:		inherit;
	border:		0px;
	font-family:	inherit;
	padding:	1px;
	margin:		0px;
	width:		100%;
	}

table.left_container {
	background-color: inherit;
	color:		inherit;
	border:		0px;
	font-family:	inherit;
	padding:	1px;
	margin:		0px;
	width:		<?php echo $theme['ThemeSettings']['LEFT_WIDTH']; ?>;
	}

tr.page_container,
tr.left_container {
	background-color: inherit;
	}

td.page_container,
td.left_container {
	background-color: inherit;
	color:			inherit;
	padding:		0px;
	font-family:	inherit;
	}

span.admin-right-floating-box {
	background-color: <?php echo $theme['ThemeSettings']['ADMIN_DB_BKGD_COLOUR']; ?>;
	color:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['ADMIN_DB_BORDER']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_SIZE']; ?>;
	cursor: pointer;
	position: fixed;
	top: 50%;
	right: 30px;
	margin: 5px;
	padding: 2px;
	border-radius: 0.5em;
	-webkit-user-select: none;
	-webkit-border-radius: 0.5em;
/*	-moz-border-radius: 0.5em; */
	}

span.admin-left-floating-box {
	background-color: <?php echo $theme['ThemeSettings']['ADMIN_DB_BKGD_COLOUR']; ?>;
	color:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['ADMIN_DB_BORDER']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_SIZE']; ?>;
	cursor: pointer;
	position: fixed;
	left: 30px;
	top: 50%;
	margin: 5px;
	padding: 2px;
	border-radius: 0.5em;
	-webkit-user-select: none;
	-webkit-border-radius: 0.5em;
/*	-moz-border-radius: 0.5em; */
	}

table.admin_db_container {
	background-color: <?php echo $theme['ThemeSettings']['ADMIN_DB_BKGD_COLOUR']; ?>;
	color:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['ADMIN_DB_BORDER']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['ADMIN_DB_FONT_SIZE']; ?>;
	padding:	1px;
	margin:		0px;
	}

tr.admin_db_container_odd {
	background-color: <?php echo Clm::get_row_bkgnd_colour(false,$theme['ThemeSettings']['ADMIN_DB_BKGD_COLOUR'],$theme['ThemeSettings']['ODD_EVEN_ROW_CHG']); ?>;
	}

tr.admin_db_container_even {
	background-color: <?php echo Clm::get_row_bkgnd_colour(true,$theme['ThemeSettings']['ADMIN_DB_BKGD_COLOUR'],$theme['ThemeSettings']['ODD_EVEN_ROW_CHG']); ?>;
	}

tr.admin_db_container {
	background-color: inherit;
	}

th.admin_db_container {
	background-color: inherit;
	color:			inherit;
	padding:		0px;
	font-family:	inherit;
	font-weight:	bold;
	text-align:		left;
	white-space:	<?php echo (($theme['ThemeSettings']['ADMIN_DB_NOWRAP_BOOL'] == 'true') ? 'nowrap':'normal'); ?>;
	}

td.admin_db_container {
	background-color: inherit;
	color:			inherit;
	padding:		0px;
	font-family:	inherit;
	text-align:		right;
	white-space:	<?php echo (($theme['ThemeSettings']['ADMIN_DB_NOWRAP_BOOL'] == 'true') ? 'nowrap':'normal'); ?>;
	}

table.tools_db_container {
	background-color: <?php echo $theme['ThemeSettings']['TOOLS_DB_BKGD_COLOUR']; ?>;
	color:		<?php echo $theme['ThemeSettings']['TOOLS_DB_FONT_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['TOOLS_DB_BORDER']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['TOOLS_DB_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['TOOLS_DB_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['TOOLS_DB_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['TOOLS_DB_FONT_SIZE']; ?>;
	padding:	1px;
	margin:		0px;
	}

tr.tools_db_container {
	background-color: inherit;
	}

tr.tools_db_container_odd {
	background-color: <?php echo Clm::get_row_bkgnd_colour(false,$theme['ThemeSettings']['TOOLS_DB_BKGD_COLOUR'],$theme['ThemeSettings']['ODD_EVEN_ROW_CHG']); ?>;
	}

tr.tools_db_container_even {
	background-color: <?php echo Clm::get_row_bkgnd_colour(true,$theme['ThemeSettings']['TOOLS_DB_BKGD_COLOUR'],$theme['ThemeSettings']['ODD_EVEN_ROW_CHG']); ?>;
	}

th.tools_db_container {
	background-color: inherit;
	color:			inherit;
	padding:		0px;
	font-family:	inherit;
	font-weight:	bold;
	text-align:		left;
	white-space:	<?php echo (($theme['ThemeSettings']['TOOLS_DB_NOWRAP_BOOL'] == 'true') ? 'nowrap':'normal'); ?>;
	}

td.tools_db_container {
	background-color: inherit;
	color:			inherit;
	padding:		0px;
	font-family:	inherit;
	text-align:		right;
	white-space:	<?php echo (($theme['ThemeSettings']['TOOLS_DB_NOWRAP_BOOL'] == 'true') ? 'nowrap':'normal'); ?>;
	}

table.left_column {
	background-color: <?php echo $theme['ThemeSettings']['LEFT_BKGD_COLOUR']; ?>;
	color:		<?php echo $theme['ThemeSettings']['LEFT_FONT_COLOUR']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['LEFT_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['LEFT_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['LEFT_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['LEFT_FONT_SIZE']; ?>;
	padding-top: 5px;
	padding-bottom: 5px;
	padding-left: 0px;
	padding-right: 0px;
	border:		<?php echo $theme['ThemeSettings']['LEFT_BORDER']; ?>;
	margin:		0px;
	width:		100%;
	}

tr.left_column {
	background-color: inherit;
	}

th.left_column {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		italic;
	}

td.left_column {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	normal;
	font-style:		normal;
	}

table.page_body {
	background-color: inherit;
	font-family:	inherit;
	padding:	0px;
	border:		0px;
	margin:		0px;
	width:		100%;
	}

tr.page_body {
	background-color: inherit;
	}

tr.page_body_odd {
	background-color: <?php echo Clm::get_row_bkgnd_colour(false,$theme['ThemeSettings']['BODY_BKGD_COLOUR'],$theme['ThemeSettings']['ODD_EVEN_ROW_CHG']); ?>;
	}

tr.page_body_even {
	background-color: <?php echo Clm::get_row_bkgnd_colour(true,$theme['ThemeSettings']['BODY_BKGD_COLOUR'],$theme['ThemeSettings']['ODD_EVEN_ROW_CHG']); ?>;
	}

th.page_body {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		normal;
	text-align:		left;
	padding:		0px;
	margin:			0px;
	}

td.page_body, span.page_body {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	normal;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	padding:		0px;
	margin:			0px;
	}

tr.page_body_msgs, th.page_body_msgs,
td.page_body_msgs, span.page_body_msgs {
	background-color: inherit;
	color:			white;
	padding:		5px;
	font-family:	inherit;
	}

table.section_body {
	background-color: <?php echo $theme['ThemeSettings']['SECTION_BKGD_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['SECTION_BORDER']; ?>;
	color:		<?php echo $theme['ThemeSettings']['SECTION_FONT_COLOUR']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['SECTION_FONT_FAMILY']; ?>;
	font-size:	<?php echo $theme['ThemeSettings']['SECTION_FONT_SIZE']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['SECTION_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['SECTION_FONT_WEIGHT']; ?>;
	padding:	0px;
	margin:		0px;
	width:		100%;
	}

tr.section_body {
	background-color: inherit;
	}

th.section_body {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		normal;
	font-size:		inherit;
	text-align:		left;
	padding:		0px;
	}

td.section_body, span.section_body,
a.section_body,  a.section_body:active, a.section_body:link, a.section_body:visited,
h1.section_body, h2.section_body, h3.section_body  {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	normal;
	font-size:		<?php echo $theme['ThemeSettings']['SECTION_FONT_SIZE']; ?>;
	padding:		0px;
	}

table.link_body {
	background-color: <?php echo $theme['ThemeSettings']['LINK_BKGD_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['LINK_BORDER']; ?>;
	color:		<?php echo $theme['ThemeSettings']['LINK_FONT_COLOUR']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['LINK_FONT_FAMILY']; ?>;
	font-size:	<?php echo $theme['ThemeSettings']['LINK_FONT_SIZE']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['LINK_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['LINK_FONT_WEIGHT']; ?>;
	padding:	0px;
	margin:		0px;
	width:		100%;
	}

tr.link_body {
	background-color: inherit;
	}

th.link_body {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		normal;
	font-size:		inherit;
	text-align:		left;
	padding:		0px;
	}

td.link_body, span.link_body,
a.link_body, a.link_body:active, a.link_body:link, a.link_body:visited,
h1.link_body, h2.link_body, h3.link_body {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	normal;
	font-size:		<?php echo $theme['ThemeSettings']['LINK_FONT_SIZE']; ?>;
	padding:		5px;
	}

input[type='file'].page_config {
	border:		2px solid gray;
	border-radius: 0.5em;
	padding: 5px 8px;
	outline: none;
	}

table.page_config {
	background-color: ivory;
	color:		black;
	border:		2px solid gray;
	font-family:	inherit;
	font-style:		normal;
	font-size:		inherit;
	padding:	3px;
	margin:		0px;
	width:		100%;
	}

tr.page_config {
	background-color: inherit;
	}

tr.page_config_odd {
	background-color: #F1F1E4;
	}

tr.page_config_even {
	background-color: #FFFFFB;
	}

tr.page_config_odd:hover,
tr.page_config_even:hover {
	background-color: inherit;
	}

th.page_config {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		normal;
	text-align:		left;
	padding:		5px 0px 5px 0px;
	margin:			0px;
	}

td.page_config, span.page_config {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	normal;
	font-size:		10px;
	padding:		5px 0px 5px 0px;
	margin:			0px;
	}

tr.page_config_msgs, th.page_config_msgs,
td.page_config_msgs, span.page_config_msgs {
	background-color: inherit;
	color:			white;
	padding:		5px 0px 5px 0px;
	font-family:	inherit;
	}

table.page_bottom {
<?php if(!empty($theme['ThemeSettings']['FOOTER_BKGD_IMAGE'])) { ?>
	background-image: url("<?php echo 'images/backgrounds/' . $theme['ThemeSettings']['FOOTER_BKGD_IMAGE']; ?>");
	background-repeat: no-repeat;
	background-attachment: local;
	background-size: 100% 100%;
<?php } else { ?>
	background-color: <?php echo $theme['ThemeSettings']['FOOTER_BKGD_COLOUR']; ?>;
<?php } // else ?>
	color:		<?php echo $theme['ThemeSettings']['FOOTER_FONT_COLOUR']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['FOOTER_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['FOOTER_FONT_STYLE']; ?>;
	font-weight:		<?php echo $theme['ThemeSettings']['FOOTER_FONT_WEIGHT']; ?>;
	font-size:		<?php echo $theme['ThemeSettings']['FOOTER_FONT_SIZE']; ?>;
	padding:	0px;
	border:		<?php echo $theme['ThemeSettings']['FOOTER_BORDER']; ?>;
	margin:		0px;
	width:		100%;
	height:		<?php echo $theme['ThemeSettings']['FOOTER_HEIGHT']; ?>;   /* Height of the header */
	}

th.page_bottom {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	bold;
	}

tr.page_bottom, td.page_bottom {
	background-color: inherit;
	font-family:	inherit;
	font-weight:	lighter;
	}

span.msg_info {
	background-color: white;
	font-family:	inherit;
	font-weight:	normal;
	font-style:		italic;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	color:			black;
	}

span.msg_success {
	background-color: greenyellow;
	font-family:	inherit;
	font-weight:	normal;
	font-style:		italic;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	color:			black;
	}

span.msg_warning {
	background-color: yellow;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		italic;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	color:			black;
	}

span.msg_error {
	background-color: red;
	font-family:	inherit;
	font-weight:	bold;
	font-style:		italic;
	font-size:		<?php echo $theme['ThemeSettings']['FONT_SIZE']; ?>;
	color:			white;
	}

.box_outer_tip {
	background-color: inherit;
	color:		inherit;
	font-family: inherit;
	font-size: inherit;
	font-weight: inherit;
	cursor: inherit;
	text-decoration: inherit;
	position: relative;
}

.box_outer_tip span {
	display: none;
	position: absolute;
}

.box_outer_tip:hover span {	/* on tablet devices is assisted by onclick="return true" */
	width: 90px;
	height: auto;
	border-radius: 0.5em;
	display: block;
	position: absolute;
	left: 0px;
	top: 0px;
	z-index: 810;
	padding: 3px;
	margin-left: 0;
}

.box_inner_tip {
	color: <?php echo $theme['ThemeSettings']['LINK_FONT_COLOUR']; ?>;
	font-family: inherit;
	font-size: 10px;
	font-weight: normal;
	outline: none;
	cursor: inherit;
	z-index: 830;
	text-decoration: none;
}

.title_tooltip {
	display:	block;
	background:	<?php echo $theme['ThemeSettings']['TOOLTIP_BKGD_COLOUR']; ?>;
	border:		<?php echo $theme['ThemeSettings']['TOOLTIP_BORDER']; ?>;
	font-family:	<?php echo $theme['ThemeSettings']['FOOTER_FONT_FAMILY']; ?>;
	font-style: <?php echo $theme['ThemeSettings']['TOOLTIP_FONT_STYLE']; ?>;
	font-weight:	<?php echo $theme['ThemeSettings']['TOOLTIP_FONT_WEIGHT']; ?>;
	font-size:	<?php echo $theme['ThemeSettings']['TOOLTIP_FONT_SIZE']; ?>;
	color:		<?php echo $theme['ThemeSettings']['TOOLTIP_FONT_COLOUR']; ?>;
	border-radius: <?php echo $theme['ThemeSettings']['TOOLTIP_BORDER_RADIUS']; ?>;
	-webkit-user-select: none;
	-webkit-border-radius: <?php echo $theme['ThemeSettings']['TOOLTIP_BORDER_RADIUS']; ?>;
/*	-moz-border-radius: <?php echo $theme['ThemeSettings']['TOOLTIP_BORDER_RADIUS']; ?>; */
	padding:	5px;
	margin:		0px;
	z-index:	840;
	position:	relative;
}

/* eof */

