// Revision: $Id: lm_funcs.js 360 2016-04-17 02:26:52Z robert0609 $
// (C) BRAEWORKS 2013, basic javascript functions

	function setCookie(name,value,expires,path,domain,secure) {
		var curCookie = name + "=" + escape(value);	//add the value
		curCookie += ((expires) ? ";expires=" + expires.toGMTString():""); //add expire date
		curCookie += ((path) ? ";path=" + path:"");
		curCookie += ((domain) ? ";domain=" + domain:"");
		curCookie += ((secure) ? ";secure=" + secure:"");
		document.cookie = curCookie;
		} // setCookie()

	function getCookie(name) {
		// array to store the parts & split values
		var cookie = document.cookie;
		// document.write(cookie + "<br><br>");	// test
		var cookieAry = document.cookie.split(";");	// split it into its parts

		//lookup the bits
		var tmpAry = "";	//new Array();
		var sTmp1 = "";
		var sTmp2 = "";
		// document.write(name + "<br><br>");	// test

		for ( var i = 0; i < cookieAry.length; i++) {
			tmpAry = cookieAry[i].split("="); //split around the '='
			sTmp1 = tmpAry[0];
			sTmp2 = tmpAry[1];
			// document.write(sTmp1 + " / " + sTmp2 + "<br>");	// test
			if(sTmp1.search(name) != -1) {
				// document.write("Got it<br>");	// test
				return sTmp2;	// got it
				} // if
			} // for
		return null; // not there
		} // getCookie()

	function deleteCookie(name,path,domain) {
		var valRet = getCookie(name);
		if ( valRet != null) {
	 		var deadCookie = name + "=";
	 		deadCookie += ((path) ? ";path=" + path:"");
	 		deadCookie += ((domain) ? ";domain=" + domain:"");
	 		deadCookie += ";expires=Thu,01-Jan-70 00:00:01 GMT";
			document.cookie = killCookie;
			} // if
		return valRet;
		} // deleteCookie()

	function formatIntNumber(num) {
		var text = "";
		var sep = ',';
		var left = 0;
		num = Math.round(num);
		while(num >= 1000) {
			// get left bit
			left = "000" + (num % 1000);	// get remainder, prefix with 000 for 0 to 99
			if(text.length > 0) text = left.substr(-3) + sep + text;
			else text = left.substr(-3) + text;

			// next 1000
			num /= 1000;
			num = Math.floor(num);
			} // while
		if(num > 0) {
			left = num;
			if(text.length > 0) text = left + sep + text;
			else text = left + text;
			} // if
		return text;
		} // formatIntNumber()

	function scroll2Name(name) {	// scroll selected item into view
		document.getElementsByName(name)[0].scrollIntoView(true);
		} // scroll2Name()

	function showFoundName(name,keywords) {
		scroll2Name(name);
		document.getElementsByName(name)[0].innerHTML = "<span class=\"msg_success\"><img src=\"images/success.gif\">Found here</span>" +
			"&nbsp;&nbsp;<a href=\"index.php?action=edit_search&search=" + keywords + "\" title=\"Search for: " + unescape(keywords) + "\">Return to search.</a><br>";
		} // showFoundName()

	var sleep_timeout = false;
	function sleep(ms) {
		sleep_timeout = false;
		var it_cnt = ms * 30;	// ???? catch all
		setTimeout(function(){ sleep_timeout = true; },ms);
		while((!sleep_timeout) && (it_cnt--)) continue;
		} // sleep()

	function showWorking(feedback_id,flg) {
		if(feedback_id.length <= 0) return;
		var elt = document.getElementById(feedback_id);
		switch(elt.nodeName) {
			case "IMG":
				if(flg) elt.style.display = "inline";
				else elt.style.display = "none";
				break;
			case "DIV":
			case "SPAN":
				if(flg) document.getElementById(feedback_id).innerHTML = 'Working .. <img src="images/ajax-loader.gif">';
				else document.getElementById(feedback_id).innerHTML = '';
			} // switch
		} // showWorking()

	function CajaxOps(ajax_url_op,ajax_feedback_id,ajax_result_id,run_scripts) {	// class to hold the everything
		// works with java.php
		this.self = this;
		var complain = true;
		var ajax_running = false;
		var url_op = ajax_url_op;
		var feedback_id = ajax_feedback_id;
		var result_id = ajax_result_id;
		var run_code = run_scripts;

		this.createRequest = function () {
			var xmlHttp = false;
			var app = navigator.appName;
			var ver = navigator.appVersion;
			if((app != 'Netscape') && (ver <= 7) && (typeof window.ActiveXObject != 'undefined')) {
				xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
			} else if(typeof window.XMLHttpRequest != 'undefined') {
				xmlHttp = new XMLHttpRequest();
				} // else

			if ((!xmlHttp) && (this.complain)) {
				alert('AJAX cannot create request.');
				return false;
				} // if
			return xmlHttp;
			} // createRequest()

		this.doAjaxRequestGET = function (get_data) {
			if(ajax_running) return false;
			var xmlHttp = false;
			if(!(xmlHttp = this.createRequest())) return false;
			ajax_running = true;
			var url = "ajax.php?ajax=" + url_op + encodeURI(get_data);
			showWorking(feedback_id,true);

			xmlHttp.open("GET", url, true);
			xmlHttp.onreadystatechange = function() {
				if(xmlHttp.readyState != 4) return;
				if(xmlHttp.status == 200) {
					showWorking(feedback_id,false);	// do first in case feedback_id and result_id are the same
					if(result_id.length > 0) {
						var elem = document.getElementById(result_id);
						elem.innerHTML = xmlHttp.responseText;
						if(run_code) {	// now execute any sripts and get sources that came down
							var codes = elem.getElementsByTagName("script");
							for(var i = 0; i < codes.length; i++) {
								if (codes[i].src != "") {
									var tag = document.createElement("script");
									tag.src = codes[i].src;
									document.getElementsByTagName("head")[0].appendChild(tag);
									} // if
								else {
									eval(codes[i].text);
									} // else
								} // for
							} // if
						reRunTitles2tooltips();
						} // if
					ajax_running = false;
					} // if
				};
			// kick it off
			xmlHttp.send();	// send null

			// ajax set
			return true;
			} // doAjaxRequestGET()

		this.doAjaxRequestPOST = function (op_data) {
			if(ajax_running) return false;
			var xmlHttp = false;
			if(!(xmlHttp = this.createRequest())) return false;
			ajax_running = true;
			var url = "ajax.php?ajax=" + url_op;
			showWorking(feedback_id,true);

			xmlHttp.open("POST", url, true);
			xmlHttp.onreadystatechange = function() {
				if(xmlHttp.readyState != 4) return;
				if(xmlHttp.status == 200) {
					showWorking(feedback_id,false);	// do first in case feedback_id and result_id are the same
					if(result_id.length > 0) {
						var elem = document.getElementById(result_id);
						elem.innerHTML = xmlHttp.responseText;
						if(run_code) {	// now execute any sripts and get sources that came down
							var codes = elem.getElementsByTagName("script");
							for(var i = 0; i < codes.length; i++) {
								if (codes[i].src != "") {
									var tag = document.createElement("script");
									tag.src = codes[i].src;
									document.getElementsByTagName("head")[0].appendChild(tag);
									} // if
								else {
									eval(codes[i].text);
									} // else
								} // for
							} // if
						reRunTitles2tooltips();
						} // if
					ajax_running = false;
					} // if
				};
			// kick it off
			xmlHttp.send(op_data);	// send data

			// ajax set
			return true;
			} // doAjaxRequestPOST()

		}	// CajaxOps()
	var ajaxOps = [];	// place to save CajaxOps iterations

	function getFound() {
		var obj;
		try {
			obj = document.getElementById('filtered_page');
			var keywords = document.forms["filter"]["keywords"].value;
			if((typeof(obj) != 'undefined') && (obj != null)) {	// do an ajax call
				if(!ajaxOps['getFound']) {
					ajaxOps['getFound'] = new CajaxOps('getFound&filter=','ajax-loader','filtered_page',false);
					} // if';
				ajaxOps['getFound'].doAjaxRequestGET(keywords);	// do it
				// obj.innerHTML = '<span style="color: red">howdy ABC</span>';
				} // if
			} // try
		catch(e) {
			} // catch
		} // getFound()


// EOF

