<?php
	// $Id: about_lm.php 413 2016-10-13 14:04:45Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><?php if(Clm::is_browser_html5()) echo '<caption>Links manager body</caption>'; ?><tr class="page_container"><td class="page_container">
<table class="page_body" style="color: black; background-color: white;">
	<?php if(Clm::is_browser_html5()) echo '<caption>About ' . strip_tags(LM_PROJECT_NAME) . ' page</caption>'; ?>
	<tr class="page_body">
		<th class="page_body">
			<img src="images/bw_logo.gif" alt="bw_logo" title="<?php echo Clm::$version_str; ?>">
		<h1>About BRAEWORKS &reg; <?php echo LM_PROJECT_NAME . ' (' . LM_PROJECT_SHORTNAME . ')' . ' ' . LM_PROJECT_VERSION; ?></h1>
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p>
				<?php echo LM_PROJECT_SHORTNAME; ?> came from the need to have an easy method to add, change and
				delete links and URLs in a development environment, without the need to "hack" the local intranet web site code.
			</p>
			<p>
				<?php echo LM_PROJECT_SHORTNAME; ?> provides settings menus and URL links in sections.
			</p>
			<p>
				A further consideration is to have a common method to link to locally installed tools
				(e.g. WebSVN, Database tools, Regex testers, etc).
			</p>
			<p>
				<?php echo LM_PROJECT_SHORTNAME; ?> also provides a methods for displaying only the necessary content for each user or group.
				A user can log into <?php echo LM_PROJECT_SHORTNAME; ?>.
				Each user can be a member of a number of groups
				and so allows content set for group/s to display the appropriate links.
				A user also be an administrator or a group manager.
			</p>
			<p class="page_body">
				The <a href="index.php?action=lm_manual">Users Manual</a> has more details on the <?php echo LM_PROJECT_SHORTNAME; ?>.
			</p>
			<p>
				As <?php echo LM_PROJECT_SHORTNAME; ?> has been useful, BRAEWORKS has released <?php echo LM_PROJECT_SHORTNAME; ?> to the
				public domain under the <a href="http://www.gnu.org/licenses/gpl-2.0.html">GNU General Public License, version 2</a>.
				You are free to install, share and change <?php echo LM_PROJECT_SHORTNAME; ?> as needs be.
				However, BRAEWORKS suggests that code changes to the released file set be submitted back to <a HREF="mailto:feedback@braeworks.com?Subject=<?php echo rawurlencode(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . ' Changes.'); ?>">BRAEWORKS via email</a>, as there maybe more features added in the meantime.
			</p>
			<p class="page_body">
				The <?php echo LM_PROJECT_SHORTNAME; ?> is a sibling project to the BRAEWORKS Content Management System (CMS).
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			License
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				GNU General Public License, version 2. See "http://www.gnu.org/licenses/gpl-2.0.html"
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			Disclaimer
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p>
				<?php echo LM_PROJECT_SHORTNAME; ?> software and related graphics are provided &quot;AS IS&quot;.
				No warrantees, no guarantees nor suitability for a purpose, are given, expressed nor implied.
			</p>
			<p>
				BRAEWORKS is not responsible for the use of the <?php echo LM_PROJECT_SHORTNAME; ?>
				software and associated documents,
				nor the purpose that <?php echo LM_PROJECT_SHORTNAME; ?> is used.
			</p>
			<p>
				Any links to other web sites and internet resources are provided for convenience
				only and BRAEWORKS does not express, imply nor give any endorsement nor warrantee,
				to any resource provided by links on <?php echo LM_PROJECT_SHORTNAME; ?>.
			</p>
			<p>
				BRAEWORKS makes no representations nor warrantees as to the accuracy of any information on this web site.
				The <?php echo LM_PROJECT_SHORTNAME; ?> user assumes all risk in the content and use of <?php echo LM_PROJECT_SHORTNAME; ?>.
				No commitment is made to update or correct any information that appears on <?php echo LM_PROJECT_SHORTNAME; ?>.
			</p>
			<p>
				All trademarks belong to their respective owners.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="Compatibility">
				Compatibility
			</a>
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				Basic compatibility testing has been done on available devices and browsers.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				The <?php echo LM_PROJECT_SHORTNAME; ?> detects the type of device being used to display the web pages,
				and is not designed to be administered from tablets or very small devices.
				For more information, please refer to the table below.
				<br>If any errors or suggestions are found, please email <A HREF="mailto:feedback@braeworks.com?Subject=<?php echo rawurlencode(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . ' Compatability'); ?>">Feedback</A>.
			</p>
<?php
		if((is_readable(LM_BROWSER_MATRIX)) &&
			(($mh = fopen(LM_BROWSER_MATRIX,'r')) !== false)) {
			$row = 0; $cols = false; $col_show = false;
?>
			<table class="page_body" style="color: black; background-color: white; border: 2px solid gray;">
				<?php if(Clm::is_browser_html5()) echo '<caption>Browser Compatibility ' . strip_tags(LM_PROJECT_SHORTNAME) . '.</caption>'; ?>
<?php

			while(($data = fgetcsv($mh)) !== false) {
				if($row == 0) {
					if($data[0] != 'Show') continue;
					$col_show = $data; $cols = 0;
					for($i = 1; $i < count($col_show); $i++) if($data[$i] == 'Yes') $cols++;
					$row++;
					continue;
					} // if
?>
<?php		if($data[0] == 'Title') { // title row ?>
				<tr class="page_body">
					<th class="page_body" colspan="<?php echo $cols; ?>" style="text-decoration: underline;">
						<?php echo $data[1]; ?>
					</th>
				</tr>
<?php			} // if
			else {
				if($data[0] == 'No') continue;	// row not shown
?>
				<tr class="<?php echo (($row & 1) ? 'page_body_odd':'page_body_even'); ?>">
<?php
				for($i = 1; $i < count($data); $i++) {
					if($col_show[$i] != 'Yes') continue;
					if($data[0] == 'Header') { // header row
?>
					<th class="page_body"><?php echo $data[$i]; ?></th>
<?php					} // if
					else {
?>
					<td class="page_body"><?php echo $data[$i]; ?></td>
<?php					} // else
					} // for
?>
				</tr>
<?php			} // else
?>
<?php
				$row++;
				} // while
			fclose($mh);
?>
			</table>
<?php			} // if
		else echo 'span class="msg_warning">ERROR: File "' . basename (LM_BROWSER_MATRIX) . '" not found.</span>';
?>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="MoreInfo"></a>
			User Manual, Release Information and Feedback
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				<A HREF="index.php?action=lm_manual">User Manual</A>.
			</p>
			<p class="page_body">
				<A HREF="releasenotes.txt">Release Notes</A>.
			</p>
			<p class="page_body">
				<A HREF="installation.txt">Installation Notes</A>.
			</p>
			<p class="page_body">
				Hints, corrections and suggestions are always welcome.
				Email <A HREF="mailto:feedback@braeworks.com?Subject=<?php echo rawurlencode(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION); ?>">Feedback</A>.
			</p>
		</td>
	</tr>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
