<?php
	// $Id: edit_install.php 359 2016-04-16 19:18:52Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$lm_install_id = 0;
$lm_install_op = '';
if($action == 'edit_install') { // a bit of caution
	if((isset($_POST['save'])) && (isset($_POST['common_install'])) && (is_array($_POST['common_install']))) {
		Clm::reset_xml_stitemap();
		$install = $_POST['common_install'];
		Clm::save_ini_settings($install);
		unset($_POST['save']);
		unset($_POST['common_install']);
		} // if
	else if((isset($_POST['reloadINI'])) && ($_POST['reloadINI'] == 'reloadINI')) {
		Clm::reset_xml_stitemap();
		$settings_default = parse_ini_file(LM_FS_CONFIG_DEFAULT,true);
		$settings = parse_ini_file(LM_FS_CONFIG,true);
		$sections = array('CommonSettings','DataBaseAccess');
		foreach($sections as $sect) {
			if((isset($settings[$sect])) && (is_array($settings[$sect])) &&
				(isset($settings_default[$sect])) && (is_array($settings[$sect]))) {
				$settings[$sect] = $settings_default[$sect];
				} // if
			} // foreach
		if(Clm::save_ini_settings($settings)) {
			Clm::addMsg("Set install to default settings.",'info');
			} // if
		$lm_theme_op = '';
		$lm_theme_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_install_op = 'cancel';
		$lm_install_id = 0;
		} // else if
	else if(isset($_GET['name'])) {
		$lm_install_op = 'scroll';
		$lm_install_id = $_GET['name'];
		} // else if
	} // if
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config" style="text-align: left">

			<?php echo Clm::get_admin_scroll2top_anchor(); ?>

			<h1>Install Configuration</h1>
		</th>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_ini_install" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_install'; ?>">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<button name="save" value="save" type="submit" title="save to <?php echo basename(LM_FS_CONFIG); ?>">Save</button>
			<span class="page_config">to &quot;<?php echo basename(LM_FS_CONFIG); ?>&quot;.</span>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>
	<?php
	$conf = Clm::read_ini_settings(false,array('ThemeSettings'));
	$comments = Clm::read_ini_comments(false,array('ThemeSettings'));
	foreach($comments as $sect_name => $section) { ?>
	<tr class="page_config">
		<td class="page_config">
			<table class="page_config" border="0">
				<tr class="page_config">
					<th class="page_config" style="text-align: left"><h2><?php echo Clm::unmake_hungarion_fmt($sect_name); ?></h2></th>
					<th class="page_config" style="text-align: left" valign="bottom"><?php
						if(!empty($comments[$sect_name]['comment'])) {
							echo $comments[$sect_name]['comment'];
							} // if
						else echo '&nbsp;';
					?></th>
				</tr>
			</table>
		</td>
	</tr>
	<tr class="page_config">
		<td class="page_config">
			<table class="page_config" border="1">
				<tr class="page_config">
					<th class="page_config" width="200"><h3>Name/Key</h3><th>
					<th class="page_config" width="275" style="text-align: left"><h3>Value/Setting</h3><th>
					<th class="page_config"><h3>Comments/Help</h3><th>
				</tr>
		<?php 	$row = 0;
				foreach($section as $key => $value) {
					if($key == 'comment') continue;
		?>
				<tr class="<?php echo (($row & 1) ? 'page_config_odd':'page_config_even'); ?>">
					<td class="page_config">
						<?php echo '<a name="' . $key . '"></a>'; ?>
						<?php echo Clm::make_nice_name($key); ?>:<?php echo (INI_DEBUG_BOOL ? '<br>(INI_' . $key . ')':'');?>
					</td>
					<td class="page_config" style="text-align: left"><?php echo Clm::make_type_input('common_install[' . $sect_name . '][' . $key . ']',$key,(isset($conf[$sect_name][$key]) ? $conf[$sect_name][$key]:'')); ?></td>
					<td class="page_config"><?php echo $value; ?></td>
				</tr>
		<?php		$row++;	} // foreach ?>
			</table>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<?php	} // foreach ?>
	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<button name="save" value="save" type="submit" title="save to <?php echo basename(LM_FS_CONFIG); ?>">Save</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit" title="Cancel changes and reload.">Cancel</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
			&nbsp;&nbsp;
			<button name="reloadINI" value="reloadINI" type="submit" title="Clear and re-initialise default install." onClick="return confirm('Clear and re-initialise default install?\nCAUTION: resets the database filename.')">Defaults</button>
			<a name="DEFAULT_INSTALL_BUTTON"></a>
			<?php	} // if ?>
		</td>
	</tr>
	</form>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>
<?php if($lm_install_op == 'scroll') { ?>
<script type="text/javascript">
	showFoundName("<?php echo $lm_install_id; ?>","<?php echo $_GET['keywords']; ?>");
</script>
<noscript></noscript>
<?php	} // if ?>
<?php Clm::page_end_comment(__FILE__); ?>
