<?php
	// $Id: lm_manual.php 340 2015-04-08 07:27:14Z robert0609 $
	// Copyright BRAEWORKS (R) 2014

?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><?php if(Clm::is_browser_html5()) echo '<caption>' . strip_tags(LM_PROJECT_SHORTNAME) . ' body</caption>'; ?><tr class="page_container"><td class="page_container">
<table class="page_body" style="color: black; background-color: white;">
	<?php if(Clm::is_browser_html5()) echo '<caption>Manual for ' . strip_tags(LM_PROJECT_SHORTNAME) . ' page</caption>'; ?>
	<tr class="page_body">
		<th class="page_body">
			<?php echo Clm::get_admin_scroll2top_anchor(); ?>
			<img src="images/bw_logo.gif" alt="bw_logo" title="<?php echo Clm::$version_str; ?>">
			<h1>Users Manual for BRAEWORKS &reg; <?php echo LM_PROJECT_NAME . ' (' . LM_PROJECT_SHORTNAME . ') ' . LM_PROJECT_VERSION; ?></h1>
		</th>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="Contents"></a>
			Contents
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<ul>
				<li>
					<a href="index.php?action=lm_manual#Introduction">Introduction</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#TechnicalInformation">Technical Information</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#ServerSystemPrerequisite">Server System Prerequisites</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#Installation">Installation and Update</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#WindowLayout">Browser Window Layout</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#SetupConfiguration">Setup and Configuration</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#ImportExport">Exporting and Importing CSV Files</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#Localtools">Local Tools</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#Sitemap">Sitemap</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#SVN">File Version Control</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#TroubleShooting">Trouble Shooting</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#License">License</a>
				</li>
				<li>
					<a href="index.php?action=lm_manual#MoreInfo">More Information and Feedback</a>
				</li>
			</ul>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="Introduction"></a>
			Introduction
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				This user manual is to aid administrators and managers of the <?php echo LM_PROJECT_SHORTNAME; ?>.<br>
				Supplementary to this manual is the <a href="installation.txt">Installation Notes</a>.
				The <a href="releasenotes.txt">Release Notes</a> list the <?php echo LM_PROJECT_SHORTNAME; ?> change history.
				General information is available in the <a href="index.php?action=about_lm">About <?php echo LM_PROJECT_SHORTNAME; ?></a>.
			</p>
			<p class="page_body">
				The LM has dynamic filtering that finds content matching keywords.
			</p>
			<p class="page_body">
				Also the most recent changes can be shown. The number of changes within a number of days can be configured.
			</p>
			<p class="page_body">
				The LM has an admin search function to aid finding configuration and setup values.
			</p>
			<p class="page_body">
				<strong>NOTE:</strong> The <?php echo LM_PROJECT_SHORTNAME; ?> is not designed to operate inside a frame or iframe.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="TechnicalInformation"></a>
			Technical Information
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				<?php echo LM_PROJECT_SHORTNAME; ?> is based around standard technology.
				Some effort was made to make the code compatible for browsers with CSS2 and HTML4.
				CSS3 and HTML5 is used on compatible browsers.
				PHP 5.3 scripts are used to generate html web pages.
			</p>
			<p class="page_body">
				See <a href="index.php?action=about_cms#Compatibility">Compatibility</a> for browser support information.
			</p>
			<p class="page_body">
				Installation setup is stored in INI files.
				Theme customization is also stored in INI files, and is used to generate CSS style sheets.
				Accompanying installation and theme setting pages are included to make changes.
				The default settings provide an operational <?php echo LM_PROJECT_SHORTNAME; ?>.
			</p>
			<p class="page_body">
				<?php echo LM_PROJECT_SHORTNAME; ?> has a number of WYSIWYG web page editors available.
				The WYSIWYGs included in the <?php echo LM_PROJECT_SHORTNAME; ?> are standard free downloads from there from TinyMCE and CKEditor web sites.
				They are supported by code built into the <?php echo LM_PROJECT_SHORTNAME; ?>.
				There are six to eight (depending on the server) WYSIWYGs available and the WYSIWYG selection is in the Admin -&gt; Config menu.
			</p>
			<p class="page_body">
				Data for users, administrators, managers, groups, page bodies, tools and configuration are stored in an SQLite2 or SQLite3 database.
				SQLite was chosen due to its easy installation (no database setup required) and it is very suitable for small projects.
				Automatic database installation code is provided.
				The SQLite database is initialized when the first web page is generated after installation.
				Providing an empty initialized database with the default configuration settings.
			</p>
			<p class="page_body">
				A basic description of the databases tables used;-
				<ul>
					<li>
						Configuration Table - stores company name, web titles, image control, etc.,
						used in the web pages.
					</li>

					<li>
						Users Table - stores username, login counts, encrypted password, group memberships,
						sort order/priority, enable/disable and administrator enabling.
						New users can be configured to provide their passwords on first login, or the admin can enter the password.
					</li>

					<li>
						Groups Table - stores group, enable/disable, administrator and managers.
					</li>

					<li>
						Sections Table - stores the section information for links.
						Number of columns, sort order/priority, group memberships and enable/disable.
						This table can be <a href="index.php?action=lm_manual#ImportExport">exported and imported as CSV files</a>.
					</li>

					<li>
						Links Table - stores the link information.
						Each link has a section where it should appear.
						Links have sort order/priority, group memberships, new page and enable/disable.
						This table can be <a href="index.php?action=lm_manual#ImportExport">exported and imported as CSV files</a>.
					</li>

					<li>
						Tools Table - stores the tools information.
						A special directory has been set aside inside the <?php echo LM_PROJECT_SHORTNAME; ?>
						file structure for handy tools, local "hacks" and try outs.
						Tools have sort order/priority, new page and enable/disable.
						Stores tool links , group memberships, sort order/priority and enable/disable.
						The tools appear in left column or in a drop down from the header,
						and are displayed according to the group settings.
					</li>

				</ul>
			</p>
			<p class="page_body">
				Setup and operational features should be self evident.
				All install, setup and configuration settings have accompanying information builtin describing each particular setting.
				The idea was to keep it simple.
				Remove anything that wasn&rsquo;t useful or looked too complicated (i.e. make it easy to customize),
				by providing just the basics.
				The result has been to make use of CSS to remove as much code as possible.
				As a result the code has minimal javascript.
			</p>
			<p class="page_body">
				 <?php echo LM_PROJECT_SHORTNAME; ?> theme settings are numerous and should self evident.
				 <?php echo LM_PROJECT_SHORTNAME; ?> is intended for general small web sites required for the generation of user/owner managed web sites.
				 <?php echo LM_PROJECT_SHORTNAME; ?> can be set to be easily identifiable (due to page headers and footers) so that users know the web site entity.
			</p>
			<p class="page_body">
				<B>NOTE:</B> The <?php echo LM_PROJECT_SHORTNAME; ?> will also work in an aliased folder.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="ServerSystemPrerequisite"></a>
			Server System Prerequisites
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				<?php echo LM_PROJECT_SHORTNAME; ?> requires the following server requirements to operate;-
				<ul>
					<li>
						Apache Web Server 2.2.x installed on LINUX or MS Windows (other PHP compatible web servers should be suitable),
					</li>

					<li>
						PHP 5.3 with PHP SQLite installed, or PHP 5.4 with php-pecl-sqlite installed,
					</li>

					<li>
						<?php echo LM_PROJECT_SHORTNAME; ?> can be setup as an adjunct to an existing web site, or as a new web site (If a new web site, the apache web server configuration needs to be setup for the new web site.),
					</li>

					<li>
						An SSL certificate, self signed or registered for SSL/https web site encryption,
					</li>

					<li>
						http (port 80) for default home/links page and https (port 443) for login and user designated pages,
					</li>
				</ul>
			</p>
			<p class="page_body">
				To install on Windows, a server bundle like <a href="http://www.wampserver.com/en/#download-wrapper">WAMP</a>
				or <a href="https://www.apachefriends.org/download.html">XAMPP</a> will need to be installed and setup.
				It is also recommended that <a href="http://gnuwin32.sourceforge.net/packages/wget.htm">Wget for Windows</a> be installed also.
				<br><b>NOTE:</b> &quot;xampp-win32-5.5.19-0-VC11-installer.exe&quot; (apache, php, MySQL, etc.) was installed and setup on Windows &reg; 7 Ultimate for development of <?php echo LM_PROJECT_SHORTNAME; ?>.
			</p>
			<p class="page_body">
				To use country checks, the PECL geoip (geoip >= 2.0) is required.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="Installation"></a>
			Installation and Update
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				<b>Note 1:</b> The server set up is beyond the scope of this manual. Some general server side setup information is given here. If help is required, contact your system administrator or tech support.<br>
				<b>Note 2:</b> The actual methods used on a particular server may vary from the steps shown here.<br>
				<b>Note 3:</b> The <?php echo LM_PROJECT_SHORTNAME; ?> zip file does not come with user set files that over writes user settings, if they don&rsquo;t exist the <?php echo LM_PROJECT_SHORTNAME; ?> will generate default files.
			</p>
			<p class="page_body">
				For full user and administration experience use one of the following PC browsers on a desktop or laptop PC;-
				<ul>
					<li>
						Windows Internet Explore V11 or higher,
					</li>

					<li>
						Firefox V31 or higher on Windows, LINUX or Apple MAC,
					</li>
				</ul>
			Other <a href="index.php?action=about_cms#Compatibility">web browser have been tested</a>.
			</p>
			<p class="page_body">
				A guide to installing and updating <?php echo LM_PROJECT_SHORTNAME; ?> follows;-
				<ul>
					<li>
						If updating the <?php echo LM_PROJECT_SHORTNAME; ?>, backup the web site.
					</li>

					<li>
						<a href="http://www.braeworks.org/download/LM/BW-LM-latest.zip">Download the <?php echo LM_PROJECT_SHORTNAME; ?> zip file</a> &quot;BW-LM-latest.zip&quot; to the web site&rsquo;s directory.
					</li>

					<li>
						Unzip the &quot;BW-LM-latest.zip&quot; with the overwrite and update options turned on into your web sites directory.<br>
						e.g. unzip -u -o &quot;BW-LM-latest.zip&quot;<br>
						&nbsp;&nbsp;where (-u = update, -o = overwrite)<br>
						This will unzip the <?php echo LM_PROJECT_SHORTNAME; ?> file structure into the
						containing (the web site&rsquo;s) directory.<br>
						If you wish to restore <?php echo LM_PROJECT_SHORTNAME; ?> to it&rsquo;s default file structure contents, leave the update option off. And then run Rebuild Setup, see below.<br>
						e.g. unzip -o &quot;BW-LM-latest.zip&quot;<br>
						<b>NOTE:</b> This does not change existing settings, but will remove any code changes made outside of the release.
					</li>

					<li>
						Pointer your browser at	&quot;http://your.web.site/site_alias/index.php&quot; (site_alias/ is part of your server setup, usually empty).<br>
						When the <?php echo LM_PROJECT_SHORTNAME; ?> is first accessed, it will create an empty SQLite database and rebuild all the CSS stylesheets.<br>
						After approximately 20 seconds and went well, the first run web site looks like this;-<br>
						<img class="manual" src="images/manual/lm_first_run.gif" alt="First run" /><br>
						<b>NOTE:</b> The filename of the log includes the domain name of the web site.<br>
						On an update the appearance will be different.
						Run the &quot;Admin->Rebuild Setup&quot; to rebuild the web site.
					</li>

					<li>
						Click the User: Login link. On a fresh install you see this;-<br>
						<img class="manual" src="images/manual/lm_first_login.gif" alt="First login" /><br>
						On an update the appearance maybe different.
					</li>

					<li>
						When no users are setup, a default admin user is;-<br>
						Username: admin<br>
						Paswword: password<br>
						Strongly recommend the admin username be disabled after you have setup another, more secure, user (with admin rights).<br>
						Login to the web site. On a fresh install you see this;-<br>
						<img class="manual" src="images/manual/lm_admin_empty.gif" alt="Admin empty" /><br>
						On an update the appearance maybe different.
					</li>

					<li>
						Suggest going to the <a href="index.php?action=lm_manual#SetupConfiguration">Setup and Configuration</a> section.
					</li>

				</ul>
			</p>
			<p class="page_body">
				If failures and non functional issues occur, <a href="index.php?action=lm_manual#TroubleShooting"> see Trouble shooting</a>
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="WindowLayout"></a>
			Browser Window Layout
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				There is an overall web site style settings (part of the Theme settings);
				<ul>
					<li>
						Block Style - uses absolute positioning in the browser&rsquo;s window. The sections and links scrolls between fixed positions of the header and the footer. The tool links and admin links also have fixed positions in the browser&rsquo;s window. The browser&rsquo;s window is more easily navigable.
					</li>
					<li>
						Inline Style - uses inline/relative positioning in the browser&rsquo;s window. Scrolls the header, tool links, admin link, sections and links and footer as one entity. This can make the separate areas of the browser window difficult to navigate to.
						Where the browser cannot be identified or compatibility issues are known, the <?php echo LM_PROJECT_SHORTNAME; ?> will use inline style.
					</li>
				</ul>
			</p>
			<p class="page_body">
				The general arrangement of the <?php echo LM_PROJECT_SHORTNAME; ?> in block mode is;-
				<ul>
					<li>
						Header - top section of the window.
						This can be the standard web page header from the <?php echo LM_PROJECT_SHORTNAME; ?> which contains standard features.
						The standard features can be configured by the administer.
						Or the entire header can be replaced with a customer header.
						Or the header can be turned off.
						If the left column is turned off, drop boxes are used to display tool and administration links.
					</li>

					<li>
						Left Column -  when enabled and displayed, occupies the left side of the window between the header and footer.
						The left column displays tool links and administration links.
						If no tools are setup and no user is logged in, the left column is not displayed.
						The left column can be turned off, then other means are used to display tool administration link, in the header.
					</li>

					<li>
						Sections and Links Body -  occupies the remaining window area.
						This the window area that displays the sections and links as configured by the administer / manager.
					</li>

					<li>
						Footer - bottom section of the window.
						This can be the standard web page footer from the <?php echo LM_PROJECT_SHORTNAME; ?> which contains standard features.
						The standard features can be configured by the administer.
						Or the entire footer can be replaced with a customer header.
						Or the footer can be turned off.
					</li>
			</ul>
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="SetupConfiguration"></a>
			Setup and Configuration
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">Use a recommended administration web browser.</p>
			<p class="page_body">
				After logging into the <?php echo LM_PROJECT_SHORTNAME; ?>,
				an &quot;Admin&quot; menu in the left column (default),
				in the header (as a drop down),
				depending on any previous settings, will appear.
				The contents of the &quot;Admin&quot; menu are self explanatory, having tooltips (i.e. small pop up boxes with explanatory text) for each link.
			</p>
			<p class="page_body">
				After installation or update, the following guide is useful;-
				<ul>
					<li>
						Suggest checking out the &quot;Admin&quot; links to get a feel for the available settings.
					</li>
					<li>
						If looking for a possible setting, try the &quot;Admin-&gt;Search&quot; link.
					</li>
				</ul>
			</p>
			<p class="page_body">
				To further the general control and operation of the web site, the following maybe useful;-
				<ul>
					<li>
						Web site administrators can redirect the web site to another URL.
						Administrator can still login (using the &quot;http://your.web.site/site_alias/login.php&quot; URI) and administrator the site.
					</li>
					<li>
						Web site administrators can close the web site.
						Administrator can still login (using the &quot;http://your.web.site/site_alias/login.php&quot; URI) and administrator the site.
					</li>
				</ul>
			</p>
		</td>
	</tr>

	<tr class="page_body">
		<th class="page_body">
			<a name="ImportExport"></a>
			Exporting and Importing CSV Files
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				The Sections and Links tables in the database can be downloaded (exported) as CSV file.
				And saved to the local computer so that the contents can be edited by a spreadsheet program.
			</p>
			<p class="page_body">
				The CSV files use the tab character as the column separator.
				The first line of the CSV file is the databases table column (column headers) names.
				The the import table column names and order of the column names must match the export table csv.
			</p>
			<p class="page_body">
				The sections table CSV file uses <?php echo implode(',',  Clm_export::get_section_colnames()); ?>
				as the header, which is always the first line. The <?php echo implode(', ',  Clm_export::get_section_index()); ?> column is regarded as unique and is the index to the table.
				If imports are done from a CSV file that has multiple rows with the same <?php echo implode(', ',  Clm_export::get_section_index()); ?> value, the last one is used.
			</p>
				<?php if(is_readable(LM_FS_EXPORT_DIR . 'lm_sections.csv')) { ?>
			<p class="page_body">
				The sections export the  <?php echo LM_FS_EXPORT_DIR . 'lm_sections.csv'; ?> file in the server filesystem.
				And is available at <a href="<?php echo str_replace(LM_FS_BASE_DIR, '', LM_FS_EXPORT_DIR . 'lm_sections.csv'); ?>">lm_sections.csv</a>
			</p>
				<?php	} // if ?>
				<?php if(is_readable(LM_FS_IMPORT_DIR . 'lm_sections.csv')) { ?>
			<p class="page_body">
				The sections import the <?php echo LM_FS_IMPORT_DIR . 'lm_sections.csv'; ?> file in the server filesystem.
				And is available at <a href="<?php echo str_replace(LM_FS_BASE_DIR, '', LM_FS_IMPORT_DIR . 'lm_sections.csv'); ?>">lm_sections.csv</a>
			</p>
				<?php	} // if ?>
			<p class="page_body">
				Similar to the sections table, the links table which has a CSV file that uses <?php echo implode(', ',  Clm_export::get_link_colnames()); ?>
				as the header, which is always the first line. The <?php echo implode(', ',  Clm_export::get_link_index()); ?> columns are regarded as unique and are the index to the table.
				If imports are done from a CSV file that has multiple rows with the same <?php echo implode(', ',  Clm_export::get_link_index()); ?> value, the last one is used.
			</p>
				<?php if(is_readable(LM_FS_EXPORT_DIR . 'lm_links.csv')) { ?>
			<p class="page_body">
				The links export use the <?php echo LM_FS_EXPORT_DIR . 'lm_links.csv'; ?> file in the server filesystem.
				And is available at <a href="<?php echo str_replace(LM_FS_BASE_DIR, '', LM_FS_EXPORT_DIR . 'lm_links.csv'); ?>">lm_links.csv</a>
			</p>
				<?php	} // if ?>
				<?php if(is_readable(LM_FS_IMPORT_DIR . 'lm_links.csv')) { ?>
			<p class="page_body">
				The links import use the <?php echo LM_FS_IMPORT_DIR . 'lm_links.csv'; ?> file in the server filesystem.
				And is available at <a href="<?php echo str_replace(LM_FS_BASE_DIR, '', LM_FS_IMPORT_DIR . 'lm_links.csv'); ?>">lm_links.csv</a>
			</p>
				<?php	} // if ?>
		</td>
	</tr>


	<tr class="page_body">
		<th class="page_body">
			<a name="Localtools"></a>
			Local Tools
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				The <?php echo LM_PROJECT_SHORTNAME; ?> has a local tools directory at &quot;./<?php echo LM_LOCAL_TOOLS_FOLDER; ?>&quot;, for the installation of web based tools and extras.
				The local tools folder provides somewhere to put web applications / pages (tools).
				Each tool should be given a unique directory to occupy.
				Examples of tools are;- conversion tables, code checkers, procedures, manuals, just to name a few.
			</p>
			<p>
				If you have tools installed on the host that are not under the &quot;./<?php echo LM_LOCAL_TOOLS_FOLDER; ?>&quot; directory,
				these tools can be accessed by using a symlink.
				This allows these non-local tools to be appear in the Local Tools setup.
				<br><br>
				<b><u>Symlinked Local Tools EXAMPLES:</u></b><br>
				<b>On LINUX</b>, to setup HTdig, make a symlink by going to the &quot;./<?php echo LM_LOCAL_TOOLS_FOLDER; ?>&quot; directory,
				and execute &quot;ln -s /usr/share/htdig htdig&quot;,
				where &quot;/usr/share/htdig&quot; is the path to the HTdig web pages.
				This allows HTdig to be used as the Local Tool.
				<br>
				A similar tool setup can used for the Apache Manual.
				Execute &quot;ln -s /var/www/manual ApacheManual&quot; in the &quot;./<?php echo LM_LOCAL_TOOLS_FOLDER; ?>&quot; directory,
				where &quot;/var/www/manual&quot; is the path to the Apache Manual web pages.
				<br>
				<b>On Windows</b>, a similar symlink can be set by using the mklink command.
				Execute &quot;mklink /D ApacheManual C:\\xampp\apache\manual&quot; in the &quot;./<?php echo LM_LOCAL_TOOLS_FOLDER; ?>&quot; directory,
				where &quot;C:\\xampp\apache\manual&quot; is the path to the Apache Manual web pages.
				<br>
				NOTE: Windows may not have the &quot;mklink&quot; command installed.
				If not contact your system administrator.
			</p>
			<p>
				During tool setup, the &quot;./<?php echo LM_LOCAL_TOOLS_FOLDER; ?>&quot; directory is searched for filename extensions of .htm .php .html and .txt
				The tool could be a complete sub-web site.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="Sitemap"></a>
			Sitemap
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				The <?php echo LM_PROJECT_SHORTNAME; ?> has a search engine compatible XML sitemap generator builtin.
				As changes are made to configuration and contents of the web site, the sitemap is automatically updated.
				To manually update the sitemap goto &quot;http://your.web.site/site_alias/index.php?action=update_sitemap&quot;.
				<br>
				NOTE: If the sitemap filename is not setup, no sitemap XML is generated.
			</p>
			<p class="page_body">
				The XML sitemap is available at &quot;http://your.web.site/site_alias/<?php echo INI_XML_SITEMAP_FILE; ?>.xml&quot; (replace &quot;your.web.site/site_alias/&quot; with your domain name and alias, if any, for <?php echo LM_PROJECT_SHORTNAME; ?> installation).
				<br>
				NOTE: The name of the sitemap can be configured in the &quot;Admin-&gt;Install-&gt;Xml Sitemap File&quot; setting.
				The primary link URL in the sitemap is the same URL in &quot;Admin-&gt;Config-&gt;Main Web Site URL&quot; setting.
			</p>
			<p class="page_body">
				The sitemap can be generated from the command line.
				<ul>
					<li>On a LINUX server, in a console shell, goto the web site&rsquo;s cli/ directory and run "./generate_sitemap.sh".</li>
					<li>On a Windows host, in a command shell, goto the web site&rsquo;s cli/ folder and run "generate_sitemap.cmd".</li>
				</ul>
					Successful sitemap generation looks like this;-

				<pre style="font-family: 'Times New Roman',yahoma;">
					Starting -> sitemap generator for <?php echo LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION; ?>.
					INFO: Created sitemap "/web-site-root-directory/<?php echo INI_XML_SITEMAP_FILE; ?>.xml" (Link=sitemap.xml)
					Finished -> sitemap generator for <?php echo LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION; ?>.
				</pre>
					Where sitemap name is set to &quot;sitemap&quot;.<br>
					If any errors or warnings occurred, these will be printed out.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="TroubleShooting"></a>
			Trouble Shooting
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				The <?php echo LM_PROJECT_SHORTNAME; ?> has installation and updating trouble shooting functions built-in.
				<br><b>NOTE:</b> This does not change existing settings, but will remove any code changes made outside of the release.
			</p>
			<p class="page_body">
				If the web site is basically functional,
				logging in as an administrator and
				going to the &quot;http://your.web.site/site_alias/index.php?action=rebuild_setup&quot; link will rebuild the web site settings.
				This can take a minute or so to complete.
			</p>
			<p class="page_body">
				If after an update or other problems, the web site is non functional, there is a recovery command available to help fix this.
				<ul>
					<li>On a LINUX server, in a console shell, goto the web site&rsquo;s cli/ directory and run "./rebuild.sh".</li>
					<li>On a Windows host, in a command shell, goto the web site&rsquo;s cli/ folder and run "rebuild.cmd".</li>
				</ul>
					Successful rebuild output looks like this;-

				<pre style="font-family: 'Times New Roman',yahoma;">
					Starting -> rebuilding setup for <?php echo LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION; ?>.
					INFO: Installation check.
					INFO: No install issues detected.
					INFO: Checking <?php echo LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION; ?> database for updates.
					INFO: Checking table lm_users
					INFO: Checking table lm_groups
					INFO: Checking table lm_configs
					INFO: Checking table lm_sections
					INFO: Checking table lm_links
					INFO: Checking table lm_tools
					SUCCESS: Checked links_manager.sqlite tables - success
					SUCCESS: Update main_styles.css
					SUCCESS: Update block_styles.css
					SUCCESS: Update inline_styles.css
					INFO: DB updated to <?php echo LM_PROJECT_VERSION; ?>.
					Finished -> rebuilding setup for <?php echo LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION; ?>.
				</pre>
					If any errors or warnings occurred, these will be printed out.
			</p>
			<p class="page_body">
				A basic installation guide is available in the <A HREF="installation.txt">Installation Notes</A>.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="SVN"></a>
			File Version Control
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				When a manager or administrator are logged in, the <?php echo LM_PROJECT_SHORTNAME; ?> can use &quot;Subversion&quot; (SVN), if available, to aid in administration and checking of the site.
				Hovering the mouse over the BRAEWORKS logo in the about or manual pages shows the current SVN version status of the website.
				This reports the lowest and highest SVN revision number of the web site.
				The revision numbers can used to identify changes.
			</p>
			<p class="page_body">
				To use the SVN features, the system administrator will need to install the PECL SVN package.
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="License"></a>
			License
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				GNU General Public License, version 2. See "http://www.gnu.org/licenses/gpl-2.0.html"
			</p>
		</td>
	</tr>
	<tr class="page_body">
		<th class="page_body">
			<a name="MoreInfo"></a>
			More Information and Feedback
		</th>
	</tr>
	<tr class="page_body">
		<td class="page_body">
			<p class="page_body">
				<A HREF="releasenotes.txt">Release Notes</A>.
			</p>
			<p class="page_body">
				Hints, corrections and suggestions are always welcome.
				Email <A HREF="mailto:feedback@braeworks.com?Subject=<?php echo rawurlencode(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION); ?>">Feedback</A>.
			</p>
		</td>
	</tr>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
