<?php

/**
 * $Id: log_view.php 305 2015-05-18 15:14:07Z robert0609 $
 *
 * Description of log_view
 * general log file vieqer and manager
 *
 * @author robert0609
 */

$log_path = LM_LOGS_DIR;
if((isset($_POST['delete_log_file'])) && (!empty($_POST['delete_log_file']))) {
	$log_file = $_POST['delete_log_file'];
	if(file_exists($log_path . $log_file)) {
		$date = date('Ymd-hms');
		$old_file = preg_replace('/\.log$/i', '.log-' . $date, $log_file);
		if($fh = fopen(LM_FS_TRASH_DIR . $old_file . '.gz','w')) {
			if(fwrite($fh,gzencode(file_get_contents($log_path . $log_file), 9)) !== false) {
				unlink($log_path . $log_file);
				} // if
			fclose($fh);
			} // if
		else rename($log_path . $log_file, LM_FS_TRASH_DIR . $old_file);
		if(isset($_POST['view_log_file'])) unset($_POST['view_log_file']);
		Clm::addMsg('Moved &quot;' . $log_file . '&quot; to Trash.','info');
		} // if
	} // if

// $_POST['download_log_file'] done in app_top.php

$view_log_file = '';
if(isset($_GET['view_log_file'])) $view_log_file = $_GET['view_log_file'];
else if(isset($_POST['view_log_file'])) $view_log_file = $_POST['view_log_file'];

$lines_max = 100;
if(isset($_POST['lines_max'])) $lines_max = $_POST['lines_max'];
if($lines_max > 1000) $lines_max = 1000;

$line_start = 1;
if(isset($_POST['next'])) $line_start += $lines_max;
else if(isset($_POST['prev'])) $line_start -= $lines_max;
if($line_start < 1) $line_start = 1;
$line_end = $line_start + $lines_max - 1;

$log_files = array();
if($dh = opendir($log_path)) { // check log file location
	while (($file = readdir($dh)) !== false) {
		if(is_dir($file)) continue;
		if(!preg_match('/\.log$/i', $file)) continue;
		if(!$fd = fopen($log_path . $file, 'r')) continue;
		$stat = fstat($fd);
		$groupinfo = posix_getgrgid($stat['gid']);	// needs php-posix or php-process installed
		$userinfo = posix_getpwuid($stat['uid']);	// needs php-posix or php-process installed

		// make mode string
		$mode = '';
		// msb (left) side first
		$mode .= (($stat['mode'] & 512) ? 'S':' ');
		$mode .= (($stat['mode'] & 256) ? 'r':'-');
		$mode .= (($stat['mode'] & 128) ? 'w':'-');
		$mode .= (($stat['mode'] & 64) ? 'x':'-');
		$mode .= (($stat['mode'] & 32) ? 'r':'-');
		$mode .= (($stat['mode'] & 16) ? 'w':'-');
		$mode .= (($stat['mode'] & 8) ? 'x':'-');
		$mode .= (($stat['mode'] & 4) ? 'r':'-');
		$mode .= (($stat['mode'] & 2) ? 'w':'-');
		$mode .= (($stat['mode'] & 1) ? 'x':'-');
		// lsb (right) side last

		$log_files[$file] = array(
			'name' => $file,
			'size' => $stat['size'],
			'mtime' => date(DATE_RSS, $stat['mtime']),
			'mode' => $mode,	// sprintf('%0o',$stat['mode']),
			'uid' => $stat['uid'],
			'gid' => $stat['gid'],
			'user' => (isset($userinfo['name']) ? $userinfo['name']:$stat['uid']),
			'group' => (isset($groupinfo['name']) ? $groupinfo['name']:$stat['gid']),
			);
		fclose($fd);
		} // while
	closedir($dh);
	ksort($log_files);
	} // if
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config" style="text-align: left;" title="Log directory: <?php echo $log_path; ?>">
			<h1>View Log Files</h1>
		</th>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<tr class="page_config">
		<td class="page_config" style="text-align: left;">
<?php
		if(!empty($log_files)) {
?>
			<table class="page_config">
				<tr class="page_config">
					<th class="page_config" style="text-align: left;" title="The file read, write , execute modes for user, group and others.">Mode</th>
					<th class="page_config" style="text-align: left;" title="The user associated with the file.">User</th>
					<th class="page_config" style="text-align: left;" title="The group associated with the file.">Group</th>
					<th class="page_config" style="text-align: left;" title="Size of file in bytes.">Size</th>
					<th class="page_config" style="text-align: left;" title="Last time the file was modified.">Modified</th>
					<th class="page_config" style="text-align: left;" title="Log filename.\nNames starting with CLI are generated by comman line operations (CLI),\nothers start with the domain name used.">Name</th>
					<th class="page_config" style="text-align: center;" title="Actions on files.">Actions</th>
				</tr>
				<form name="view_lof_file" action="index.php?action=log_view" method="post" enctype="multipart/form-data">
					<input type="hidden" name="view_log_file" value="<?php echo urlencode($view_log_file); ?>"/>
					<input type="hidden" name="start_line" value="<?php echo $line_start; ?>"/>
<?php
				$row = 0;
				foreach($log_files as $f => $d) {
?>
				<tr class="<?php echo (($row++ & 1) ? 'page_config_odd':'page_config_even') ?>">
					<td class="page_config" style="text-align: left;"><?php echo $d['mode']; ?></td>
					<td class="page_config" style="text-align: left;"><?php echo $d['user']; ?></td>
					<td class="page_config" style="text-align: left;"><?php echo $d['group']; ?></td>
					<td class="page_config" style="text-align: left;"><?php echo $d['size']; ?></td>
					<td class="page_config" style="text-align: left;"><?php echo $d['mtime']; ?></td>
					<td class="page_config" style="text-align: left;"><?php echo $d['name']; ?></td>
					<td class="page_config" style="text-align: center;">
						<button type="submit" name="view_log_file" value="<?php echo urlencode($d['name']); ?>" title="Click to view file &quot;<?php echo urlencode($d['name']); ?>&quot;.">View</button>
						&nbsp;
						<button type="submit" name="download_log_file" value="<?php echo urlencode($d['name']); ?>" title="Click to download file &quot;<?php echo urlencode($d['name']); ?>&quot.">Download</button>
						&nbsp;
						<button type="submit" name="delete_log_file" value="<?php echo urlencode($d['name']); ?>" onclick="return confirm('Move file &quot;<?php echo urlencode($d['name']); ?>&quot; to Trash.');" title="Click to move file &quot;<?php echo urlencode($d['name']); ?>&quot; to Trash.">Delete</button>
					</td>
				</tr>
<?php
				} // foreach
?>
				</form>
			</table>
<?php
			} // if
		else echo 'No log file found.'
?>
		</td>
	</tr>
<?php if((!empty($view_log_file)) && (is_readable($log_path . $view_log_file))) { ?>
<form name="view_lof_file" action="index.php?action=log_view" method="post" enctype="multipart/form-data">
	<input type="hidden" name="view_log_file" value="<?php echo urlencode($view_log_file); ?>"/>
	<input type="hidden" name="start_line" value="<?php echo $line_start; ?>"/>
	<tr class="page_config">
		<td class="page_config">
			<input type="text" name="lines_max" value="<?php echo $lines_max; ?>" size="4"/> lines.
<?php	if($line_start > 1) { ?>
			<button type="submit" name="prev" value="prev" title="Click for previous page.">Previous</button>
<?php		} // if ?>
<?php	if(((isset($_POST['last_line_num'])) &&
			((int)$_POST['last_line_num'] > $line_end)) ||
			(!isset($_POST['last_line_num']))) { ?>
			<button type="submit" name="next" value="next" title="Click for next page.">Next</button>
<?php		} // if ?>
		</td>
	</tr>
	<tr class="page_config">
		<td class="page_config">
			<table class="page_config">
				<tr class="page_config" title="From log directory: <?php echo $log_path. ' (' . $lines_max . ' lines maximum)'; ?>">
					<th class="page_config" style="text-align: center;">Line</th>
					<th class="page_config" style="text-align: left;"><?php echo $view_log_file; ?></th>
				</tr>
<?php
		$fh = fopen($log_path . $view_log_file, "r");
		$line_num = 0;
		if($fh) {
			$row = 0;
			while (($line = fgets($fh, 4096)) !== false) {
				$line_num++;
				if($line_start > $line_num) continue;	// find start line
				if($line_num > $line_end) break;	// thats it
?>
				<tr class="<?php echo (($row++ & 1) ? 'page_config_odd':'page_config_even') ?>">
					<td class="page_config" style="text-align: center;"><?php echo $line_num; ?></td>
					<td class="page_config" style="text-align: left;"><?php echo htmlentities($line); ?></td>
				</tr>
<?php
				} // while
			fclose($fh);
			if($line_num == 0) {
?>
				<tr class="page_config">
					<td class="page_config" style="text-align: center;"><?php echo $line_num; ?></td>
					<td class="page_config" style="text-align: left;">File is empty.</td>
				</tr>
<?php
				} // if
			} // if
?>
			</table>
		</td>
	</tr>
	<input type="hidden" name="last_line_num" value="<?php echo $line_num; ?>"/>
	<tr class="page_config">
		<td class="page_config">
<?php	if($line_start > 1) { ?>
			<button type="submit" name="prev" value="prev" title="Click for previous page.">Previous</button>
<?php		} // if ?>
<?php	if($line_num > $line_end) { ?>
			<button type="submit" name="next" value="next" title="Click for next page.">Next</button>
<?php		} // if ?>
		</td>
	</tr>
</form>
<?php	} // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>

